                                  _   _ ____  _
                              ___| | | |  _ \| |
                             / __| | | | |_) | |
                            | (__| |_| |  _ <| |___
                             \___|\___/|_| \_\_____|

                                  Changelog

Version 8.4.0 (11 Oct 2023)

Daniel Stenberg (11 Oct 2023)

- RELEASE-NOTES: synced

- THANKS: add contributors from 8.4.0

Jay Satiro (11 Oct 2023)

- socks: return error if hostname too long for remote resolve

  Prior to this change the state machine attempted to change the remote
  resolve to a local resolve if the hostname was longer than 255
  characters. Unfortunately that did not work as intended and caused a
  security issue.

  Bug: https://curl.se/docs/CVE-2023-38545.html

Stefan Eissing (10 Oct 2023)

- CI: remove slowed-network tests

  - remove these tests as they are currently not reliable in our CI
    setups.

  curl handles the test cases, but CI sometimes fails on these due to
  additional conditions. Rather than mix them in, an additional CI job
  will be added in the future that is specific to them.

  Closes https://github.com/curl/curl/pull/12075

Jay Satiro (10 Oct 2023)

- libcurl-env-dbg.3: move debug variables from libcurl-env.3

  - Move documentation of libcurl environment variables used only in debug
    builds from libcurl-env into a separate document libcurl-env-dbg.

  - Document more debug environment variables.

  Previously undocumented or missing a description:

  CURL_ALTSVC_HTTP, CURL_DBG_SOCK_WBLOCK, CURL_DBG_SOCK_WPARTIAL,
  CURL_DBG_QUIC_WBLOCK, CURL_DEBUG, CURL_DEBUG_SIZE, CURL_GETHOSTNAME,
  CURL_HSTS_HTTP, CURL_FORCETIME, CURL_SMALLREQSEND, CURL_SMALLSENDS,
  CURL_TIME.

  Closes https://github.com/curl/curl/pull/11811

Dan Fandrich (9 Oct 2023)

- test670: increase the test timeout

  This should make it more immune to loaded servers.

  Ref: #11328

Stefan Eissing (9 Oct 2023)

- MQTT: improve receive of ACKs

  - add `mq->recvbuf` to provide buffering of incomplete
    ACK responses
  - continue ACK reading until sufficient bytes available
  - fixes test failures on low network receives

  Closes #12071

Viktor Szakats (9 Oct 2023)

- quic: fix BoringSSL build

  Add guard around `SSL_CTX_set_ciphersuites()` use.

  Bug: https://github.com/curl/curl/pull/12065#issuecomment-1752171885

  Follow-up to aa9a6a177017e4b74d33cdf85a3594900f4a7f81

  Co-authored-by: Jay Satiro
  Reviewed-by: Daniel Stenberg
  Closes #12067

Stefan Eissing (9 Oct 2023)

- test1540: improve reliability

  - print that bytes have been received on pausing, but not how many

  Closes #12069

- test2302: improve reliability

  - make result print collected write data, unless
    change in meta flags is detected
  - will show same result even when data arrives via
    several writecb invocations

  Closes #12068

Daniel Stenberg (9 Oct 2023)

- curl_easy_pause: set "in callback" true on exit if true

  Because it might have called another callback in the mean time that then
  set the bit FALSE on exit.

  Reported-by: Jay Satiro
  Fixes #12059
  Closes #12061

Viktor Szakats (8 Oct 2023)

- h3: add support for ngtcp2 with AWS-LC builds

  ```
  curl 8.4.0-DEV (x86_64-apple-darwin) libcurl/8.4.0-DEV (SecureTransport) AWS-
  LC/1.15.0 nghttp2/1.56.0 ngtcp2/0.19.1 nghttp3/0.15.0
  Release-Date: [unreleased]
  Protocols: dict file ftp ftps gopher gophers http https imap imaps ldap ldaps
   mqtt pop3 pop3s rtsp smb smbs smtp smtps telnet tftp ws wss
  Features: alt-svc AsynchDNS HSTS HTTP2 HTTP3 HTTPS-proxy IPv6 Largefile Multi
  SSL NTLM SSL threadsafe UnixSockets
  ```

  Also delete an obsolete GnuTLS TODO and update the header comment in
  `FindNGTCP2.cmake`.

  Reviewed-by: Daniel Stenberg
  Closes #12066

- build: do not publish `HAVE_BORINGSSL`, `HAVE_AWSLC` macros

  Syncing this up with CMake.

  Source code uses the built-in `OPENSSL_IS_AWSLC` and
  `OPENSSL_IS_BORINSSL` macros to detect BoringSSL and AWS-LC. No help is
  necessary from the build tools.

  The one use of `HAVE_BORINGSSL` in the source turned out to be no longer
  necessary for warning-free BoringSSL + Schannel builds. Ref: #1610 #2634

  autotools detects this anyway for display purposes.
  CMake detects this to decide whether to use the BoringSSL-specific
  crypto lib with ngtcp2. It detects AWS-LC, but doesn't use the detection
  result just yet (planned in #12066).

  Ref: #11964

  Reviewed-by: Daniel Stenberg
  Reviewed-by: Jay Satiro
  Closes #12065

Marc Hoersken (8 Oct 2023)

- CI: move distcheck job from Azure Pipelines to GitHub Actions

  This will allow for more trigger excludes within Azure Pipelines.

  Also fixes seemingly broken check with scripts/installcheck.sh.
  Ref: 190374c74ec4e5247d9066544c86e8d095e1d7b5

  Assisted-by: Philip Heiduck
  Closes #9532

Daniel Stenberg (8 Oct 2023)

- url: fall back to http/https proxy env-variable if ws/wss not set

  Reported-by: Craig Andrews
  Fixes #12031
  Closes #12058

Stefan Eissing (8 Oct 2023)

- cf-socket: simulate slow/blocked receives in debug

  add 2 env variables for non-UDP sockets:
  1. CURL_DBG_SOCK_RBLOCK: percentage of receive calls that randomly
     should return EAGAIN
  2. CURL_DBG_SOCK_RMAX: max amount of bytes read from socket

  Closes #12035

- http2: refused stream handling for retry

  - answer HTTP/2 streams refused via a GOAWAY from the server to
    respond with CURLE_RECV_ERROR in order to trigger a retry
    on another connection

  Reported-by: black-desk on github
  Ref #11859
  Closes #12054

Jay Satiro (8 Oct 2023)

- CURLOPT_DEBUGFUNCTION.3: warn about internal handles

  - Warn that the user's debug callback may be called with the handle
    parameter set to an internal handle.

  Without this warning the user may assume that the only handles their
  debug callback receives are the easy handles on which they set
  CURLOPT_DEBUGFUNCTION.

  This is a follow-up to f8cee8cc which changed DoH handles to inherit
  the debug callback function set in the user's easy handle. As a result
  those handles are now passed to the user's debug callback function.

  Closes https://github.com/curl/curl/pull/12034

- url: fix typo

Daniel Stenberg (8 Oct 2023)

- test458: verify --expand-output, expanding a file name accepting option

  Verifies the fix in #12055 (commit f2c8086ff15e6e995e1)

- tool_getparam: accept variable expansion on file names too

  Reported-by: PBudmark on github
  Fixes #12048
  Closes #12055

- RELEASE-NOTES: synced

- multi: do CURLM_CALL_MULTI_PERFORM at two more places

  ... when it does a state transition but there is no particular socket or
  timer activity. This was made apparent when commit b5bb84c removed a
  superfluous timer expiry.

  Reported-by: Dan Fandrich.
  Fixes #12033
  Closes #12056

Viktor Szakats (7 Oct 2023)

- GHA/linux: mbedtls 3.5.0 + minor dep bumps

  Closes #12057

Dan Fandrich (7 Oct 2023)

- CI: bump OpenLDAP package version on FreeBSD

  The old one is no longer available.

Marc Hoersken (7 Oct 2023)

- docs/libcurl/opts/Makefile.inc: add missing manpage files

  Detected with #9532

Dan Fandrich (7 Oct 2023)

- tests: fix a race condition in ftp server disconnect

  If a client disconnected and reconnected quickly, before the ftp server
  had a chance to respond, the protocol message/ack (ping/pong) sequence
  got out of sync, causing messages sent to the old client to be delivered
  to the new.  A disconnect must now be acknowledged and intermediate
  requests thrown out until it is, which ensures that such synchronization
  problems can't occur. This problem could affect ftp, pop3, imap and smtp
  tests.

  Fixes #12002
  Closes #12049

Viktor Szakats (7 Oct 2023)

- appveyor: bump mingw-w64 job to gcc 13 (was: 8)

  This sets gcc 6, 7, 9, 13 in our test mix (was: 6, 7, 8, 9).
  Adding a modern gcc version to the tests.

  (The gcc 8 job used to take around 50 minutes. The new image with gcc 13
  finished in 32, 35, 34 minutes in the 3 test runs so far.)

  It also adds a modern CMake version and OS env to our mingw-w64 builds.

  Closes #12051

David Benjamin (6 Oct 2023)

- openssl: use X509_ALGOR_get0 instead of reaching into X509_ALGOR

  While the struct is still public in OpenSSL, there is a (somewhat
  inconvenient) accessor. Use it to remain compatible if it becomes opaque
  in the future.

  Closes #12038

Daniel Stenberg (6 Oct 2023)

- curl_easy_pause.3: mention it works within callbacks

  Reported-by: Maxim Dzhura
  Bug: https://curl.se/mail/lib-2023-10/0010.html
  Closes #12046

- curl_easy_pause.3: mention h2/h3 buffering

  Asked-by: Maxim Dzhura
  Ref: https://curl.se/mail/lib-2023-10/0011.html

  Closes #12045

Viktor Szakats (6 Oct 2023)

- cmake: re-add missed C89 headers for specific detections

  We removed C89 `setjmp.h` and `signal.h` detections and excluded them
  from the global header list we use when detecting functions [1]. Then
  missed to re-add these headers to the specific functions which need
  them to be detected [2]. Fix this omission in this patch.

  [1] Follow-up to 3795fcde995d96db641ddbcc8a04f9f0f03bef9f #11951
  [2] Follow-up to 96c29900bcec32dd6bc8e9857c8871ff4b8b8ed9 #11940

  Closes #12043

Daniel Stenberg (6 Oct 2023)

- multi: set CURLM_CALL_MULTI_PERFORM after switch to DOING_MORE

  Since there is nothing to wait for there. Avoids the test 1233 hang
  reported in #12033.

  Reported-by: Dan Fandrich
  Closes #12042

Dan Fandrich (5 Oct 2023)

- test1903: actually verify the cookies after the test

  The test otherwise could do just about anything (except leak memory in
  debug mode) and its bad behaviour wouldn't be detected. Now, check the
  resulting cookie file to ensure the cookies are still there.

  Closes #12041

- test: add missing <feature>s

  The tests will otherwise fail if curl has them disabled.

- test1906: set a lower timeout since it's hit on Windows

  msys2 builds actually hit the connect timeout in normal operation, so
  lower the timeout from 5 minutes to 5 seconds to reduce test time.

  Ref: #11328
  Closes #12036

Daniel Stenberg (5 Oct 2023)

- RELEASE-NOTES: synced

Jay Satiro (5 Oct 2023)

- idn: fix WinIDN null ptr deref on bad host

  - Return CURLE_URL_MALFORMAT if IDN hostname cannot be converted from
    UTF-8 to UTF-16.

  Prior to this change a failed conversion erroneously returned CURLE_OK
  which meant 'decoded' pointer (what would normally point to the
  punycode) would not be written to, remain NULL and be dereferenced
  causing an access violation.

  Closes https://github.com/curl/curl/pull/11983

Dan Fandrich (4 Oct 2023)

- tests: close the shell used to start sshd

  This shell isn't needed once sshd starts, so use "exec" so it doesn't
  stick around.

  Closes #12032

Daniel Stenberg (4 Oct 2023)

- base64: also build for curl

  Since the tool itself now uses the base64 code using the curlx way, it
  needs to build also when the tool needs it. Starting now, the tool build
  defines BULDING_CURL to allow lib-side code to use it.

  Follow-up to 2e160c9c6525

  Closes #12010

Eduard Strehlau (4 Oct 2023)

- tests: Fix zombie processes left behind by FTP tests.

  ftpserver.pl correctly cleans up spawned server processes,
  but forgets to wait for the shell used to spawn them.
  This is barely noticeable during a normal testrun,
  but causes process exhaustion and test failure
  during a complete torture run of the FTP tests.

  Fixes #12018
  Closes #12020

Dan Fandrich (4 Oct 2023)

- github/labeler: improve labeler matches

- test574: add a timeout to the test

  This one hangs occasionally, so this will speed up a test run and allow
  logs to be seen when it does.

  Closes #12025

- tests: propagate errors in libtests

  Use the test macros to automatically propagate some errors, and check
  and log others while running the tests. This can help in debugging
  exactly why a test has failed.

- tests: set --expect100-timeout to improve test reliability

  On an overloaded server, the default 1 second timeout can go by without
  the test server having a chance to respond with the expected headers,
  causing tests to fail. Increase the 1 second timeout to 99 seconds so
  this failure mode is no longer a problem on test 1129. Some other tests
  already set a high value, but make them consistently 99 seconds so if
  something goes wrong the test is stalled for less time.

  Ref: #11328

- CI: ignore the "flaky" and "timing-dependent" test results in CMake

  This was already done for automake builds but CMake builds were missed.
  Test 1086 actually causes the test harness to crash with:

  Warning: unable to close filehandle DWRITE properly: Broken pipe at C:/projec
  ts/curl/tests/ftpserver.pl line 527

  Rather than fix it now, this change leaves test 1086 entirely skipped on
  those builds that show this problem.

  Follow-up to 589dca761

  Ref: #11865

Viktor Szakats (4 Oct 2023)

- cmake: improve OpenLDAP builds

  - cmake: detect OpenLDAP based on function `ldap_init_fd`.
    autotools does this. autotools also publishes this detection result
    in `HAVE_LDAP_INIT_FD`. We don't mimic that with CMake as the source
    doesn't use this value. (it might need to be remove-listed in
    `scripts/cmp-config.pl` for future OpenLDAP test builds.)
    This also deletes existing self-declaration method via the
    CMake-specific `CURL_USE_OPENLDAP` configuration.

  - cmake: define `LDAP_DEPRECATED=1` for OpenLDAP.
    Like autotools does. This fixes a long list of these warnings:
    ```
    /usr/local/opt/openldap/include/ldap.h:1049:5: warning: 'LDAP_DEPRECATED' i
  s not defined, evaluates to 0 [-Wundef]
    ```

  - cmake: delete LDAP TODO comment no longer relevant.

  Also:

  - autotools: replace domain name `dummy` with `0.0.0.0` in LDAP feature
    detection functions.

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #12024

- cmake: fix unity builds for more build combinations

  By using unique static function/variable names in source files
  implementing these interfaces.

  - OpenLDAP combined with any SSH backend.

  - MultiSSL with mbedTLS, OpenSSL, wolfSSL, SecureTransport.

  Closes #12027

Daniel Stenberg (4 Oct 2023)

- tests: remove leading spaces from some tags

  The threee tags `<name>`, `</name>` and `<command>` were frequently used
  with a leading space that this removes. The reason this habbit is so
  widespread in testcases is probably that they have been copy and pasted.

  Hence, fixing them all now might curb this practice from now on.

  Closes #12028

Viktor Szakats (4 Oct 2023)

- GHA: bump actions/checkout

  Follow-up to 2e0fa50fc16b9339f51e0a7bfff0352829323acb #11964
  Follow-up to c39585d9b7ef3cbfc1380812dec60e7b275b6af3 #12000

  Closes #12023

- spelling: fix codespell 2.2.6 typos

  Closes #12019

Daniel Stenberg (3 Oct 2023)

- GHA: add workflow to compare configure vs cmake outputs

  Uses scripts/cmp-config.pl two compare two curl_config.h files,
  presumbly generated with configure and cmake. It displays the
  differences and filters out a lot of known lines we ignore.

  The script also shows the matches that were *not* used. Possibly
  subjects for removal.

  Closes #11964

- appveyor: enable test 571

  Follow-up from 8a940fd55c175f7 / #12013

  Closes #12017

Viktor Szakats (3 Oct 2023)

- build: alpha-sort source files for lib and src

  Closes #12014

- cmake: delete old `HAVE_LDAP_URL_PARSE` logic

  Left there by accident after adding proper detection for this.

  Follow-up to 772f0d8edf1c3c2745543f42388ccec5a16ee2c0 #12006

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #12015

Stefan Eissing (3 Oct 2023)

- tests: increase lib571 timeout from 3s to 30s

  - 3s is too short for our CI, making this test fail occasionally
  - test usually experiences no delay run locally, so 30s wont hurt

  Closes #12013

Viktor Szakats (3 Oct 2023)

- cmake: fix unity with Windows Unicode + TrackMemory

  Found the root cause of the startup crash in unity builds with Unicode
  and TrackMemory enabled at the same time.

  We must make sure that the `memdebug.h` header doesn't apply to
  `lib/curl_multibyte.c` (as even noted in a comment there.) In unity
  builds all headers apply to all sources, including `curl_multibyte.c`.
  This probably resulted in an infinite loop on startup.

  Exclude this source from unity compilation with TrackMemory enabled,
  in both libcurl and curl tool. Enable unity mode for a debug Unicode
  CI job to keep it tested. Also delete the earlier workaround that
  fully disabled unity for affected builds.

  Follow-up to d82b080f6374433ce7c98241329189ad2d3976f8 #12005
  Follow-up to 3f8fc25720900b14b7432f4bd93407ca15311719 #11095

  Closes #11928

- cmake: disable unity mode with Windows Unicode + TrackMemory

  "TrackMemory" is `ENABLE_DEBUG=ON` (aka `ENABLE_CURLDEBUG=ON`,
  aka `-DCURLDEBUG`).

  There is an issue with memory tracking and Unicode when built in "unity"
  mode, which results in the curl tool crashing right on startup, even
  without any command-line option. Interestingly this doesn't happen under
  WINE (at least on the system I tested this on), but consistenly happens
  on real Windows machines. Crash is 0xC0000374 heap corruption. Both
  shared and static curl executables are affected.

  This limitation probably won't hit too many people, but it remains
  a TODO to find and fix the root cause and drop this workaround.

  Example builds and runs:
  https://ci.appveyor.com/project/curlorg/curl/builds/48169111/job/17cptxhtpubd
  7iwj#L313 (static)
  https://ci.appveyor.com/project/curlorg/curl/builds/48169111/job/76e1ge758tby
  qu9c#L317 (shared)

  Follow-up to 3f8fc25720900b14b7432f4bd93407ca15311719 #11095

  Ref: #11928
  Closes #12005

- cmake: tidy-up `NOT_NEED_LBER_H` detection

  Follow-up to 772f0d8edf1c3c2745543f42388ccec5a16ee2c0 #12006

- appveyor: rewrite batch in PowerShell + CI improvements

  1. Rewrite in PowerShell:

  - rewrite MS-DOS batch build script in PowerShell.
  - move some bash operations into native PowerShell.
  - fixups for PowerShell insisting on failure when a command outputs
    something to stderr.
  - fix to actually run `curl -V` after every build.
    (and exclude ARM64 builds.)
  - also say why we skipped `curl -V` if we had to skip.
  - fix CMake warnings about unused configuration variables, by adapting
    these dynamically for build cases.
  - dedupe OpenSSL path into a variable.
  - disable `test1451` failing with a warning anyway due to missing python
    impacket. (after trying and failing to install impacket)
    PowerShell promotes these warnings to errors by PowerShell. We can also
    suppress they wholesale if they start causing issues in the future,
    like we already to with `autoreconf` and `./configure`.

  PowerShell is better than MS-DOS batches, so the hope is this makes it
  easier to extend and maintain the AppVeyor build logic. POSIX/bash isn't
  supported inline by AppVeyor on Windows build machines, but we are okay
  to keep it in an external script, so it's also an option.

  2. CI improvements:

  - enable tests for a "unity" build job.
  - speed-up CI initialization by using shallow clones of the curl repo.
  - speed-up CMake MSVC jobs with `TrackFileAccess=false`.
  - enable parallelism in `VisualStudioSolution` builds.
  - display CMake version before builds.
  - always show the CPU in job names.
  - tell which jobs are build-only in job names.
  - move `TESTING:` value next to `DISABLED_TESTS:` in two jobs.
  - add `config.log` (autotools) to dumped logs (need to enable manually).

  3. Style:

  - use single-quotes in YAML like we do in other CI YAML files.
    It also allows to drop quoting characters and lighter to write/read.
    (keep double quotes for PowerShell strings needing expansion.)

  Closes #11999

- cmake: fix `HAVE_LDAP_SSL`, `HAVE_LDAP_URL_PARSE` on non-Windows

  - set `HAVE_LDAP_URL_PARSE` if `ldap_url_parse` function exists.
    Before this patch we set it based it on the presence of `stricmp`,
    which correctly enabled it on e.g. Windows, but was inaccurate for
    other platforms.

  - always set `HAVE_LDAP_SSL` if an LDAP backend is detected and
    LDAPS is not explicitly disabled. This mimics autotools behaviour.
    Previously we set it only for Windows LDAP. After this fix, LDAPS is
    correctly enabled in default macOS builds.

  - enable LDAP[S] for a CMake macOS CI job. Target OS X 10.9 (Mavericks)
    to avoid deprecation warnings for LDAP API.

  - always detect `HAVE_LDAP_SSL_H`, even with LDAPS explicitly disabled.
    This doesn't make much sense, but let's do it to sync behaviour with
    autotools.

  - fix benign typo in variable name.

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #12006

- autotools: restore `HAVE_IOCTL_*` detections

  This restores `CURL_CHECK_FUNC_IOCTL` detection. I deleted it in
  4d73854462f30948acab12984b611e9e33ee41e6 and
  c3456652a0c72d1845d08df9769667db7e159949 (2022-08), because the
  `HAVE_IOCTL` result it generated was unused in the source. But,
  I did miss the fact that this had two dependent checks:
  `CURL_CHECK_FUNC_IOCTL_FIONBIO`,
  `CURL_CHECK_FUNC_IOCTL_SIOCGIFADDR` that we do actually need:
  `HAVE_IOCTL_FIONBIO`, `HAVE_IOCTL_SIOCGIFADDR`.

  Regression from 4d73854462f30948acab12984b611e9e33ee41e6

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #12008

Daniel Stenberg (2 Oct 2023)

- RELEASE-PROCEDURE.md: updated coming release dates

- RELEASE-NOTES: synced

Viktor Szakats (1 Oct 2023)

- cmake: pre-cache `HAVE_POLL_FINE` on Windows

  Windows doesn't support `poll()`, so we can safely skip checking for
  fine poll.

  Closes #12003

- gha: bump actions to latest versions

  - actions@checkout@v4 (from v3 and v2)

  - fsfe/reuse-action@v2 (from v1)

  Closes #12000

Stefan Eissing (30 Sep 2023)

- h2: testcase and fix for pausing h2 streams

  - refs #11982 where it was noted that paused transfers may
    close successfully without delivering the complete data
  - made sample poc into tests/http/client/h2-pausing.c and
    added test_02_27 to reproduce

  Closes #11989
  Fixes #11982
  Reported-by: Harry Sintonen

Viktor Szakats (30 Sep 2023)

- cmake: validate `CURL_DEFAULT_SSL_BACKEND` config value

  Before this patch CMake builds accepted any value and it was used at
  runtime as-is. This patch make sure that the selected default backend
  is also enabled in the build. It also enforces a full lowercase value.

  This improves reproducibility and brings CMake in sync with autotools
  which already worked like described above.

  Follow-up to 26c7feb8b9d51a57fab3325571b4bbfa03b11af0 #11774

  Closes #11998

- autotools: adjust `CURL_CA_PATH` value to CMake

  autotools was using the same value as CMake, but with an ending
  slash. Delete the ending slash to match configurations.

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #11997

- cmake: detect `sys/wait.h` and `netinet/udp.h`

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #11996

Daniel Stenberg (30 Sep 2023)

- lib: provide and use Curl_hexencode

  Generates a lower case ASCII hex output from a binary input.

  Closes #11990

- configure: check for the capath by default

  ... if the chosen TLS backend supports it: OpenSSL, GnuTLS, mbedTLS or wolfSS
  L

  cmake: synced

  Assisted-by: Viktor Szakats
  Closes #11987

- wolfssl: ignore errors in CA path

  The default wolfSSL_CTX_load_verify_locations() function is quite picky
  with the certificates it loads and will for example return error if just
  one of the certs has expired.

  With the *_ex() function and its WOLFSSL_LOAD_FLAG_IGNORE_ERR flag, it
  behaves more similar to what OpenSSL does by default.

  Even the set of default certs on my Debian unstable has several expired
  ones.

  Assisted-by: Juliusz Sosinowicz
  Assisted-by: Michael Osipov

  Closes #11987

- create-dirs.d: clarify it also uses --output-dirs

  Reported-by: Robert Simpson
  Fixes #11991
  Closes #11995

Viktor Szakats (30 Sep 2023)

- appveyor: fix yamlint issues, indent

  Also:
  - use double quotes in all batch if statements.

  Closes #11994

- cmake: detect `HAVE_CLOCK_GETTIME_MONOTONIC_RAW`

  Based on existing autotools logic.

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #11981

- cmake: detect `HAVE_GETADDRINFO_THREADSAFE`

  Based on existing autotools logic.

  autotools checks for old versions of the allowlisted target OSes and
  disables this feature when seeing them. In CMake we assume we're running
  on newer systems and enable regardless of OS version.

  autotools always runs all 3 probes for non-fast-tracked systems and
  enables this feature if any one of them was successful. To save
  configuration time,  CMake stops at the first successful check.

  OpenBSD is not fast-tracked and then gets blocklisted as a generic BSD
  system. I haven't double-checked if this is correct, but looks odd.

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #11979

- cmake: fix `HAVE_WRITABLE_ARGV` detection

  Move detection before the creation of detection results in
  `curl_config.h`.

  Ref: #11964 (effort to sync cmake detections with autotools)

  Closes #11978

- appveyor: minor improvements

  - run `curl -V` after builds to see if they run and with what features.
    Except for one job where a CRT DLL is missing. And ARM64 which should
    fail, but is silently not launched instead.

  - copy libcurl DLL next to curl tool and tests binaries in shared mode.
    This makes it possible to run the tests. (We don't run tests after
    these builds yet.)

  - list the DLLs and EXEs present after the builds.

  - add `DEBUG` variable for CMake builds to allow disabling it, for
    testing non-debug builds. (currently enabled for all)

  - add commented lines that dump CMake configuration logs for debugging
    build/auto-detection issues.

  - add gcc version to jobs where missing.

  - switch a job to the native MSYS2 mingw-w64 toolchain. This adds gcc 9
    to the build mix.

  - make `SHARED=OFF` and `OPENSSL=OFF` defaults global.

  - delete a duplicate backslash.

  Closes #11976

- configure: replace adhoc domain with `localhost` in tests

  Reviewed-by: Daniel Stenberg
  Closes #11988

- tidy-up: use more example domains

  Also make use of the example TLD:
  https://en.wikipedia.org/wiki/.example

  Reviewed-by: Daniel Stenberg
  Closes #11992

Dan Fandrich (29 Sep 2023)

- runtests: display the test status if tests appear hung

  It sometimes happens that a test hangs during a test run and never
  returns. The test harness will wait indefinitely for the results and on
  CI servers the CI job will eventually be killed after an hour or two.
  At the end of a test run, if results haven't come in within a couple of
  minutes, display the status of all test runners and what tests they're
  running to help in debugging the problem.

  This feature is really only kick in with parallel testing enabled, which
  is fine because without parallel testing it's usually easy to tell what
  test has hung.

  Closes #11980

- github/labeler: remove workaround for labeler

  This was added due to what seemed to be a bug regarding the sync-labels:
  config option, but it looks like it wasn't necessary.

  Follow-up to b2b0534e7

Viktor Szakats (29 Sep 2023)

- docs: upgrade an URL to HTTPS in `BINDINGS.md` [ci skip]

Daniel Stenberg (29 Sep 2023)

- docs: replace made up domains with example.com

  in FAQ and MANUAL.md

  - example.com was made for this purpose.

  - reduces the risk that one of those domains suddenly start hosting
    something nasty and we provide links to them

  Closes #11986

Michael Osipov (29 Sep 2023)

- acinclude.m4: Document proper system truststore on FreeBSD

  The default system truststore on FreeBSD has been /etc/ssl/certs for many
  years now. It is managed canonically through certctl(8) and contains hashed
  symlinks for OpenSSL and other TLS providers.
  The previous ones require security/ca_root_nss which might not be installed o
  r
  will not contain any custom CA certificates.

  Closes #11985

Daniel Stenberg (29 Sep 2023)

- FAQ: How do I upgrade curl.exe in Windows?

  This is a growing question, better answer it here to get somewhere to
  point users to.

  Closes #11984

Viktor Szakats (28 Sep 2023)

- cmake: pre-cache `HAVE_BASENAME` for mingw-w64 and MSVC

  `basename` is present in mingw-w64, missing from MSVC. Pre-cache
  accordingly to make configure faster.

  Notice that `basename` has a bug so we later disable it even with
  mingw-w64:
  https://github.com/curl/curl/blob/781242ffa44a9f9b95b6da5ac5a1bf6372ec6257/li
  b/curl_setup.h#L820-L825

  Closes #11974

Daniel Stenberg (28 Sep 2023)

- cmake: add missing checks

  - check for arc4random. To make rand.c use it accordingly.
  - check for fcntl
  - fix fseek detection
  - add SIZEOF_CURL_SOCKET_T
  - fix USE_UNIX_SOCKETS
  - define HAVE_SNPRINTF to 1
  - check for fnmatch
  - check for sched_yield
  - remove HAVE_GETPPID duplicate from curl_config.h
  - add HAVE_SENDMSG

  Ref: #11964

  Co-authored-by: Viktor Szakats
  Closes #11973

- configure: remove unused checks

  - for sys/uio.h
  - for fork
  - for connect

  Ref: #11964

  Closes #11973

- lib: remove TIME_WITH_SYS_TIME

  It is not used in any code anywhere.

  Ref: #11964
  Closes #11975

- docs: update curl man page references

  Detected by the manpage-syntax update

  Closes #11963

- manpage-syntax: verify curl man page references

  1. References to curl symbols are now checked that they indeed exist as
     man pages. This for \f references as well as the names referenced in the
     SEE ALSO section.

     Allowlist curl.1 since it is not always built in builds

  2. References to curl symbols that lack section now causes warning, since tha
  t
     will prevent them from getting linked properly

  3. Check for "bare" references to curl functions and warn, they should be
     references

  Closes #11963

- cmake: add check for suseconds_t

  And fix the HAVE_LONGLONG define

  Ref: #11964
  Closes #11977

Viktor Szakats (28 Sep 2023)

- tidy-up: whitespace fixes

  Closes #11972

- cmake: detect TLS-SRP in OpenSSL/wolfSSL/GnuTLS

  With new option `CURL_DISABLE_SRP=ON` to force-disable it.
  To match existing option and detection logic in autotools.

  Also:
  - fix detecting GnuTLS.
    We assume `nettle` as a GnuTLS dependency.
  - add CMake GnuTLS CI job.
  - bump AppVeyor CMake OpenSSL MSVC job to OpenSSL 1.1.1 (from 1.0.2)
    TLS-SRP fails to detect with 1.0.2 due to an OpenSSL header bug.
  - fix compiler warning when building with GnuTLS and disabled TLS-SRP.
  - fix comment typos, whitespace.

  Ref: #11964

  Closes #11967

- tool: use our own stderr variable

  Earlier this year we changed our own stderr variable to use the standard
  name `stderr` (to avoid bugs where someone is using `stderr` instead of
  the curl-tool specific variable). This solution needed to override the
  standard `stderr` symbol via the preprocessor. This in turn didn't play
  well with unity builds and caused curl tool to crash or stay silent due
  to an uninitialized stderr. This was a hard to find issue, fixed by
  manually breaking out one file from the unity sources.

  To avoid two these two tricks, this patch implements a different
  solution: Restore using our own local variable for our stderr output and
  leave `stderr` as-is. To avoid using `stderr` by mistake, add a
  `checksrc` rule (based on logic we already used in lib for `strerror`)
  that detects any `stderr` use in `src` and points to using our own
  variable instead: `tool_stderr`.

  Follow-up to 06133d3e9b8aeb9e9ca0b3370c246bdfbfc8619e
  Follow-up to 2f17a9b654121dd1ecf4fc043c6d08a9da3522db

  Closes #11958

Loïc Yhuel (28 Sep 2023)

- connect: only start the happy eyeballs timer when needed

  The timeout is only used when there is a second address family, for the
  delayed eyeballer.

  Closes #11939

Daniel Stenberg (28 Sep 2023)

- tool_operate: free 'gateway' correctly

  Pointed out by Coverity. The fix in 93885cf3a8d4e was incomplete.

  Also removed repeated wording in IPFS related error messages.

  Closes #11969

Stefan Eissing (28 Sep 2023)

- lib: move handling of `data->req.writer_stack` into Curl_client_write()

  - move definitions from content_encoding.h to sendf.h
  - move create/cleanup/add code into sendf.c
  - installed content_encoding writers will always be called
    on Curl_client_write(CLIENTWRITE_BODY)
  - Curl_client_cleanup() frees writers and tempbuffers from
    paused transfers, irregardless of protocol

  Closes #11908

Loïc Yhuel (28 Sep 2023)

- multi: round the timeout up to prevent early wakeups

  Curl_timediff rounds down to the millisecond, so curl_multi_perform can
  be called too early, then we get a timeout of 0 and call it again.

  The code already handled the case of timeouts which expired less than
  1ms in the future.  By rounding up, we make sure we will never ask the
  platform to wake up too early.

  Closes #11938

Daniel Stenberg (28 Sep 2023)

- RELEASE-NOTES: spell out that IPFS is via gateway

- RELEASE-NOTES: synced

- tool_operate: avoid strlen() -1 on zero length content from file

  Follow-up to 65b563a96a226649ba12cb1e

  Closes #11959

- tool_operate: fix memory mixups

  Switch to plain getenv() from curl_getenv() to avoid the allocation and
  having to keep track of which free() or curl_free() that need to be
  used.

  Coverity found issues and a memory leak.

  Follow-up to 65b563a96a226649ba12cb1e

  Closes #11959

Viktor Szakats (27 Sep 2023)

- curl-functions.m4: fixup recent bad edits

  Follow-up to 96c29900bcec32dd6bc8e9857c8871ff4b8b8ed9 #11940

  Closes #11966

Daniel Stenberg (27 Sep 2023)

- curl-functions.m4: fix include line

  This made the getaddrinfo detection fail, but we did not spot it in the
  CI because it graciously falled back to using legacy functions instead!

  Follow-up to 96c29900bcec (#11940)

  Closes #11965

- inet_ntop: add typecast to silence Coverity

  CID 1024653:  Integer handling issues  (SIGN_EXTENSION)

  Suspicious implicit sign extension: "src[i]" with type "unsigned char
  const" (8 bits, unsigned) is promoted in "src[i] << (1 - i % 2 << 3)" to
  type "int" (32 bits, signed), then sign-extended to type "unsigned long"
  (64 bits, unsigned).  If "src[i] << (1 - i % 2 << 3)" is greater than
  0x7FFFFFFF, the upper bits of the result will all be 1.

  111         words[i/2] |= (src[i] << ((1 - (i % 2)) << 3));

  The value will not be greater than 0x7FFFFFFF so this still cannot
  happen.

  Also, switch to ints here instead of longs. The values stored are 16 bit
  so at least no need to use 64 bit variables. Also, longs are 32 bit on
  some platforms so this logic still needs to work with 32 bits.

  Closes #11960

- docs: adapt SEE ALSO sections to new requirements

  To please manpage-syntax.pl used by test 1173

  Closes #11957

- manpage-syntax.pl: verify SEE ALSO syntax

  - Enforce a single reference per .BR line
  - Skip the quotes around the section number for example (3)
  - Insist on trailing commas on all lines except the last
  - Error on comma on the last SEE ALSO entry

  - List the entries alpha-sorted, not enforced just recommended

  Closes #11957

- connect: expire the timeout when trying next

  ... so that it gets called again immediately and can continue trying
  addresses to connect to. Otherwise it might unnecessarily wait for a
  while there.

  Fixes #11920
  Reported-by: Loïc Yhuel
  Closes #11935

- http: remove wrong comment for http_should_fail

  Reported-by: Christian Schmitz
  Ref: #11936
  Closes #11941

Dan Fandrich (26 Sep 2023)

- tool_setopt: remove unused function tool_setopt_flags

  This function is identical to tool_setopt_bitmask except that it treats
  the argument as unsigned.

  Closes #11943

Viktor Szakats (26 Sep 2023)

- cmake: add feature checks for `memrchr` and `getifaddrs`

  - `HAVE_MEMRCHR` for `memrchr`.
  - `HAVE_GETIFADDRS` for `getifaddrs`.
    This was present in `lib/curl_config.h.cmake` but missed the detection
    logic.

  To match existing autotools feature checks.

  Closes #11954

- cmake: move global headers to specific checks

  Before this patch we added standard headers unconditionally to the
  global list of headers used for feature checks. This is unnecessary
  and also doesn't help CMake 'Generate' performance. This patch moves
  these headers to each feature check where they are actually needed.
  Stop using `stddef.h`, as it seems unnecessary.

  I've used autotools' `m4/curl-functions.m4` to figure out these
  dependencies.

  Also delete checking for the C89 standard header `time.h`, that I
  missed in the earlier commit.

  Ref: 96c29900bcec32dd6bc8e9857c8871ff4b8b8ed9 #11940

  Closes #11951

- src/mkhelp: make generated code pass `checksrc`

  Closes #11955

- tests: show which curl tool `runtests.pl` is using

  To help debugging when there is issue finding or running it.

  Closes #11953

- CI/azure: make `MAKEFLAGS` global to parallelize all jobs

  https://dev.azure.com/daniel0244/curl/_build/results?buildId=17528 (before)
  https://dev.azure.com/daniel0244/curl/_build/results?buildId=17545 (after, wi
  th -j3)

  Closes #11952

- CI/azure: migrate old mingw MSYS1 jobs to MSYS2

  Also delete an accidental variable reference.

  Follow-up to 38029101e2d78ba125732b3bab6ec267b80a0e72

  Closes #11945

Daniel Stenberg (26 Sep 2023)

- docs: add see also curl_multi_get_handles to some man pages

  Assisted-by: Jay Satiro

  Closes #11942

Viktor Szakats (26 Sep 2023)

- cmake: assume `_fseeki64` and no `fseeko` on Windows

  `_fseeki64` is present in mingw-w64 1.0 (2011-09-26) headers, and
  at least Watcom C 1.9 (2010) headers and MSVS 2008 [1].

  `fseeko` is not present in any of these.

  (mingw-w64 1.0 also offers `fseeko64`.)

  [1] https://github.com/curl/curl/pull/11944#issuecomment-1734995004

  Follow-up to 9c7165e96a3a9a2d0b7059c87c699b5ca8cdae93 #11918

  Closes #11950

- build: delete checks for C89 standard headers

  Delete checks and guards for standard C89 headers and assume these are
  available: `stdio.h`, `string.h`, `time.h`, `setjmp.h`, `stdlib.h`,
  `stddef.h`, `signal.h`.

  Some of these we already used unconditionally, some others we only used
  for feature checks.

  Follow-up to 9c7165e96a3a9a2d0b7059c87c699b5ca8cdae93 #11918 (for `stdio.h` i
  n CMake)

  Closes #11940

Stefan Eissing (26 Sep 2023)

- multiif.h: remove Curl_multi_dump declaration

  Follow-up to d850eea2 which removed the Curl_multi_dump definition.

  Closes https://github.com/curl/curl/pull/11946

Jay Satiro (26 Sep 2023)

- config-win32: define HAVE__FSEEKI64

  Follow-up to 9c7165e9 which added an fseeko wrapper to the lib that
  calls _fseeki64 if it is available.

  Closes https://github.com/curl/curl/pull/11944

- docs: explain how PINNEDPUBLICKEY is independent of VERIFYPEER

  - Explain that peer verification via CURLOPT_PINNEDPUBLICKEY takes place
    even if peer verification via CURLOPT_SSL_VERIFYPEER is turned off.

  The behavior is verified by test2048.

  Bug: https://github.com/curl/curl/issues/2935#issuecomment-418371872
  Reported-by: claudiusaiz@users.noreply.github.com

  Bug: https://github.com/curl/curl/discussions/11910
  Reported-by: Hakan Sunay Halil

  Closes https://github.com/curl/curl/pull/11930

Stefan Eissing (26 Sep 2023)

- openssl: improve ssl shutdown handling

  - If SSL shutdown is not finished then make an additional call to
    SSL_read to gather additional tracing.

  - Fix http2 and h2-proxy filters to forward do_close() calls to the next
    filter.

  For example h2 and SSL shutdown before and after this change:

  Before:

  Curl_conn_close -> cf_hc_close -> Curl_conn_cf_discard_chain ->
  ssl_cf_destroy

  After:

  Curl_conn_close -> cf_hc_close -> cf_h2_close -> cf_setup_close ->
  ssl_cf_close

  Note that currently the tracing does not show output on the connection
  closure handle. Refer to discussion in #11878.

  Ref: https://github.com/curl/curl/discussions/11878

  Closes https://github.com/curl/curl/pull/11858

Loïc Yhuel (26 Sep 2023)

- multi: fix small timeouts

  Since Curl_timediff rounds down to the millisecond, timeouts which
  expire in less than 1ms are considered as outdated and removed from the
  list. We can use Curl_timediff_us instead, big timeouts could saturate
  but this is not an issue.

  Closes #11937

Viktor Szakats (25 Sep 2023)

- cmake: fix stderr initialization in unity builds

  Before this patch, in certain build configurations the curl tool may
  not have displayed anything (debug, macOS), or crashed at startup
  (debug, Windows).

  Follow-up to 3f8fc25720900b14b7432f4bd93407ca15311719
  Necessary after 2f17a9b654121dd1ecf4fc043c6d08a9da3522db

  Closes #11929

- cmake: fix missing `zlib.h` when compiling `libcurltool`

  Came up while testing debug/testing build for Windows. I'm not sure why
  it didn't come up in earlier tests with similar config.
  `tool_hugehelp.c` might indeed require `zlib.h` and without linking
  `CURL_LIBS` to the `curltool` target, CMake doesn't seem to add detected
  dependency headers to the compiler command.

  ```
  [ 25%] Building C object src/CMakeFiles/curltool.dir/tool_hugehelp.c.obj
  cd .../curl/bld-cmake-llvm-x64/src && /usr/local/opt/llvm/bin/clang
    --target=x86_64-w64-mingw32 --sysroot=/usr/local/opt/mingw-w64/toolchain-x8
  6_64
    -DCURLDEBUG -DCURL_STATICLIB -DHAVE_CONFIG_H -DUNICODE -DUNITTESTS -D_UNICO
  DE
    -I.../curl/include -I.../curl/lib -I.../curl/bld-cmake-llvm-x64/lib
    -I.../curl/bld-cmake-llvm-x64/include -I.../curl/src -Wno-unused-command-li
  ne-argument
    -D_UCRT -DDEBUGBUILD -DHAS_ALPN -DUSE_MANUAL=1  -fuse-ld=lld -Wl,-s -static
  -libgcc
    -lucrt [...] -O3 -DNDEBUG -municode -MD
    -MT src/CMakeFiles/curltool.dir/tool_hugehelp.c.obj
    -MF CMakeFiles/curltool.dir/tool_hugehelp.c.obj.d
    -o CMakeFiles/curltool.dir/tool_hugehelp.c.obj -c .../curl/bld-cmake-llvm-x
  64/src/tool_hugehelp.c
  .../curl/bld-cmake-llvm-x64/src/tool_hugehelp.c:6:10: fatal error: 'zlib.h' f
  ile not found
      6 | #include <zlib.h>
        |          ^~~~~~~~
  ```

  Follow-up to 39e7c22bb459c2e818f079984989a26a09741860

  Closes #11927

- cmake: fix duplicate symbols when linking tests

  The linker resolves this automatically in non-unity builds. In unity
  builds the linker cannot drop a single object with the duplicates,
  resulting in these errors. The root issue is that we started including
  certain objects both via both libcurlu and libcurltool libs.

  Regression from 39e7c22bb459c2e818f079984989a26a09741860

  Windows errors:
  ```
  [  3%] Linking C executable unit1303.exe
  [  3%] Building C object tests/server/CMakeFiles/rtspd.dir/__/__/lib/curl_mul
  tibyte.c.obj
  ../../lib/libcurlu-d.a(unity_0.c.obj): In function `curlx_convert_UTF8_to_wch
  ar':
  C:/projects/curl/lib/curl_multibyte.c:44: multiple definition of `curlx_conve
  rt_UTF8_to_wchar'
  ../../src/libcurltool-d.a(unity_0.c.obj):C:/projects/curl/lib/curl_multibyte.
  c:44: first defined here
  ../../lib/libcurlu-d.a(unity_0.c.obj): In function `curlx_convert_wchar_to_UT
  F8':
  C:/projects/curl/lib/curl_multibyte.c:66: multiple definition of `curlx_conve
  rt_wchar_to_UTF8'
  ../../src/libcurltool-d.a(unity_0.c.obj):C:/projects/curl/lib/curl_multibyte.
  c:66: first defined here
  ../../lib/libcurlu-d.a(unity_0.c.obj): In function `curlx_win32_open':
  C:/projects/curl/lib/curl_multibyte.c:92: multiple definition of `curlx_win32
  _open'
  ../../src/libcurltool-d.a(unity_0.c.obj):C:/projects/curl/lib/curl_multibyte.
  c:92: first defined here
  ../../lib/libcurlu-d.a(unity_0.c.obj): In function `curlx_win32_fopen':
  C:/projects/curl/lib/curl_multibyte.c:120: multiple definition of `curlx_win3
  2_fopen'
  ../../src/libcurltool-d.a(unity_0.c.obj):C:/projects/curl/lib/curl_multibyte.
  c:120: first defined here
  ../../lib/libcurlu-d.a(unity_0.c.obj): In function `curlx_win32_stat':
  [...]
  ```
  Ref: https://ci.appveyor.com/project/curlorg/curl/builds/48110107/job/nvlhpt9
  aa4ehny5q#L247

  macOS errors:
  ```
  [ 56%] Linking C executable unit1302
  duplicate symbol '_curlx_sotouz' in:
      ../../lib/libcurlu.a(unity_0_c.c.o)
      ../../src/libcurltool.a(unity_0_c.c.o)
  duplicate symbol '_curlx_sitouz' in:
      ../../lib/libcurlu.a(unity_0_c.c.o)
      ../../src/libcurltool.a(unity_0_c.c.o)
  duplicate symbol '_curlx_uztosz' in:
      ../../lib/libcurlu.a(unity_0_c.c.o)
      ../../src/libcurltool.a(unity_0_c.c.o)
  [...]
  ```
  with config:
  ```
    -DCMAKE_UNITY_BUILD=ON \
    -DENABLE_DEBUG=ON -DBUILD_TESTING=ON -DCMAKE_C_FLAGS=-DDEBUGBUILD \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_STATIC_LIBS=OFF
  ```

  Closes #11926

- cmake: lib `CURL_STATICLIB` fixes (Windows)

  - always define `CURL_STATICLIB` when building libcurl for Windows.

    This disables `__declspec(dllexport)` for exported libcurl symbols.
    In normal mode (hide symbols) these exported symbols are specified
    via `libcurl.def`. When not hiding symbols, all symbols are exported
    by default.

    Regression from 1199308dbc902c52be67fc805c72dd2582520d30

    Fixes #11844

  - fix to omit `libcurl.def` when not hiding private symbols.

    Regression from 2ebc74c36a19a1700af394c16855ce144d9878e3

  - fix `ENABLED_DEBUG=ON` + shared curl tool Windows builds by also
    omitting `libcurl.def` in this case, and exporting all symbols
    instead. This ensures that a shared curl tool can access all debug
    functions which are not normally exported from libcurl DLL.

  - delete `INTERFACE_COMPILE_DEFINITIONS "CURL_STATICLIB"` for "objects"
    target.

    Follow-up to 2ebc74c36a19a1700af394c16855ce144d9878e3

  - delete duplicate `BUILDING_LIBCURL` definitions.

  - fix `HIDES_CURL_PRIVATE_SYMBOLS` to not overwrite earlier build settings.

    Follow-up to 1199308dbc902c52be67fc805c72dd2582520d30

  Closes #11914

Daniel Stenberg (25 Sep 2023)

- RELEASE-NOTES: synced

Dan Fandrich (25 Sep 2023)

- tests: fix log directory path in IPFS tests

  Hard-coding the log directory name fails with parallel tests.

  Follow-up to 65b563a96

  Ref: #8805

Daniel Stenberg (25 Sep 2023)

- curl_multi_get_handles: get easy handles from a multi handle

  Closes #11750

Stefan Eissing (25 Sep 2023)

- http: h1/h2 proxy unification

  - use shared code for setting up the CONNECT request
    when tunneling, used in HTTP/1.x and HTTP/2 proxying
  - eliminate use of Curl_buffer_send() and other manipulations
    of `data->req` or `data->state.ulbuf`

  Closes #11808

Natanael Copa (25 Sep 2023)

- lib: use wrapper for curl_mime_data fseek callback

  fseek uses long offset which does not match with curl_off_t. This leads
  to undefined behavior when calling the callback and caused failure on
  arm 32 bit.

  Use a wrapper to solve this and use fseeko which uses off_t instead of
  long.

  Thanks to the nice people at Libera IRC #musl for helping finding this
  out.

  Fixes #11882
  Fixes #11900
  Closes #11918

- configure: sort AC_CHECK_FUNCS

  No functional changes.

Daniel Stenberg (25 Sep 2023)

- warnless: remove unused functions

  Previously put there for use with the intel compiler

  Closes #11932

- GHA/linux: run singleuse to detect single-use global functions

  Use --unit for configure --enable-debug builds

  Closes #11932

- singleuse: add scan for use in other source codes

  This should reduce false-positive to almost zero. Checks for presence in
  unit tests if --unit is specified, which is intended for debug builds
  where unit testing is enabled.

  Closes #11932

- multi: remove Curl_multi_dump

  A debug-only function that is basically never used. Removed to ease the
  use of the singleuse script to detect non-static functions not used
  outside the file where it is defined.

  Closes #11931

Viktor Szakats (24 Sep 2023)

- tests: fix compiler warnings

  Seen with llvm 17 on Windows x64.

  ```
  .../curl/tests/server/rtspd.c:136:13: warning: no previous extern declaration
   for non-static variable 'logdir' [-Wmissing-variable-declarations]
    136 | const char *logdir = "log";
        |             ^
  .../curl/tests/server/rtspd.c:136:7: note: declare 'static' if the variable i
  s not intended to be used outside of this translation unit
    136 | const char *logdir = "log";
        |       ^
  .../curl/tests/server/rtspd.c:137:6: warning: no previous extern declaration 
  for non-static variable 'loglockfile' [-Wmissing-variable-declarations]
    137 | char loglockfile[256];
        |      ^
  .../curl/tests/server/rtspd.c:137:1: note: declare 'static' if the variable i
  s not intended to be used outside of this translation unit
    137 | char loglockfile[256];
        | ^
  .../curl/tests/server/fake_ntlm.c:43:13: warning: no previous extern declarat
  ion for non-static variable 'logdir' [-Wmissing-variable-declarations]
     43 | const char *logdir = "log";
        |             ^
  .../curl/tests/server/fake_ntlm.c:43:7: note: declare 'static' if the variabl
  e is not intended to be used outside of this translation unit
     43 | const char *logdir = "log";
        |       ^
  .../curl/src/tool_doswin.c:350:8: warning: possible misuse of comma operator 
  here [-Wcomma]
    350 |     ++d, ++s;
        |        ^
  .../curl/src/tool_doswin.c:350:5: note: cast expression to void to silence wa
  rning
    350 |     ++d, ++s;
        |     ^~~
        |     (void)( )
  ```

  ```
  .../curl/tests/libtest/lib540.c:146:27: warning: result of comparison 'long' 
  > 2147483647 is always false [-Wtautological-type-limit-compare]
    146 |         int itimeout = (L > (long)INT_MAX) ? INT_MAX : (int)L;
        |                         ~ ^ ~~~~~~~~~~~~~
  1 warning generated.

  .../curl/tests/libtest/libntlmconnect.c:195:31: warning: result of comparison
   'long' > 2147483647 is always false [-Wtautological-type-limit-compare]
    195 |       int itimeout = (timeout > (long)INT_MAX) ? INT_MAX : (int)timeo
  ut;
        |                       ~~~~~~~ ^ ~~~~~~~~~~~~~
  1 warning generated.

  .../curl/tests/libtest/lib591.c:117:31: warning: result of comparison 'long' 
  > 2147483647 is always false [-Wtautological-type-limit-compare]
    117 |       int itimeout = (timeout > (long)INT_MAX) ? INT_MAX : (int)timeo
  ut;
        |                       ~~~~~~~ ^ ~~~~~~~~~~~~~
  1 warning generated.
  .../curl/tests/libtest/lib597.c:99:31: warning: result of comparison 'long' >
   2147483647 is always false [-Wtautological-type-limit-compare]
     99 |       int itimeout = (timeout > (long)INT_MAX) ? INT_MAX : (int)timeo
  ut;
        |                       ~~~~~~~ ^ ~~~~~~~~~~~~~
  1 warning generated.
  ```

  Seen on macOS Intel:
  ```
  .../curl/tests/server/sws.c:440:64: warning: field precision should have type
   'int', but argument has type 'size_t' (aka 'unsigned long') [-Wformat]
            msnprintf(logbuf, sizeof(logbuf), "Got request: %s %.*s HTTP/%d.%d"
  ,
                                                               ~~^~
  1 warning generated.
  ```

  Closes #11925

Jay Satiro (24 Sep 2023)

- url: fix netrc info message

  - Fix netrc info message to use the generic ".netrc" filename if the
    user did not specify a netrc location.

  - Update --netrc doc to add that recent versions of curl on Windows
    prefer .netrc over _netrc.

  Before:
  * Couldn't find host google.com in the (nil) file; using defaults

  After:
  * Couldn't find host google.com in the .netrc file; using defaults

  Closes https://github.com/curl/curl/pull/11904

Dan Fandrich (23 Sep 2023)

- wolfssh: do cleanup in Curl_ssh_cleanup

  Closes: #11921

Daniel Stenberg (24 Sep 2023)

- tool_listhelp: regenerated

  Polished the --ipfs-gateway description

  Fixed the --trace-config description

  The script also fixed some other small mistakes

  Closes #11923

Viktor Szakats (23 Sep 2023)

- Makefile.mk: always set `CURL_STATICLIB` for lib (Windows)

  Also fix to export all symbols in Windows debug builds, making
  `-debug-dyn` builds work with `-DCURL_STATICLIB` set.

  Ref: https://github.com/curl/curl/pull/11914 (same for CMake)

  Closes #11924

Daniel Stenberg (23 Sep 2023)

- quic: set ciphers/curves the same way regular TLS does

  for OpenSSL/BoringSSL

  Fixes #11796
  Reported-by: Karthikdasari0423 on github
  Assisted-by: Jay Satiro
  Closes #11836

- test457: verify --max-filesize with chunked encoding

- lib: let the max filesize option stop too big transfers too

  Previously it would only stop them from getting started if the size is
  known to be too big then.

  Update the libcurl and curl docs accordingly.

  Fixes #11810
  Reported-by: Elliot Killick
  Assisted-by: Jay Satiro
  Closes #11820

Viktor Szakats (23 Sep 2023)

- mingw: delete support for legacy mingw.org toolchain

  Drop support for "old" / "legacy" / "classic" / "v1" / "mingw32" MinGW:
    https://en.wikipedia.org/wiki/MinGW, https://osdn.net/projects/mingw/
  Its homepage used to be http://mingw.org/ [no HTTPS], and broken now.
  It supported the x86 CPU only and used a old Windows API header and
  implib set, often causing issues. It also misses most modern Windows
  features, offering old versions of both binutils and gcc (no llvm/clang
  support). It was last updated 2 years ago.

  curl now relies on toolchains based on the mingw-w64 project:
  https://www.mingw-w64.org/  https://sourceforge.net/projects/mingw-w64/
  https://www.msys2.org/  https://github.com/msys2/msys2
  https://github.com/mstorsjo/llvm-mingw
  (Also available via Linux and macOS package managers.)

  Closes #11625

Mark Gaiser (23 Sep 2023)

- curl: add support for the IPFS protocols:

  - ipfs://<cid>
  - ipns://<cid>

  This allows you tu use ipfs in curl like:
  curl ipfs://<cid>
  and
  curl ipns://<cid>

  For more information consult the readme at:
  https://curl.se/docs/ipfs.html

  Closes #8805

Daniel Stenberg (23 Sep 2023)

- bufq: remove Curl_bufq_skip_and_shift (unused)

  Closes #11915

- scripts/singleuse.pl: add curl_global_trace

Viktor Szakats (22 Sep 2023)

- cmake: fix unity symbol collisions in h2 builds

  Regression from 331b89a319d0067fa1e6441719307cfef9c7960f

  Reviewed-by: Daniel Stenberg
  Reviewed-by: Jay Satiro
  Closes #11912

Daniel Stenberg (22 Sep 2023)

- RELEASE-NOTES: synced

Dan Fandrich (21 Sep 2023)

- github/labeler: improve the match patterns

  This includes new rules for setting the appleOS and logging labels and
  matches on some example files. Also, enable dot mode for wildcard
  matches in the .github directory.

Daniel Stenberg (21 Sep 2023)

- upload-file.d: describe the file name slash/backslash handling

  Closes #11911

Jakub Jelen (21 Sep 2023)

- libssh: cap SFTP packet size sent

  Due to libssh limitations

  Signed-off-by: Jakub Jelen <jjelen@redhat.com>

  Closes #11804

Daniel Stenberg (21 Sep 2023)

- curl.h: mark CURLSSLBACKEND_NSS as deprecated since 8.3.0

  Closes #11905

- mailmap: unify Michael Osipov under a single email

Ted Lyngmo (21 Sep 2023)

- docs: use CURLSSLBACKEND_NONE

  [ssl] use CURLSSLBACKEND_NONE instead of (curl_sslbackend)-1 in
  documentation and examples.

  Signed-off-by: Ted Lyngmo <ted@lyncon.se>

  Closes #11909

Dan Fandrich (21 Sep 2023)

- github/labeler: give the sync-labels config item a default value

  This shouldn't be necessary and is likely a bug with this beta version
  of the labeller.

  Also, fix the negative matches for the documentation label.

  Follow-up to dd12b452a
  Closes #11907

- github/labeler: fix up more the labeler config format

  The new version didn't like the workaround we had for a bug in the
  previous labeler version, and it should no longer be needed.

  Follow-up to dd12b452a
  Closes #11906

- github/labeler: fix indenting to try to appease labeller

  Follow-up to dd12b452a

Jay Satiro (21 Sep 2023)

- libssh2: fix error message on failed pubkey-from-file

  - If libssh2_userauth_publickey_fromfile_ex returns -1 then show error
    message "SSH public key authentication failed: Reason unknown (-1)".

  When libssh2_userauth_publickey_fromfile_ex returns -1 it does so as a
  generic error and therefore doesn't set an error message. AFAICT that is
  not documented behavior.

  Prior to this change libcurl retrieved the last set error message which
  would be from a previous function failing. That resulted in misleading
  auth failed error messages in verbose mode.

  Bug: https://github.com/curl/curl/issues/11837#issue-1891827355
  Reported-by: consulion@users.noreply.github.com

  Closes https://github.com/curl/curl/pull/11881

Stefan Eissing (21 Sep 2023)

- pytest: exclude test_03_goaway in CI runs due to timing dependency

  Closes #11860

- lib: disambiguate Curl_client_write flag semantics

  - use CLIENTWRITE_BODY *only* when data is actually body data
  - add CLIENTWRITE_INFO for meta data that is *not* a HEADER
  - debug assertions that BODY/INFO/HEADER is not used mixed
  - move `data->set.include_header` check into Curl_client_write
    so protocol handlers no longer have to care
  - add special in FTP for `data->set.include_header` for historic,
    backward compatible reasons
  - move unpausing of client writes from easy.c to sendf.c, so that
    code is in one place and can forward flags correctly

  Closes #11885

Patrick Monnerat (21 Sep 2023)

- tftpd: always use curl's own tftp.h

  Using the system's provided arpa/tftp.h and optimizing, GCC 12 detects
  and reports a stringop-overread warning:

  tftpd.c: In function ‘write_behind.isra’:
  tftpd.c:485:12: warning: ‘write’ reading between 1 and 2147483647 bytes f
  rom a region of size 0 [-Wstringop-overread]
    485 |     return write(test->ofile, writebuf, count);
        |            ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  In file included from tftpd.c:71:
  /usr/include/arpa/tftp.h:58:30: note: source object ‘tu_data’ of size 0
     58 |                         char tu_data[0];        /* data or error stri
  ng */
        |                              ^~~~~~~

  This occurs because writebuf points to this field and the latter
  cannot be considered as being of dynamic length because it is not
  the last field in the structure. Thus it is bound to its declared
  size.

  This commit always uses curl's own version of tftp.h where the
  target field is last in its structure, effectively avoiding the
  warning.

  As HAVE_ARPA_TFTP_H is not used anymore, cmake/configure checks for
  arpa/tftp.h are removed.

  Closes #11897

Dan Fandrich (20 Sep 2023)

- test1474: make precheck more robust on non-Solaris systems

  If uname -r returns something odd, perl could return an error code and
  the test would be erroneously skipped. The qx// syntax avoid this.

  Followup to 08f9b2148

- github/labeler: switch to the 5 beta version

  This version adds an important feature that will allow more PRs to be
  labelled. Rather than being limited to labeling PRs with files that
  match a single glob, it can now label them if multiple changed files
  match any one of a number of globs.

Daniel Stenberg (20 Sep 2023)

- lib: enable hmac for digest as well

  Previously a build that disabled NTLM and aws-sigv4 would fail to build
  since the hmac was disabled, but it is also needed for digest auth.

  Follow-up to e92edfbef64448ef

  Fixes #11890
  Reported-by: Aleksander Mazur
  Closes #11896

- idn: if idn2_check_version returns NULL, return error

  ... this avoids a NULL dereference for this unusual case.

  Reported-by: s0urc3_ on hackerone
  Closes #11898

- http: fix CURL_DISABLE_BEARER_AUTH breakage

  When bearer auth was disabled, the if/else logic got wrong and caused
  problems.

  Follow-up to e92edfbef64448ef461
  Fixes #11892
  Reported-by: Aleksander Mazur
  Closes #11895

Michael Osipov (20 Sep 2023)

- wolfssl: allow capath with CURLOPT_CAINFO_BLOB

  Remain consistent with OpenSSL. While CAfile is nulled as documented
  with CURLOPT_CAINFO_BLOB, CApath remains intact.

  Closes #11886

- wolfssl: use ssl_cafile/ssl_capath variables consistent with openssl.c

  Closes #11886

Dan Fandrich (19 Sep 2023)

- test1474: disable test on NetBSD, OpenBSD and Solaris 10

  These kernels only send a fraction of the requested amount of the first
  large block, invalidating the assumptions of the test and causing it to
  fail.

  Assisted-by: Christian Weisgerber
  Ref: https://curl.se/mail/lib-2023-09/0021.html
  Closes #11888

Ryan Schmidt (20 Sep 2023)

- cmake, configure: also link with CoreServices

  When linking with CoreFoundation, also link with CoreServices which is
  apparently required to avoid an NSInvalidArgumentException in software
  linking with libcurl on macOS Sonoma 14 and later.

  Fixes #11893
  Closes #11894

Marc Hoersken (19 Sep 2023)

- CI/azure: remove pip, wheel, cryptography, pyopenssl and impacket

  These dependencies are now already included in the Docker image.

  Ref: https://github.com/mback2k/curl-docker-winbuildenv/commit/2607a31bcab544
  b41d15606e97f38cf312c1ce56

  Closes #11889

Daniel Stenberg (19 Sep 2023)

- wolfssl: if CURLOPT_CAINFO_BLOB is set, ignore the CA files

  Ref: #11883
  Reported-by: Michael Osipov
  Closes #11884

- RELEASE-NOTES: synced

- test3103: CURLOPT_COOKIELIST test

- cookie: set ->running in cookie_init even if data is NULL

  This is a regression introduced in b1b326ec500 (shipped in curl 8.1.0)

  Test 3103 verifies.

  Fixes #11875
  Reported-by: wangp on github
  Closes #11876

- test498: total header size for all redirects is larger than accepted

- http: use per-request counter to check too large headers

  Not the counter that accumulates all headers over all redirects.

  Follow-up to 3ee79c1674fd6

  Do a second check for 20 times the limit for the accumulated size for
  all headers.

  Fixes #11871
  Reported-by: Joshix-1 on github
  Closes #11872

Jay Satiro (18 Sep 2023)

- THANKS: add Eric Murphy

  He reported #11850 (quiche build error) but I forgot to add a
  'reported-by' entry in the fix 267e14f1.

Daniel Stenberg (18 Sep 2023)

- h2-proxy: remove left-over mistake in drain_tunnel()

  Left-over from 331b89a319

  Reported-by: 南宫雪珊

  Closes https://github.com/curl/curl/pull/11877

vvb2060 (18 Sep 2023)

- lib: failf/infof compiler warnings

  Closes #11874

Daniel Stenberg (17 Sep 2023)

- rand: fix 'alnum': array is too small to include a terminating null character

  It was that small on purpose, but this change now adds the null byte to
  avoid the error.

  Follow-up to 3aa3cc9b052353b1

  Reported-by: Dan Fandrich
  Ref: #11838
  Closes #11870

Mathias Fuchs (16 Sep 2023)

- cmake: fix the help text to the static build option in CMakeLists.txt

  Closes #11843

John Haugabook (16 Sep 2023)

- MANUAL.md: change domain to example.com

  Closes #11866

Daniel Stenberg (16 Sep 2023)

- doh: inherit DEBUGFUNCTION/DATA

  When creating new transfers for doing DoH, they now inherit the debug
  settings from the initiating transfer, so that the application can
  redirect and handle the verbose output correctly even for the DoH
  transfers.

  Reported-by: calvin2021y on github
  Fixes #11864
  Closes #11869

Dan Fandrich (16 Sep 2023)

- http_aws_sigv4: fix sorting with empty parts

  When comparing with an empty part, the non-empty one is always
  considered greater-than. Previously, the two would be considered equal
  which would randomly place empty parts amongst non-empty ones. This
  showed as a test 439 failure on Solaris as it uses a different
  implementation of qsort() that compares parts differently.

  Fixes #11855
  Closes #11868

- CI: ignore the "flaky" and "timing-dependent" test results

  CI builds will now run these tests, but will ignore the results if they
  fail. The relevant tests are ones that are sensitive to timing or
  have edge conditions that make them more likely to fail on CI servers,
  which are often heavily overloaded and slow.

  This change only adds two additional tests to be ignored, since the
  others already had the flaky keyword.

  Closes #11865

- runtests: eliminate a warning on old perl versions

  The warning "Use of implicit split to @_ is deprecated" showed between
  perl versions about 5.8 through 5.11.

- tests: log the test result code after each libtest

  This makes it easier to determine the test status. Also, capitalize
  FAILURE and ABORT messages in log lines to make them easier to spot.

Harry Sintonen (16 Sep 2023)

- misc: better random strings

  Generate alphanumerical random strings.

  Prior this change curl used to create random hex strings. This was
  mostly okay, but having alphanumerical random strings is better: The
  strings have more entropy in the same space.

  The MIME multipart boundary used to be mere 64-bits of randomness due
  to being 16 hex chars. With these changes the boundary is 22
  alphanumerical chars, or little over 130 bits of randomness.

  Closes #11838

Daniel Stenberg (15 Sep 2023)

- cookie: reduce variable scope, add const

- cookie: do not store the expire or max-age strings

  Convert it to an expire time at once and save memory.

  Closes #11862

- cookie: remove unnecessary struct fields

  Plus: reduce the hash table size from 256 to 63. It seems unlikely to
  make much of a speed difference for most use cases but saves 1.5KB of
  data per instance.

  Closes #11862

- RELEASE-NOTES: synced

  Bumped to 8.4.0, the next presumed version

Dan Fandrich (14 Sep 2023)

- test2600: remove special case handling for USE_ALARM_TIMEOUT

  This was originally added to handle platforms that supported only 1
  second granularity in connect timeouts, but after some recent changes
  the test currently permafails on several Windows platforms.

  The need for this special-case was removed in commit 8627416, which
  increased the connect timeout in all cases to well above 1 second.

  Fixes #11767
  Closes #11849

Daniel Stenberg (14 Sep 2023)

- SECURITY-PROCESS.md. call it vulnerability disclosure policy

  SECURITY-PROCESS.md -> VULN-DISCLOSURE-POLICY.md

  This a name commonly used for a document like this. This name helps
  users find it.

  Closes #11852

Junho Choi (14 Sep 2023)

- quiche: fix build error with --with-ca-fallback

  - Fix build error when curl is built with --with-quiche
    and --with-ca-fallback.

  - Add --with-ca-fallback to the quiche CI job.

  Fixes https://github.com/curl/curl/issues/11850
  Closes https://github.com/curl/curl/pull/11847

Jay Satiro (14 Sep 2023)

- escape: replace Curl_isunreserved with ISUNRESERVED

  - Use the ALLCAPS version of the macro so that it is clear a macro is
    being called that evaluates the variable multiple times.

  - Also capitalize macro isurlpuntcs => ISURLPUNTCS since it evaluates
    a variable multiple times.

  This is a follow-up to 291d225a which changed Curl_isunreserved into an
  alias macro for ISUNRESERVED. The problem is the former is not easily
  identified as a macro by the caller, which could lead to a bug.

  For example, ISUNRESERVED(*foo++) is easily identifiable as wrong but
  Curl_isunreserved(*foo++) is not even though they both are the same.

  Closes https://github.com/curl/curl/pull/11846

Dan Fandrich (13 Sep 2023)

- tests: increase the default server logs lock timeout

  This timeout is used to wait for the server to finish writing its logs
  before checking them against the expected values. An overloaded machine
  could take more than the two seconds previously allocated, so increase
  the timeout to 5 seconds.

  Ref: #11328
  Closes #11834

- tests: increase TEST_HANG_TIMEOUT in two tests

  These tests had a 5 second timeout compared to 60 seconds for all other
  tests. Make these consistent with the others for more reliability on
  heavily-loaded machines.

  Ref: #11328

- test1056: disable on Windows

  This test relies on the IPv6 scope field being ignored when connecting to
  ipv6-localhost (i.e. [::1%259999] is treated as [::1]). Maybe this is a bit
  dodgy, but it works on all our test platforms except Windows. This
  test was disabled manually on all Windows CI builds already, so instead
  add an incompatible feature and precheck so it's skipped on Windows
  everywhere automatically.

- test587: add a slight delay after test

  This test is designed to connect to the server, then immediately send a
  few bytes and disconnect. In some situations, such as on a loaded
  server, this doesn't give the server enough time to write its lock file
  before its existence is checked. The test harness then fails to find the
  server's input log file (because it hasn't been written yet) and fails
  the test. By adding a short delay after the test, the HTTP server has
  enough time to write its lock file which gives itself more time to write
  its remaining files.

  Ref: #11328

- tests: stop overriding the lock timeout

  These tests reduce the server lock wait timeout which can increase
  flakiness on loaded machines. Since this is merely an optimization,
  eliminate them in favour of reliability.

  Ref: #11328

- tests: add some --expect100-timeout to reduce timing dependencies

  These tests can fail when the test machine is so slow that the test HTTP
  server didn't get a chance to complete before the client's one second
  100-continue timeout triggered. Increase that 1 second to 999 seconds so
  this situation doesn't happen.

  Ref: #11328

- test661: return from test early in case of curl error

- tests: add the timing-dependent keyword on several tests

  These are ones likely to fail on heavily-loaded machines that alter the
  normal test timing. Most of these tests already had the flaky keyword
  since this condition makes them more likely to fail on CI.

- test1592: greatly increase the maximum test timeout

  It was too short to be reliable on heavily loaded CI machines, and
  as a fail-safe only, it didn't need to be short.

  Ref: #11328

- test: minor test cleanups

  Remove an obsolete block of code in tests 2032 & 576.
  Add a comment in test 1474.

- tests: quadruple the %FTPTIME2 and %FTPTIME3 timeouts

  This gives more of a margin for error when running on overloaded CI
  servers.

  Ref: #11328

- tests: improve SLOWDOWN test reliability by reducing sent data

  These tests are run in SLOWDOWN mode which adds a 10 msec delay after
  each character output, which means it takes at least 1.6 seconds (and
  320 kernel calls) just to get through the long welcome banner. On an
  overloaded system, this can end up taking much more than 1.6 seconds,
  and even more than the 7 or 16 second curl timeout that the tests rely
  on, causing them to fail. Reducing the size of the welcome banner drops
  the total number of characters sent before the transfer starts by more
  than half, which reduces the opportunity for test-breaking slowdowns by
  the same amount.

  Ref: #11328

- test650: fix an end tag typo

Jay Satiro (13 Sep 2023)

- tool_cb_wrt: fix debug assertion

  - Fix off-by-one out-of-bounds array index in Windows debug assertion.

  Bug: https://github.com/curl/curl/commit/af3f4e41#r127212213
  Reported-by: Gisle Vanem

Daniel Stenberg (13 Sep 2023)

- ctype: add ISUNRESERVED()

  ... and make Curl_isunreserved() use that macro instead of providing a
  separate funtion for the purpose.

  Closes #11840

Version 8.3.0 (13 Sep 2023)

Daniel Stenberg (13 Sep 2023)

- RELEASE-NOTES: syn ced

  curl 8.3.0 release

- THANKS: contributors from 8.3.0

Thorsten Klein (12 Sep 2023)

- cmake: set SIZEOF_LONG_LONG in curl_config.h

  in order to support 32bit builds regarding wolfssl CTC_SETTINGS

  Closes #11839

Jay Satiro (12 Sep 2023)

- curl_ngtcp2: fix error message

- http_aws_sigv4: handle no-value user header entries

  - Handle user headers in format 'name:' and 'name;' with no value.

  The former is used when the user wants to remove an internal libcurl
  header and the latter is used when the user actually wants to send a
  no-value header in the format 'name:' (note the semi-colon is converted
  by libcurl to a colon).

  Prior to this change the AWS header import code did not special case
  either of those and the generated AWS SignedHeaders would be incorrect.

  Reported-by: apparentorder@users.noreply.github.com

  Ref: https://curl.se/docs/manpage.html#-H

  Fixes https://github.com/curl/curl/issues/11664
  Closes https://github.com/curl/curl/pull/11668

Dan Fandrich (11 Sep 2023)

- CI: run pytest with the -v option

  This lists of the test cases being run so it can be tracked over time.

  Closes #11824

Daniel Stenberg (11 Sep 2023)

- HTTP3: the msquic backend is not functional

  I ask that we do not submit bugs for this backend just yet as we know it
  does not fully work.

  Closes #11831
  Closes #11819

- aws_sigv4: the query canon code miscounted URL encoded input

  Added some extra ampersands to test 439 to verify "blank" query parts

  Follow-up to fc76a24c53b08cdf

  Closes #11829

vvb2060 (11 Sep 2023)

- quic: don't set SNI if hostname is an IP address

  We already do this for TLS connections.

  RFC 6066 says: Literal IPv4 and IPv6 addresses are not permitted in
  "HostName".

  Ref: https://www.rfc-editor.org/rfc/rfc6066#section-3

  Fixes https://github.com/curl/curl/issues/11827
  Closes https://github.com/curl/curl/pull/11828

Daniel Stenberg (10 Sep 2023)

- RELEASE-NOTES: synced

Benoit Pierre (10 Sep 2023)

- configure: fix `HAVE_TIME_T_UNSIGNED` check

  The syntax was incorrect (need a proper main body), and the test
  condition was wrong (resulting in a signed `time_t` detected as
  unsigned).

  Closes #11825

Daniel Stenberg (9 Sep 2023)

- THANKS-filter: pszlazak on github

pszlazak (9 Sep 2023)

- include.d: explain headers not printed with --fail before 7.75.0

  Prior to 7.75.0 response headers were not printed if -f/--fail was used
  and an error was reported by server.  This was fixed in ab525c0
  (precedes 7.75.0).

  Closes #11822

Daniel Stenberg (8 Sep 2023)

- http_aws_sigv4: skip the op if the query pair is zero bytes

  Follow-up to fc76a24c53b08cdf

  Spotted by OSS-Fuzz

  Bug: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=62175
  Closes #11823

- cmdline-docs: use present tense, not future

  + some smaller cleanups

  Closes #11821

- cmdline-docs: make sure to phrase it as "added in ...."

  References to things that were added or changed in a specific version
  should be specified as "(added in [version]) for two reasons:

  1 - consistency

  2 - to allow gen.pl to strip them out if deemed referring to too old
      versions

  Closes #11821

Jay Satiro (8 Sep 2023)

- docs: mark --ssl-revoke-best-effort as Schannel specific

  Closes https://github.com/curl/curl/pull/11760

Nathan Moinvaziri (8 Sep 2023)

- schannel: fix ordering of cert chain info

  - Use CERT_CONTEXT's pbCertEncoded to determine chain order.

  CERT_CONTEXT from SECPKG_ATTR_REMOTE_CERT_CONTEXT contains
  end-entity/server certificate in pbCertEncoded. We can use this pointer
  to determine the order of certificates when enumerating hCertStore using
  CertEnumCertificatesInStore.

  This change is to help ensure that the ordering of the certificate chain
  requested by the user via CURLINFO_CERTINFO has the same ordering on all
  versions of Windows.

  Prior to this change Schannel certificate order was reversed in 8986df80
  but that was later reverted in f540a39b when it was discovered that
  Windows 11 22H2 does the reversal on its own.

  Ref: https://github.com/curl/curl/issues/9706

  Closes https://github.com/curl/curl/pull/11632

Chris Talbot (8 Sep 2023)

- digest: Use hostname to generate spn instead of realm

  In https://www.rfc-editor.org/rfc/rfc2831#section-2.1.2

  digest-uri-value should be serv-type "/" host , where host is:

        The DNS host name or IP address for the service requested.  The
        DNS host name must be the fully-qualified canonical name of the
        host. The DNS host name is the preferred form; see notes on server
        processing of the digest-uri.

  Realm may not be the host, so we must specify the host explicitly.

  Note this change only affects the non-SSPI digest code. The digest code
  used by SSPI builds already uses the hostname to generate the spn.

  Ref: https://github.com/curl/curl/issues/11369

  Closes https://github.com/curl/curl/pull/11395

Daniel Stenberg (7 Sep 2023)

- docs: remove use of the word 'very'

  It is mostly superfluous. proselint would complain.

  Closes #11818

- curl_multi_remove_handle.3: clarify what happens with connection

  Closes #11817

- RELEASE-NOTES: synced

- test439: verify query canonization for aws-sigv4

- tool_operate: make aws-sigv4 not require TLS to be used

  Maybe not used too often, but we want it for testing and it should work.

- http_aws_sigv4: canonicalize the query

  Percent encoding needs to be done using uppercase, and most
  non-alphanumerical must be percent-encoded.

  Fixes #11794
  Reported-by: John Walker
  Closes #11806

Wyatt O'Day (7 Sep 2023)

- lib: add ability to disable auths individually

  Both with configure and cmake

  Closes #11490

Stefan Eissing (7 Sep 2023)

- ngtcp2: fix handling of large requests

  - requests >64K are send in parts to the filter
  - fix parsing of the request to assemble it correctly
    from several sends
  - open a QUIC stream only when the complete request has
    been collected

  Closes #11815

- openssl: when CURLOPT_SSL_CTX_FUNCTION is registered, init x509 store before

  - we delay loading the x509 store to shorten the handshake time.
    However an application callback installed via CURLOPT_SSL_CTX_FUNCTION
    may need to have the store loaded and try to manipulate it.
  - load the x509 store before invoking the app callback

  Fixes #11800
  Reported-by: guoxinvmware on github
  Cloes #11805

Daniel Stenberg (7 Sep 2023)

- krb5: fix "implicit conversion loses integer precision" warnings

  conversions to/from enum and unsigned chars

  Closes #11814

Stefan Eissing (7 Sep 2023)

- pytest: improvements

  - set CURL_CI for pytest runs in CI environments
  - exclude timing sensitive tests from CI runs
  - for failed results, list only the log and stat of
    the failed transfer

  - fix type in http.c comment

  Closes #11812

- CI: move on to ngtcp2 v0.19.1

  Closes #11809

Dan Fandrich (5 Sep 2023)

- CI: run Circle macOS builds on x86 for now

  The ARM machines aren't ready for us and requesting them now causes
  warnings e-mails to be sent to some PR pushers.

  Ref: #11771

Viktor Szakats (5 Sep 2023)

- http3: adjust cast for ngtcp2 v0.19.0

  ngtcp2 v0.19.0 made size of `ecn` member of `ngtcp2_pkt_info`
  an `uint8_t` (was: `uint32_t`). Adjust our local cast accordingly.

  Fixes:
  ```
  ./curl/lib/vquic/curl_ngtcp2.c:1912:12: warning: implicit conversion loses in
  teger precision: 'uint32_t' (aka 'unsigned int') to 'uint8_t' (aka 'unsigned 
  char') [-Wimplicit-int-conversion]
    pi.ecn = (uint32_t)ecn;
           ~ ^~~~~~~~~~~~~
  ```

  Also bump ngtcp2, nghttp3 and nghttp2 to their latest versions in our
  docs and CI.

  Ref: https://github.com/ngtcp2/ngtcp2/commit/80447281bbc94af53f8aa7a4cfc19175
  782894a3
  Ref: https://github.com/ngtcp2/ngtcp2/pull/877
  Closes #11798

Stefan Eissing (5 Sep 2023)

- http: fix sending of large requests

  - refs #11342 where errors with git https interactions
    were observed
  - problem was caused by 1st sends of size larger than 64KB
    which resulted in later retries of 64KB only
  - limit sending of 1st block to 64KB
  - adjust h2/h3 filters to cope with parsing the HTTP/1.1
    formatted request in chunks

  - introducing Curl_nwrite() as companion to Curl_write()
    for the many cases where the sockindex is already known

  Fixes #11342 (again)
  Closes #11803

- pytest: fix check for slow_network skips to only apply when intended

  Closes #11801

Daniel Stenberg (5 Sep 2023)

- curl_url_get/set.3: add missing semicolon in SYNOPSIS

- CURLOPT_URL.3: explain curl_url_set() uses the same parser

- CURLOPT_URL.3: add two URL API calls in the see-also section

Dan Fandrich (4 Sep 2023)

- CI: add a 32-bit i686 Linux build

  This is done by cross-compiling under regular x86_64 Linux.  Since the
  kernel offers backwards compatibility, the binaries can be tested as
  normal.

  Closes #11799

- tests: fix a type warning on 32-bit x86

Viktor Szakats (4 Sep 2023)

- tests: delete stray `.orig` file

  Follow-up to 331b89a319d0067fa1e6441719307cfef9c7960f
  Closes #11797

Daniel Stenberg (4 Sep 2023)

- RELEASE-NOTES: synced

Viktor Szakats (4 Sep 2023)

- lib: silence compiler warning in inet_ntop6

  ```
  ./curl/lib/inet_ntop.c:121:21: warning: possible misuse of comma operator her
  e [-Wcomma]
          cur.base = i, cur.len = 1;
                      ^
  ./curl/lib/inet_ntop.c:121:9: note: cast expression to void to silence warnin
  g
          cur.base = i, cur.len = 1;
          ^~~~~~~~~~~~
          (void)(     )
  ```

  Closes #11790

Daniel Stenberg (4 Sep 2023)

- transfer: also stop the sending on closed connection

  Previously this cleared the receiving bit only but in some cases it is
  also still sending (like a request-body) when disconnected and neither
  direction can continue then.

  Fixes #11769
  Reported-by: Oleg Jukovec
  Closes #11795

John Bampton (4 Sep 2023)

- docs: change `sub-domain` to `subdomain`

  https://en.wikipedia.org/wiki/Subdomain

  Closes #11793

Stefan Eissing (4 Sep 2023)

- multi: more efficient pollfd count for poll

  - do not use separate pollfds for sockets that have POLLIN+POLLOUT

  Closes #11792

- http2: polish things around POST

  - added test cases for various code paths
  - fixed handling of blocked write when stream had
    been closed inbetween attempts
  - re-enabled DEBUGASSERT on send with smaller data size

  - in debug builds, environment variables can be set to simulate a slow
    network when sending data. cf-socket.c and vquic.c support
    * CURL_DBG_SOCK_WBLOCK: percentage of send() calls that should be
      answered with a EAGAIN. TCP/UNIX sockets.
      This is chosen randomly.
    * CURL_DBG_SOCK_WPARTIAL: percentage of data that shall be written
      to the network. TCP/UNIX sockets.
      Example: 80 means a send with 1000 bytes would only send 800
      This is applied to every send.
    * CURL_DBG_QUIC_WBLOCK: percentage of send() calls that should be
      answered with EAGAIN. QUIC only.
      This is chosen randomly.

  Closes #11756

Daniel Stenberg (4 Sep 2023)

- docs: add curl_global_trace to some SEE ALSO sections

  Closes #11791

- os400: fix checksrc nits

  Closes #11789

Nicholas Nethercote (3 Sep 2023)

- hyper: remove `hyptransfer->endtask`

  `Curl_hyper_stream` needs to distinguish between two kinds of
  `HYPER_TASK_EMPTY` tasks: (a) the `foreach` tasks it creates itself, and
  (b) background tasks that hyper produces. It does this by recording the
  address of any `foreach` task in `hyptransfer->endtask` before pushing
  it into the executor, and then comparing that against the address of
  tasks later polled out of the executor.

  This works right now, but there is no guarantee from hyper that the
  addresses are stable. `hyper_executor_push` says "The executor takes
  ownership of the task, which should not be accessed again unless
  returned back to the user with `hyper_executor_poll`". That wording is a
  bit ambiguous but with my Rust programmer's hat on I read it as meaning
  the task returned with `hyper_executor_poll` may be conceptually the
  same as a task that was pushed, but that there are no other guarantees
  and comparing addresses is a bad idea.

  This commit instead uses `hyper_task_set_userdata` to mark the `foreach`
  task with a `USERDATA_RESP_BODY` value which can then be checked for,
  removing the need for `hyptransfer->endtask`. This makes the code look
  more like that hyper C API examples, which use userdata for every task
  and never look at task addresses.

  Closes #11779

Dave Cottlehuber (3 Sep 2023)

- ws: fix spelling mistakes in examples and tests

  Closes #11784

Daniel Stenberg (3 Sep 2023)

- tool_filetime: make -z work with file dates before 1970

  Fixes #11785
  Reported-by: Harry Sintonen
  Closes #11786

Dan Fandrich (1 Sep 2023)

- build: fix portability of mancheck and checksrc targets

  At least FreeBSD preserves cwd across makefile lines, so rules
  consisting of more than one "cd X; do_something" must be explicitly run
  in a subshell to avoid this. This problem caused the Cirrus FreeBSD
  build to fail when parallel make jobs were enabled.

- CI: adjust labeler match patterns for new & obsolete files

- configure: trust pkg-config when it's used for zlib

  The library flags retrieved from pkg-config were later thrown out and
  harded-coded, which negates the whole reason to use pkg-config.
  Also, previously, the assumption was made that --libs-only-l and
  --libs-only-L are the full decomposition of --libs, which is untrue and
  would not allow linking against a static zlib. The new approach is
  better in that it uses --libs, although only if --libs-only-l returns
  nothing.

  Bug: https://curl.se/mail/lib-2023-08/0081.html
  Reported-by: Randall
  Closes #11778

Stefan Eissing (1 Sep 2023)

- CI/ngtcp2: clear wolfssl for when cache is ignored

  Closes #11783

Daniel Stenberg (1 Sep 2023)

- RELEASE-NOTES: synced

Nicholas Nethercote (1 Sep 2023)

- hyper: fix a progress upload counter bug

  `Curl_pgrsSetUploadCounter` should be a passed a total count, not an
  increment.

  This changes the failing diff for test 579 with hyper from this:
  ```
   Progress callback called with UL 0 out of 0[LF]
  -Progress callback called with UL 8 out of 0[LF]
  -Progress callback called with UL 16 out of 0[LF]
  -Progress callback called with UL 26 out of 0[LF]
  -Progress callback called with UL 61 out of 0[LF]
  -Progress callback called with UL 66 out of 0[LF]
  +Progress callback called with UL 29 out of 0[LF]
  ```
  to this:
  ```
   Progress callback called with UL 0 out of 0[LF]
  -Progress callback called with UL 8 out of 0[LF]
  -Progress callback called with UL 16 out of 0[LF]
  -Progress callback called with UL 26 out of 0[LF]
  -Progress callback called with UL 61 out of 0[LF]
  -Progress callback called with UL 66 out of 0[LF]
  +Progress callback called with UL 40 out of 0[LF]
  ```
  Presumably a step in the right direction.

  Closes #11780

Daniel Stenberg (1 Sep 2023)

- awssiv4: avoid freeing the date pointer on error

  Since it was not allocated, don't free it even if it was wrong syntax

  Bug: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=61908

  Follow-up to b137634ba3adb

  Closes #11782

Stefan Eissing (1 Sep 2023)

- CI: ngtcp2-linux: use separate caches for tls libraries

  allow ever changing master for wolfssl

  Closes #11766

- replace `master` as wolfssl-version with recent commit

- wolfssl, use master again in CI

  - with the shared session update fix landed in master, it
    is time to use that in our CI again

Nicholas Nethercote (31 Aug 2023)

- tests: fix formatting errors in `FILEFORMAT.md`.

  Without the surrounding backticks, these tags get swallowed when the
  markdown is rendered.

  Closes #11777

Viktor Szakats (31 Aug 2023)

- cmake: add support for `CURL_DEFAULT_SSL_BACKEND`

  Allow overriding the default TLS backend via a CMake setting.

  E.g.:
  `cmake [...] -DCURL_DEFAULT_SSL_BACKEND=mbedtls`

  Accepted values: bearssl, gnutls, mbedtls, openssl, rustls,
  schannel, secure-transport, wolfssl

  The passed string is baked into the curl/libcurl binaries.
  The value is case-insensitive.

  We added a similar option to autotools in 2017 via
  c7170e20d0a18ec8a514b4daa53bcdbb4dcb3a05.

  TODO: Convert to lowercase to improve reproducibility.

  Closes #11774

- sectransp: fix compiler warnings

  https://github.com/curl/curl-for-win/actions/runs/6037489221/job/16381860220#
  step:3:11046
  ```
  /Users/runner/work/curl-for-win/curl-for-win/curl/lib/vtls/sectransp.c:2435:1
  4: warning: unused variable 'success' [-Wunused-variable]
      OSStatus success;
               ^
  /Users/runner/work/curl-for-win/curl-for-win/curl/lib/vtls/sectransp.c:3300:4
  4: warning: unused parameter 'sha256len' [-Wunused-parameter]
                                      size_t sha256len)
                                             ^
  ```

  Closes #11773

- tidy-up: mostly whitespace nits

  - delete completed TODO from `./CMakeLists.txt`.
  - convert a C++ comment to C89 in `./CMake/CurlTests.c`.
  - delete duplicate EOLs from EOF.
  - add missing EOL at EOF.
  - delete whitespace at EOL (except from expected test results).
  - convert tabs to spaces.
  - convert CRLF EOLs to LF in GHA yaml.
  - text casing fixes in `./CMakeLists.txt`.
  - fix a codespell typo in `packages/OS400/initscript.sh`.

  Closes #11772

Dan Fandrich (31 Aug 2023)

- CI: remove Windows builds from Cirrus, without replacement

  If we don't do this, all coverage on Cirrus will cease in a few days. By
  removing the Windows builds, the FreeBSD one should still continue
  as before. The Windows builds will need be moved to another service to
  maintain test coverage.

  Closes #11771

- CI: switch macOS ARM build from Cirrus to Circle CI

  Cirrus is drastically reducing their free tier on Sept. 1, so they will
  no longer perform all these builds for us. All but one build has been
  moved, with the LibreSSL one being dropped because of linking problems
  on Circle.

  One important note about this change is that Circle CI is currently
  directing all these builds to x86_64 hardware, despite them requesting
  ARM. This is because ARM nodes are scheduled to be available on the
  free tier only in December. This reduces our architectural diversity
  until then but it should automatically come back once those machines are
  enabled.

- CI: use the right variable for BSD make

  BSD uses MAKEFLAGS instead of MAKE_FLAGS so it wasn't doing parallel
  builds before.

- CI: drop the FreeBSD 12.X build

  Cirrus' new free tier won't let us have many builds, so drop the
  nonessential ones. The FreeBSD 13.X build will still give us the most
  relevant FreeBSD coverage.

- CI: move the Alpine build from Cirrus to GHA

  Cirrus is reducing their free tier to next to nothing, so we must move
  builds elsewhere.

Stefan Eissing (30 Aug 2023)

- test_07_upload.py: fix test_07_34 curl args

  - Pass correct filename to --data-binary.

  Prior to this change --data-binary was passed an incorrect filename due
  to a missing separator in the arguments list. Since aacbeae7 curl will
  error on incorrect filenames for POST.

  Fixes https://github.com/curl/curl/issues/11761
  Closes https://github.com/curl/curl/pull/11763

Nicholas Nethercote (30 Aug 2023)

- tests: document which tests fail due to hyper's lack of trailer support.

  Closes #11762

- docs: removing "pausing transfers" from HYPER.md.

  It's a reference to #8600, which was fixed by #9070.

  Closes #11764

Patrick Monnerat (30 Aug 2023)

- os400: handle CURL_TEMP_PRINTF() while building bind source

  Closes #11547

- os400: build test servers

  Also fix a non-compliant main prototype in disabled.c.

  Closes #11547

- tests: fix compilation error for os400

  OS400 uses BSD 4.3 setsockopt() prototype by default: this does not
  define parameter as const, resulting in an error if actual parameter is
  const. Remove the const keyword from the actual parameter cast: this
  works in all conditions, even if the formal parameter uses it.

  Closes #11547

- os400: make programs and command name configurable

  Closes #11547

- os400: move build configuration parameters to a separate script

  They can then easily be overriden in a script named "config400.override"
  that is not part of the distribution.

  Closes #11547

- os400: implement CLI tool

  This is provided as a QADRT (ascii) program, a link to it in the IFS and
  a minimal CL command.

  Closes #11547

Matthias Gatto (30 Aug 2023)

- lib: fix aws-sigv4 having date header twice in some cases

  When the user was providing the header X-XXX-Date, the header was
  re-added during signature computation, and we had it twice in the
  request.

  Reported-by: apparentorder@users.noreply.github.com

  Signed-off-by: Matthias Gatto <matthias.gatto@outscale.com>

  Fixes: https://github.com/curl/curl/issues/11738
  Closes: https://github.com/curl/curl/pull/11754

Jay Satiro (30 Aug 2023)

- multi: remove 'processing: <url>' debug message

  - Remove debug message added by e024d566.

  Closes https://github.com/curl/curl/pull/11759

- ftp: fix temp write of ipv6 address

  - During the check to differentiate between a port and IPv6 address
    without brackets, write the binary IPv6 address to an in6_addr.

  Prior to this change the binary IPv6 address was erroneously written to
  a sockaddr_in6 'sa6' when it should have been written to its in6_addr
  member 'sin6_addr'. There's no fallout because no members of 'sa6' are
  accessed before it is later overwritten.

  Closes https://github.com/curl/curl/pull/11747

- tool: change some fopen failures from warnings to errors

  - Error on missing input file for --data, --data-binary,
    --data-urlencode, --header, --variable, --write-out.

  Prior to this change if a user of the curl tool specified an input file
  for one of the above options and that file could not be opened then it
  would be treated as zero length data instead of an error. For example, a
  POST using `--data @filenametypo` would cause a zero length POST which
  is probably not what the user intended.

  Closes https://github.com/curl/curl/pull/11677

- hostip: fix typo

Davide Masserut (29 Aug 2023)

- tool: avoid including leading spaces in the Location hyperlink

  Co-authored-by: Dan Fandrich <dan@coneharvesters.com>

  Closes #11735

Daniel Stenberg (29 Aug 2023)

- SECURITY-PROCESS.md: not a sec issue: Tricking user to run a cmdline

  Closes #11757

- connect: stop halving the remaining timeout when less than 600 ms left

  When curl wants to connect to a host, it always has a TIMEOUT. The
  maximum time it is allowed to spend until a connect is confirmed.

  curl will try to connect to each of the IP adresses returned for the
  host. Two loops, one for each IP family.

  During the connect loop, while curl has more than one IP address left to
  try within a single address family, curl has traditionally allowed (time
  left/2) for *this* connect attempt. This, to not get stuck on the
  initial addresses in case the timeout but still allow later addresses to
  get attempted.

  This has the downside that when users set a very short timeout and the
  host has a large number of IP addresses, the effective result might be
  that every attempt gets a little too short time.

  This change stop doing the divided-by-two if the total time left is
  below a threshold. This threshold is 600 milliseconds.

  Closes #11693

- asyn-ares: reduce timeout to 2000ms

  When UDP packets get lost this makes for slightly faster retries. This
  lower timeout is used by @c-ares itself by default starting next
  release.

  Closes #11753

John Bampton (29 Aug 2023)

- misc: remove duplicate words

  Closes #11740

Daniel Stenberg (29 Aug 2023)

- RELEASE-NOTES: synced

- wolfSSL: avoid the OpenSSL compat API when not needed

  ... and instead call wolfSSL functions directly.

  Closes #11752

Viktor Szakats (28 Aug 2023)

- lib: fix null ptr derefs and uninitialized vars (h2/h3)

  Fixing compiler warnings with gcc 13.2.0 in unity builds.

  Assisted-by: Jay Satiro
  Assisted-by: Stefan Eissing
  Closes #11739

Jay Satiro (28 Aug 2023)

- secureserver.pl: fix stunnel version parsing

  - Allow the stunnel minor-version version part to be zero.

  Prior to this change with the stunnel version scheme of <major>.<minor>
  if either part was 0 then version parsing would fail, causing
  secureserver.pl to fail with error "No stunnel", causing tests that use
  the SSL protocol to be skipped. As a practical matter this bug can only
  be caused by a minor-version part of 0, since the major-version part is
  always greater than 0.

  Closes https://github.com/curl/curl/pull/11722

- secureserver.pl: fix stunnel path quoting

  - Store the stunnel path in the private variable $stunnel unquoted and
    instead quote it in the command strings.

  Prior to this change the quoted stunnel path was passed to perl's file
  operators which cannot handle quoted paths. For example:

  $stunnel = "\"/C/Program Files (x86)/stunnel/bin/tstunnel\"";
  if(-x $stunnel or -x "$stunnel")
  # false even if path exists and is executable

  Our other test scripts written in perl, unlike this one, use servers.pm
  which has a global $stunnel variable with the path stored unquoted and
  therefore those scripts don't have this problem.

  Closes https://github.com/curl/curl/pull/11721

Daniel Stenberg (28 Aug 2023)

- altsvc: accept and parse IPv6 addresses in response headers

  Store numerical IPv6 addresses in the alt-svc file with the brackets
  present.

  Verify with test 437 and 438

  Fixes #11737
  Reported-by: oliverpool on github
  Closes #11743

- libtest: use curl_free() to free libcurl allocated data

  In several test programs. These mistakes are not detected or a problem
  as long as memdebug.h is included, as that provides the debug wrappers
  for all memory functions in the same style libcurl internals do it,
  which makes curl_free and free effectively the same call.

  Reported-by: Nicholas Nethercote
  Closes #11746

Jay Satiro (28 Aug 2023)

- disable.d: explain --disable not implemented prior to 7.50.0

  Option -q/--disable was added in 5.0 but only -q was actually
  implemented. Later --disable was implemented in e200034 (precedes
  7.49.0), but incorrectly, and fixed in 6dbc23c (precedes 7.50.0).

  Reported-by: pszlazak@users.noreply.github.com

  Fixes https://github.com/curl/curl/issues/11710
  Closes #11712

Nicholas Nethercote (28 Aug 2023)

- hyper: fix ownership problems

  Some of these changes come from comparing `Curl_http` and
  `start_CONNECT`, which are similar, and adding things to them that are
  present in one and missing in another.

  The most important changes:
  - In `start_CONNECT`, add a missing `hyper_clientconn_free` call on the
    happy path.
  - In `start_CONNECT`, add a missing `hyper_request_free` on the error
    path.
  - In `bodysend`, add a missing `hyper_body_free` on an early-exit path.
  - In `bodysend`, remove an unnecessary `hyper_body_free` on a different
    error path that would cause a double-free.
    https://docs.rs/hyper/latest/hyper/ffi/fn.hyper_request_set_body.html
    says of `hyper_request_set_body`: "This takes ownership of the
    hyper_body *, you must not use it or free it after setting it on the
    request." This is true even if `hyper_request_set_body` returns an
    error; I confirmed this by looking at the hyper source code.

  Other changes are minor but make things slightly nicer.

  Closes #11745

Daniel Stenberg (28 Aug 2023)

- multi.h: the 'revents' field of curl_waitfd is supported

  Since 6d30f8ebed34e7276

  Reported-by: Nicolás Ojeda Bär
  Ref: #11748
  Closes #11749

Gerome Fournier (27 Aug 2023)

- tool_paramhlp: improve str2num(): avoid unnecessary call to strlen()

  Closes #11742

Daniel Stenberg (27 Aug 2023)

- docs: mention critical files in same directories as curl saves

  ... cannot be fully protected. Don't do it.

  Co-authored-by: Jay Satiro
  Reported-by: Harry Sintonen
  Fixes #11530
  Closes #11701

John Hawthorn (26 Aug 2023)

- OpenSSL: clear error queue after SSL_shutdown

  We've seen errors left in the OpenSSL error queue (specifically,
  "shutdown while in init") by adding some logging it revealed that the
  source was this file.

  Since we call SSL_read and SSL_shutdown here, but don't check the return
  code for an error, we should clear the OpenSSL error queue in case one
  was raised.

  This didn't affect curl because we call ERR_clear_error before every
  write operation (a0dd9df9ab35528eb9eb669e741a5df4b1fb833c), but when
  libcurl is used in a process with other OpenSSL users, they may detect
  an OpenSSL error pushed by libcurl's SSL_shutdown as if it was their
  own.

  Co-authored-by: Satana de Sant'Ana <satana@skylittlesystem.org>

  Closes #11736

Alexander Kanavin (25 Aug 2023)

- tests: update cookie expiry dates to far in the future

  This allows testing Y2038 with system time set to after that, so that
  actual Y2038 issues can be exposed, and not masked by expiry errors.

  Fixes #11576
  Closes #11610

John Bampton (25 Aug 2023)

- misc: fix spelling

  Closes #11733

Daniel Stenberg (25 Aug 2023)

- cmdline-opts/page-header: clarify stronger that !opt == URL

  Everything provided on the command line that is not an option (or an
  argument to an option) is treated as a URL.

  Closes #11734

- tests/runner: fix %else handling

  Getting the show state proper for %else and %endif did not properly work
  in nested cases.

  Follow-up to 3d089c41ea9

  Closes #11731

Nicholas Nethercote (25 Aug 2023)

- docs: Remove mention of #10803 from `KNOWN_BUGS`.

  Because the leaks have been fixed.

- c-hyper: fix another memory leak in `Curl_http`.

  There is a `hyper_clientconn_free` call on the happy path, but not one
  on the error path. This commit adds one.

  Fixes the second memory leak reported by Valgrind in #10803.

  Fixes #10803
  Closes #11729

- c-hyper: fix a memory leak in `Curl_http`.

  A request created with `hyper_request_new` must be consumed by either
  `hyper_clientconn_send` or `hyper_request_free`.

  This is not terrifically clear from the hyper docs --
  `hyper_request_free` is documented only with "Free an HTTP request if
  not going to send it on a client" -- but a perusal of the hyper code
  confirms it.

  This commit adds a `hyper_request_free` to the `error:` path in
  `Curl_http` so that the request is consumed when an error occurs after
  the request is created but before it is sent.

  Fixes the first memory leak reported by Valgrind in #10803.

  Closes #11729

Daniel Stenberg (25 Aug 2023)

- RELEASE-NOTES: synced

John Bampton (25 Aug 2023)

- misc: spellfixes

  Closes #11730

Daniel Stenberg (25 Aug 2023)

- tests: add support for nested %if conditions

  Provides more flexiblity to test cases.

  Also warn and bail out if there is an '%else' or %endif' without a
  preceeding '%if'.

  Ref: #11610
  Closes #11728

- time-cond.d: mention what happens on a missing file

  Closes #11727

Christian Hesse (24 Aug 2023)

- docs/cmdline-opts: match the current output

  The release date has been added in output, reflect that in documentation.

  Closes #11723

Daniel Stenberg (24 Aug 2023)

- lib: minor comment corrections

- docs: rewrite to present tense

  ... instead of using future tense.

  + numerous cleanups and improvements
  + stick to "reuse" not "re-use"
  + fewer contractions

  Closes #11713

- urlapi: setting a blank URL ("") is not an ok URL

  Test it in 1560
  Fixes #11714
  Reported-by: ad0p on github
  Closes #11715

- spelling: use 'reuse' not 're-use' in code and elsewhere

  Unify the spelling as both versions were previously used intermittently

  Closes #11717

Michael Osipov (23 Aug 2023)

- system.h: add CURL_OFF_T definitions on HP-UX with HP aCC

  HP-UX on IA64 provides two modes: 32 and 64 bit while 32 bit being the
  default one. Use "long long" in 32 bit mode and just "long" in 64 bit
  mode.

  Closes #11718

Dan Fandrich (22 Aug 2023)

- tests: don't call HTTP errors OK in test cases

  Some HTTP errors codes were accompanied by the text OK, which causes
  some cognitive dissonance when reading them.

- http: close the connection after a late 417 is received

  In this situation, only part of the data has been sent before aborting
  so the connection is no longer usable.

  Assisted-by: Jay Satiro
  Fixes #11678
  Closes #11679

- runtests: slightly increase the longest log file displayed

  The new limit provides enough space for a 64 KiB data block to be logged
  in a trace file, plus a few lines at the start and end for context. This
  happens to be the amount of data sent at a time in a PUT request.

- tests: add delay command to the HTTP server

  This adds a delay after client connect.

Daniel Stenberg (22 Aug 2023)

- cirrus: install everthing with pkg, avoid pip

  Assisted-by: Sevan Janiyan

  Closes #11711

- curl_url*.3: update function descriptions

  - expand and clarify several descriptions
  - avoid using future tense all over

  Closes #11708

- RELEASE-NOTES: synced

Stefan Eissing (21 Aug 2023)

- CI/cirrus: disable python install on FreeBSD

  - python cryptography package does not build build FreeBSD
  - install just mentions "error"
  - this gets the build and the main test suite going again

  Closes #11705

- test2600: fix flakiness on low cpu

  - refs #11355 where failures to to low cpu resources in CI
    are reported
  - vastly extend CURLOPT_CONNECTTIMEOUT_MS and max durations
    to test cases
  - trigger Curl_expire() in test filter to allow re-checks before
    the usual 1second interval

  Closes #11690

Maksim Sciepanienka (20 Aug 2023)

- tool_urlglob: use the correct format specifier for curl_off_t in msnprintf

  Closes #11698

Daniel Stenberg (20 Aug 2023)

- test687/688: two more basic --xattr tests

  Closes #11697

- cmdline-opts/docs: mentioned the negative option part

  ... for --no-alpn and --no-buffer in the same style done for other --no-
  options:

  "Note that this is the negated option name documented."

  Closes #11695

Emanuele Torre (19 Aug 2023)

- tool/var: also error when expansion result starts with NUL

  Expansions whose output starts with NUL were being expanded to the empty
  string, and not being recognised as values that contain a NUL byte, and
  should error.

  Closes #11694

Daniel Stenberg (19 Aug 2023)

- tests: add 'large-time' as a testable feature

  This allows test cases to require this feature to run and to be used in
  %if conditions.

  Large here means larger than 32 bits. Ie does not suffer from y2038.

  Closes #11696

- tests/Makefile: add check-translatable-options.pl to tarball

  Used in test 1544

  Follow-up to ae806395abc8c

- gen.pl: fix a long version generation mistake

  Too excessive escaping made the parsing not find the correct long names
  later and instead add "wrong" links.

  Follow-up to 439ff2052e219

  Reported-by: Lukas Tribus
  Fixes #11688
  Closes #11689

- lib: move mimepost data from ->req.p.http to ->state

  When the legacy CURLOPT_HTTPPOST option is used, it gets converted into
  the modem mimpost struct at first use. This data is (now) kept for the
  entire transfer and not only per single HTTP request. This re-enables
  rewind in the beginning of the second request instead of in end of the
  first, as brought by 1b39731.

  The request struct is per-request data only.

  Extend test 650 to verify.

  Fixes #11680
  Reported-by: yushicheng7788 on github
  Closes #11682

Patrick Monnerat (17 Aug 2023)

- os400: do not check translatable options at build time

  Now that there is a test for this, the build time check is not needed
  anymore.

  Closes #11650

- test1554: check translatable string options in OS400 wrapper

  This test runs a perl script that checks all string options are properly
  translated by the OS400 character code conversion wrapper. It also
  verifies these options are listed in alphanumeric order in the wrapper
  switch statement.

  Closes #11650

Daniel Stenberg (17 Aug 2023)

- unit3200: skip testing if function is not present

  Fake a successful run since we have no easy mechanism to skip this test
  for this advanced condition.

- unit2600: fix build warning if built without verbose messages

- test1608: make it build and get skipped without shuffle DNS support

- lib: --disable-bindlocal builds curl without local binding support

- test1304: build and skip without netrc support

- lib: build fixups when built with most things disabled

  Closes #11687

- workflows/macos.yml: disable zstd and alt-svc in the http-only build

  Closes #11683

Stefan Eissing (17 Aug 2023)

- bearssl: handshake fix, provide proper get_select_socks() implementation

  - bring bearssl handshake times down from +200ms down to other TLS backends
  - vtls: improve generic get_select_socks() implementation
  - tests: provide Apache with a suitable ssl session cache

  Closes #11675

- tests: TLS session sharing test

  - test TLS session sharing with special test client
  - expect failure with wolfSSL
  - disable flaky wolfSSL test_02_07b

  Closes #11675

Daniel Stenberg (17 Aug 2023)

- CURLOPT_*TIMEOUT*: extend and clarify

  Closes #11686

- urlapi: return CURLUE_BAD_HOSTNAME if puny2idn encoding fails

  And document it. Only return out of memory when it actually is a memory
  problem.

  Pointed-out-by: Jacob Mealey
  Closes #11674

Mathew Benson (17 Aug 2023)

- cmake: add GnuTLS option

  - Option to use GNUTLS was missing. Hence was not able to use GNUTLS
    with ngtcp2 for http3.

  Closes #11685

Daniel Stenberg (16 Aug 2023)

- RELEASE-NOTES: synced

- http: remove the p_pragma struct field

  unused since 40e8b4e52 (2008)

  Closes #11681

Jay Satiro (16 Aug 2023)

- CURLINFO_CERTINFO.3: better explain curl_certinfo struct

  Closes https://github.com/curl/curl/pull/11666

- CURLINFO_TLS_SSL_PTR.3: clarify a recommendation

  - Remove the out-of-date SSL backend list supported by
    CURLOPT_SSL_CTX_FUNCTION.

  It makes more sense to just refer to that document instead of having
  a separate list that has to be kept in sync.

  Closes https://github.com/curl/curl/pull/11665

- write-out.d: clarify %{time_starttransfer}

  sync it up with CURLINFO_STARTTRANSFER_TIME_T

Daniel Stenberg (15 Aug 2023)

- transfer: don't set TIMER_STARTTRANSFER on first send

  The time stamp is for measuring the first *received* byte

  Fixes #11669
  Reported-by: JazJas on github
  Closes #11670

trrui-huawei (15 Aug 2023)

- quiche: enable quiche to handle timeout events

  In parallel with ngtcp2, quiche also offers the `quiche_conn_on_timeout`
  interface for the application to invoke upon timer
  expiration. Therefore, invoking the `on_timeout` function of the
  Connection is crucial to ensure seamless functionality of quiche with
  timeout events.

  Closes #11654

- quiche: adjust quiche `QUIC_IDLE_TIMEOUT` to 60s

  Set the `QUIC_IDLE_TIMEOUT` parameter to match ngtcp2 for consistency.

Daniel Stenberg (15 Aug 2023)

- KNOWN_BUGS: LDAPS requests to ActiveDirectory server hang

  Closes #9580

- imap: add a check for failing strdup()

- imap: remove the only sscanf() call in the IMAP code

  Avoids the use of a stack buffer.

  Closes #11673

- imap: use a dynbuf in imap_atom

  Avoid a calculation + malloc. Build the output in a dynbuf.

  Closes #11672

Marin Hannache (14 Aug 2023)

- http: do not require a user name when using CURLAUTH_NEGOTIATE

  In order to get Negotiate (SPNEGO) authentication to work in HTTP you
  used to be required to provide a (fake) user name (this concerned both
  curl and the lib) because the code wrongly only considered
  authentication if there was a user name provided, as in:

    curl -u : --negotiate https://example.com/

  This commit leverages the `struct auth` want member to figure out if the
  user enabled CURLAUTH_NEGOTIATE, effectively removing the requirement of
  setting a user name both in curl and the lib.

  Signed-off-by: Marin Hannache <git@mareo.fr>
  Reported-by: Enrico Scholz
  Fixes https://sourceforge.net/p/curl/bugs/440/
  Fixes #1161
  Closes #9047

Viktor Szakats (13 Aug 2023)

- build: streamline non-UWP wincrypt detections

  - with CMake, use the variable `WINDOWS_STORE` to detect an UWP build
    and disable our non-UWP-compatible use the Windows crypto API. This
    allows to drop two dynamic feature checks.

    `WINDOWS_STORE` is true when invoking CMake with
    `CMAKE_SYSTEM_NAME` == `WindowsStore`. Introduced in CMake v3.1.

    Ref: https://cmake.org/cmake/help/latest/variable/WINDOWS_STORE.html

  - with autotools, drop the separate feature check for `wincrypt.h`. On
    one hand this header has been present for long (even Borland C 5.5 had
    it from year 2000), on the other we used the check result solely to
    enable another check for certain crypto functions. This fails anyway
    with the header not present. We save one dynamic feature check at the
    configure stage.

  Reviewed-by: Marcel Raad
  Closes #11657

Nicholas Nethercote (13 Aug 2023)

- docs/HYPER.md: update hyper build instructions

  Nightly Rust and `-Z unstable-options` are not needed.

  The instructions here now match the hyper docs exactly:
  https://github.com/hyperium/hyper/commit/bd7928f3dd6a8461f0f0fdf7ee0fd95c2f15
  6f88

  Closes #11662

Daniel Stenberg (13 Aug 2023)

- RELEASE-NOTES: synced

- urlapi: CURLU_PUNY2IDN - convert from punycode to IDN name

  Asssisted-by: Jay Satiro
  Closes #11655

- spellcheck: adapt to backslashed minuses

  As the curl.1 has more backslashed minus, the cleanup sed lines xneed to
  adapt.

  Adjusted some docs slighly.

  Follow-up to 439ff2052e

  Closes #11663

- gen: escape more minus

  Detected since it was still hard to search for option names using dashes
  in the middle in the man page.

  Closes #11660

- cookie-jar.d: enphasize that this option is ONLY writing cookies

  Reported-by: Dan Jacobson
  Tweaked-by: Jay Satiro
  Ref: #11642
  Closes #11661

Nicholas Nethercote (11 Aug 2023)

- docs/HYPER.md: document a workaround for a link error

  Closes #11653

Jay Satiro (11 Aug 2023)

- schannel: verify hostname independent of verify cert

  Prior to this change when CURLOPT_SSL_VERIFYPEER (verifypeer) was off
  and CURLOPT_SSL_VERIFYHOST (verifyhost) was on we did not verify the
  hostname in schannel code.

  This fixes KNOWN_BUG 2.8 "Schannel disable CURLOPT_SSL_VERIFYPEER and
  verify hostname". We discussed a fix several years ago in #3285 but it
  went stale.

  Assisted-by: Daniel Stenberg

  Bug: https://curl.haxx.se/mail/lib-2018-10/0113.html
  Reported-by: Martin Galvan

  Ref: https://github.com/curl/curl/pull/3285

  Fixes https://github.com/curl/curl/issues/3284
  Closes https://github.com/curl/curl/pull/10056

Daniel Stenberg (11 Aug 2023)

- curl_quiche: remove superfluous NULL check

  'stream' is always non-NULL at this point

  Pointed out by Coverity

  Closes #11656

- curl/urlapi.h: tiny typo

- github/labeler: make HYPER.md set Hyper and not TLS

- docs/cmdline-opts/gen.pl: hide "added in" before 7.50.0

  7.50.0 shipped on Jul 21 2016, over seven years ago. We no longer need
  to specify version changes for earlier releases in the generated output.

  This ups the limit from the previous 7.30.0 (Apr 12 2013)

  This hides roughly 35 "added in" mentions.

  Closes #11651

Jay Satiro (10 Aug 2023)

- bug_report: require reporters to specify curl and os versions

  - Change curl version and os sections from single-line input to
    multi-line textarea.

  - Require curl version and os sections to be filled out before report
    can be submitted.

  Closes https://github.com/curl/curl/pull/11636

Daniel Stenberg (9 Aug 2023)

- gen.pl: replace all single quotes with aq

  - this prevents man from using a unicode sequence for them
  - which then allows search to work properly

  Closes #11645

Viktor Szakats (9 Aug 2023)

- cmake: fix to use variable for the curl namespace

  Replace (wrong) literal with a variable to specify the curl
  namespace.

  Follow-up to 1199308dbc902c52be67fc805c72dd2582520d30 #11505

  Reported-by: balikalina on Github
  Fixes https://github.com/curl/curl/commit/1199308dbc902c52be67fc805c72dd25825
  20d30#r123923098
  Closes #11629

- cmake: allow `SHARE_LIB_OBJECT=ON` on all platforms

  2ebc74c36a19a1700af394c16855ce144d9878e3 #11546 introduced sharing
  libcurl objects for shared and static targets.

  The above automatically enabled for Windows builds, with an option to
  disable with `SHARE_LIB_OBJECT=OFF`.

  This patch extend this feature to all platforms as a manual option.
  You can enable it by setting `SHARE_LIB_OBJECT=ON`. Then shared objects
  are built in PIC mode, meaning the static lib will also have PIC code.

  [EXPERIMENTAL]

  Closes #11627

- cmake: assume `wldap32` availability on Windows

  This system library first shipped with Windows ME, available as an extra
  install for some older releases (according to [1]). The import library
  was present already in old MinGW 3.4.2 (year 2007).

  Drop the feature check and its associated `HAVE_WLDAP32` variable.

  To manually disable `wldap32`, you can use the `USE_WIN32_LDAP=OFF`
  CMake option, like before.

  [1]: https://dlcdn.apache.org/httpd/binaries/win32/LEGACY.html

  Reviewed-by: Jay Satiro
  Closes #11624

Daniel Stenberg (9 Aug 2023)

- page-header: move up a URL paragraph from GLOBBING to URL

- variable.d: output the function names table style

  Also correct the url function name in the header

  Closes #11641

- haproxy-clientip.d: remove backticks

  This is not markdown

  Follow-up to 0a75964d0d94a4

  Closes #11639

- RELEASE-NOTES: synced

- gen.pl: escape all dashes (ascii minus) to avoid unicode hyphens

  Reported-by: FC Stegerman
  Fixes #11635
  Closes #11637

- cmdline-opts/page-header: reorder, clean up

  - removed some unnecessary blurb to focus
  - moved up the more important URL details
  - put "globbing" into its own subtitle and moved down a little
  - mention the online man page in the version section

  Closes #11638

- c-hyper: adjust the hyper to curlcode conversion

  Closes #11621

- test2306: make it use a persistent connection

  + enable verbose already from the start

  Closes #11621

eppesuig (8 Aug 2023)

- list-only.d: mention SFTP as supported protocol

  Closes #11628

Daniel Stenberg (8 Aug 2023)

- request.d: use .TP for protocol "labels"

  To render the section nicer in man page.

  Closes #11630

- cf-haproxy: make CURLOPT_HAPROXY_CLIENT_IP set the *source* IP

  ... as documented.

  Update test 3201 and 3202 accordingly.

  Reported-by: Markus Sommer
  Fixes #11619
  Closes #11626

- page-footer: QLOGDIR works with ngtcp2 and quiche

  It previously said "both" backends which is confusing as we currently
  have three...

  Closes #11631

Stefan Eissing (8 Aug 2023)

- http3: quiche, handshake optimization, trace cleanup

  - load x509 store after clienthello
  - cleanup of tracing

  Closes #11618

Daniel Stenberg (8 Aug 2023)

- ngtcp2: remove dead code

  'result' is always zero (CURLE_OK) at this point

  Detected by Coverity

  Closes #11622

Viktor Szakats (8 Aug 2023)

- openssl: auto-detect `SSL_R_TLSV13_ALERT_CERTIFICATE_REQUIRED`

  OpenSSL 1.1.1 defines this macro, but no ealier version, or any of the
  popular forks (yet). Use the macro itself to detect its presence,
  replacing the hard-wired fork-specific conditions.

  This way the feature will enable automatically when forks implement it,
  while also shorter and possibly requiring less future maintenance.

  Follow-up to 94241a9e78397a2aaf89a213e6ada61e7de7ee02 #6721

  Reviewed-by: Jay Satiro
  Closes #11617

- openssl: use `SSL_CTX_set_ciphersuites` with LibreSSL 3.4.1

  LibreSSL 3.4.1 (2021-10-14) added support for
  `SSL_CTX_set_ciphersuites`.

  Ref: https://ftp.openbsd.org/pub/OpenBSD/LibreSSL/libressl-3.4.1-relnotes.txt

  Reviewed-by: Jay Satiro
  Closes #11616

- openssl: use `SSL_CTX_set_keylog_callback` with LibreSSL 3.5.0

  LibreSSL 3.5.0 (2022-02-24) added support for
  `SSL_CTX_set_keylog_callback`.

  Ref: https://ftp.openbsd.org/pub/OpenBSD/LibreSSL/libressl-3.5.0-relnotes.txt

  Reviewed-by: Jay Satiro
  Closes #11615

- cmake: drop `HAVE_LIBWINMM` and `HAVE_LIBWS2_32` feature checks

  - `HAVE_LIBWINMM` was detected but unused. The `winmm` system library is
    also not used by curl, but it is by its optional dependency `librtmp`.
    Change the logic to always add `winmm` when `USE_LIBRTMP` is set. This
    library has been available since the early days of Windows.

  - `HAVE_LIBWS2_32` detected `ws2_32` lib on Windows. This lib is present
    since Windows 95 OSR2 (AFAIR). Winsock1 already wasn't supported and
    other existing logic already assumed this lib being present, so delete
    the check and replace the detection variable with `WIN32` and always
    add `ws2_32` on Windows.

  Closes #11612

Daniel Gustafsson (8 Aug 2023)

- crypto: ensure crypto initialization works

  Make sure that context initialization during hash setup works to avoid
  going forward with the risk of a null pointer dereference.

  Reported-by: Philippe Antoine on HackerOne
  Assisted-by: Jay Satiro
  Assisted-by: Daniel Stenberg

  Closes #11614

Viktor Szakats (7 Aug 2023)

- openssl: switch to modern init for LibreSSL 2.7.0+

  LibreSSL 2.7.0 (2018-03-21) introduced automatic initialization,
  `OPENSSL_init_ssl()` function and deprecated the old, manual init
  method, as seen in OpenSSL 1.1.0. Switch to the modern method when
  available.

  Ref: https://ftp.openbsd.org/pub/OpenBSD/LibreSSL/libressl-2.7.0-relnotes.txt

  Reviewed-by: Daniel Stenberg
  Closes #11611

Daniel Stenberg (7 Aug 2023)

- gskit: remove

  We remove support for building curl with gskit.

   - This is a niche TLS library, only running on some IBM systems
   - no regular curl contributors use this backend
   - no CI builds use or verify this backend
   - gskit, or the curl adaption for it, lacks many modern TLS features
     making it an inferior solution
   - build breakages in this code take weeks or more to get detected
   - fixing gskit code is mostly done "flying blind"

  This removal has been advertized in DEPRECATED in Jan 2, 2023 and it has
  been mentioned on the curl-library mailing list.

  It could be brought back, this is not a ban. Given proper effort and
  will, gskit support is welcome back into the curl TLS backend family.

  Closes #11460

- RELEASE-NOTES: synced

Dan Fandrich (7 Aug 2023)

- THANKS-filter: add a name typo

Stefan Eissing (7 Aug 2023)

- http3/ngtcp2: shorten handshake, trace cleanup

  - shorten handshake timing by delayed x509 store load (OpenSSL)
    as we do for HTTP/2
  - cleanup of trace output, align with HTTP/2 output

  Closes #11609

Daniel Stenberg (7 Aug 2023)

- headers: accept leading whitespaces on first response header

  This is a bad header fold but since the popular browsers accept this
  violation, so does curl now. Unless built with hyper.

  Add test 1473 to verify and adjust test 2306.

  Reported-by: junsik on github
  Fixes #11605
  Closes #11607

- include/curl/mprintf.h: add __attribute__ for the prototypes

  - if gcc or clang is used
  - if __STDC_VERSION__ >= 199901L, which means greater than C90
  - if not using mingw
  - if CURL_NO_FMT_CHECKS is not defined

  Closes #11589

- tests: fix bad printf format flags in test code

- tests: fix header scan tools for attribute edits in mprintf.h

- cf-socket: log successful interface bind

  When the setsockopt SO_BINDTODEVICE operation succeeds, output that in
  the verbose output.

  Ref: #11599
  Closes #11608

- CURLOPT_SSL_VERIFYPEER.3: mention it does not load CA certs when disabled

  Ref: #11457
  Closes #11606

- CURLOPT_SSL_VERIFYPEER.3: add two more see also options

  CURLINFO_CAINFO and CURLINFO_CAPATH

  Closes #11603

- KNOWN_BUGS: aws-sigv4 does not behave well with AWS VPC Lattice

  Closes #11007

Graham Campbell (6 Aug 2023)

- CI: use openssl 3.0.10+quic, nghttp3 0.14.0, ngtcp2 0.18.0

  Closes #11585

Daniel Stenberg (6 Aug 2023)

- TODO: add *5* entries for aws-sigv4

  Closes #7559
  Closes #8107
  Closes #8810
  Closes #9717
  Closes #10129

- TODO: LDAP Certificate-Based Authentication

  Closes #9641

Stefan Eissing (6 Aug 2023)

- http2: cleanup trace messages

  - more compact format with bracketed stream id
  - all frames traced in and out

  Closes #11592

Daniel Stenberg (6 Aug 2023)

- tests/tftpd+mqttd: make variables static to silence picky warnings

  Closes #11594

- docs/cmdline: remove repeated working for negotiate + ntlm

  The extra wording is added automatically by the gen.pl tool

  Closes #11597

- docs/cmdline: add small "warning" to verbose options

  "Note that verbose output of curl activities and network traffic might
  contain sensitive data, including user names, credentials or secret data
  content. Be aware and be careful when sharing trace logs with others."

  Closes #11596

- RELEASE-NOTES: synced

- pingpong: don't use *bump_headersize

  We use that for HTTP(S) only.

  Follow-up to 3ee79c1674fd6

  Closes #11590

- urldata: remove spurious parenthesis to unbreak no-proxy build

  Follow-up to e12b39e13382

  Closes #11591

- easy: don't call Curl_trc_opt() in disabled-verbose builds

  Follow-up to e12b39e133822c6a0

  Closes #11588

- http: use %u for printfing int

  Follow-up to 3ee79c1674fd6f99e8efca5

  Closes #11587

Goro FUJI (3 Aug 2023)

- vquic: show stringified messages for errno

  Closes #11584

Stefan Eissing (3 Aug 2023)

- trace: make tracing available in non-debug builds

  Add --trace-config to curl

  Add curl_global_trace() to libcurl

  Closes #11421

Daniel Stenberg (3 Aug 2023)

- TODO: remove "Support intermediate & root pinning for PINNEDPUBLICKEY"

  See also https://github.com/curl/curl/pull/7507

- TODO: add "WebSocket read callback"

  remove "Upgrade to websockets" as we already have this

  Closes #11402

- test497: verify rejecting too large incoming headers

- http: return error when receiving too large header set

  To avoid abuse. The limit is set to 300 KB for the accumulated size of
  all received HTTP headers for a single response. Incomplete research
  suggests that Chrome uses a 256-300 KB limit, while Firefox allows up to
  1MB.

  Closes #11582

Stefan Eissing (3 Aug 2023)

- http2: upgrade tests and add fix for non-existing stream

  - check in h2 filter recv that stream actually exists
    and return error if not
  - add test for parallel, extreme h2 upgrades that fail if
    connections get reused before fully switched
  - add h2 upgrade upload test just for completeness

  Closes #11563

Viktor Szakats (3 Aug 2023)

- tests: ensure `libcurl.def` contains all exports

  Add `test1279` to verify that `libcurl.def` lists all exported API
  functions found in libcurl headers.

  Also:

  - extend test suite XML `stdout` tag with the `loadfile` attribute.

  - fix `tests/extern-scan.pl` and `test1135` to include websocket API.

  - use all headers (sorted) in `test1135` instead of a manual list.

  - add options `--sort`, `--heading=` to `tests/extern-scan.pl`.

  - add `libcurl.def` to the auto-labeler GHA task.

  Follow-up to 2ebc74c36a19a1700af394c16855ce144d9878e3

  Closes #11570

Daniel Stenberg (2 Aug 2023)

- url: change default value for CURLOPT_MAXREDIRS to 30

  It was previously unlimited by default, but that's not a sensible
  default. While changing this has a remote risk of breaking an existing
  use case, I figure it is more likely to actually save users from loops.

  Closes #11581

- lib: fix a few *printf() flag mistakes

  Reported-by: Gisle Vanem
  Ref: #11574
  Closes #11579

Samuel Chiang (2 Aug 2023)

- openssl: make aws-lc version support OCSP

  And bump version in CI

  Closes #11568

Daniel Stenberg (2 Aug 2023)

- tool: make the length argument an int for printf()-.* flags

  Closes #11578

- tool_operate: fix memory leak when SSL_CERT_DIR is used

  Detected by Coverity

  Follow-up to 29bce9857a12b6cfa726a5

  Closes #11577

- tool/var: free memory on OOM

  Coverity detected this memory leak in OOM situation

  Follow-up to 2e160c9c652504e

  Closes #11575

Viktor Szakats (2 Aug 2023)

- gha: bump libressl and mbedtls versions

  Closes #11573

Jay Satiro (2 Aug 2023)

- schannel: fix user-set legacy algorithms in Windows 10 & 11

  - If the user set a legacy algorithm list (CURLOPT_SSL_CIPHER_LIST) then
    use the SCHANNEL_CRED legacy structure to pass the list to Schannel.

  - If the user set both a legacy algorithm list and a TLS 1.3 cipher list
    then abort.

  Although MS doesn't document it, Schannel will not negotiate TLS 1.3
  when SCHANNEL_CRED is used. That means setting a legacy algorithm list
  limits the user to earlier versions of TLS.

  Prior to this change, since 8beff435 (precedes 7.85.0), libcurl would
  ignore legacy algorithms in Windows 10 1809 and later.

  Reported-by: zhihaoy@users.noreply.github.com

  Fixes https://github.com/curl/curl/pull/10741
  Closes https://github.com/curl/curl/pull/10746

Daniel Stenberg (2 Aug 2023)

- variable.d: setting a variable again overwrites it

  Reported-by: Niall McGee
  Bug: https://twitter.com/niallmcgee/status/1686523075423322113
  Closes #11571

Jay Satiro (2 Aug 2023)

- CURLOPT_PROXY_SSL_OPTIONS.3: sync formatting

  - Re-wrap CURLSSLOPT_ALLOW_BEAST description.

Daniel Stenberg (2 Aug 2023)

- RELEASE-NOTES: synced

- resolve: use PF_INET6 family lookups when CURL_IPRESOLVE_V6 is set

  Previously it would always do PF_UNSPEC if CURL_IPRESOLVE_V4 is not
  used, thus unnecessarily asking for addresses that will not be used.

  Reported-by: Joseph Tharayil
  Fixes #11564
  Closes #11565

- docs: link to the website versions instead of markdowns

  ... to make the links work when the markdown is converted to webpages on
  https://curl.se

  Reported-by: Maurício Meneghini Fauth
  Fixes https://github.com/curl/curl-www/issues/272
  Closes #11569

Viktor Szakats (1 Aug 2023)

- cmake: cache more config and delete unused ones

  - cache more Windows config results for faster initialization.

  - delete unused config macros `HAVE_SYS_UTSNAME_H`, `HAVE_SSL_H`.

  - delete dead references to `sys/utsname.h`.

  Closes #11551

- egd: delete feature detection and related source code

  EGD is Entropy Gathering Daemon, a socket-based entropy source supported
  by pre-OpenSSL v1.1 versions and now deprecated. curl also deprecated it
  a while ago.

  Its detection in CMake was broken all along because OpenSSL libs were
  not linked at the point of feature check.

  Delete detection from both cmake and autotools, along with the related
  source snippet, and the `--with-egd-socket=` `./configure` option.

  Closes #11556

Stefan Eissing (1 Aug 2023)

- tests: fix h3 server check and parallel instances

  - fix check for availability of nghttpx server
  - add `tcp` frontend config for same port as quic, as
    without this, port 3000 is bound which clashes for parallel
    testing

  Closes #11553

Daniel Stenberg (1 Aug 2023)

- docs/cmdline-opts: spellfixes, typos and polish

  To make them accepted by the spell checker

  Closes #11562

- CI/spellcheck: build curl.1 and spellcheck it

  Added acceptable words

  Closes #11562

Alexander Jaeger (1 Aug 2023)

- misc: fix various typos

  Closes #11561

Daniel Stenberg (1 Aug 2023)

- http2: avoid too early connection re-use/multiplexing

  HTTP/1 connections that are upgraded to HTTP/2 should not be picked up
  for reuse and multiplexing by other handles until the 101 switching
  process is completed.

  Lots-of-debgging-by: Stefan Eissing
  Reported-by: Richard W.M. Jones
  Bug: https://curl.se/mail/lib-2023-07/0045.html
  Closes #11557

- Revert "KNOWN_BUGS: build for iOS simulator on macOS 13.2 with Xcode 14"

  This reverts commit 2e8a3d7cb73c85a9aa151e263315f8a496dbb9d4.

  It's a user error for supplying incomplete information to the build system.

  Reported-by: Ryan Schmidt
  Ref: https://github.com/curl/curl/issues/11215#issuecomment-1658729367

Viktor Szakats (1 Aug 2023)

- cmake: add support for single libcurl compilation pass

  Before this patch CMake builds used two separate compilation passes to
  build the shared and static libcurl respectively. This patch allows to
  reduce that to a single pass if the target platform and build settings
  allow it.

  This reduces CMake build times when building both static and shared
  libcurl at the same time, making these dual builds an almost zero-cost
  option.

  Enable this feature for Windows builds, where the difference between the
  two passes was the use of `__declspec(dllexport)` attribute for exported
  API functions for the shared builds. This patch replaces this method
  with the use of `libcurl.def` at DLL link time.

  Also update `Makefile.mk` to use `libcurl.def` to export libcurl API
  symbols on Windows. This simplifies (or fixes) this build method (e.g.
  in curl-for-win, which generated a `libcurl.def` from `.h` files using
  an elaborate set of transformations).

  `libcurl.def` has the maintenance cost of keeping the list of public
  libcurl API symbols up-to-date. This list seldom changes, so the cost
  is low.

  Closes #11546

- cmake: detect `SSL_set0_wbio` in OpenSSL

  Present in OpenSSL 1.1.0 and BoringSSL.
  Missing from LibreSSL 3.8.0.

  Follow-up to f39472ea9f4f4e12cfbc0500c4580a8d52ce4a59

  While here, also fix `RAND_egd()` detection which was broken, likely all
  along. This feature is probably broken with CMake builds and also
  requires a sufficiently obsolete OpenSSL version, so this part of the
  update was not tested.

  Closes #11555

- cmake: fixup H2 duplicate symbols for unity builds

  Closes #11550

Pablo Busse (1 Aug 2023)

- openssl: Support async cert verify callback

  - Update the OpenSSL connect state machine to handle
    SSL_ERROR_WANT_RETRY_VERIFY.

  This allows libcurl users that are using custom certificate validation
  to suspend processing while waiting for external I/O during certificate
  validation.

  Closes https://github.com/curl/curl/pull/11499

Jay Satiro (1 Aug 2023)

- tool_cb_wrt: fix invalid unicode for windows console

  - Suppress an incomplete UTF-8 sequence at the end of the buffer.

  - Attempt to reconstruct incomplete UTF-8 sequence from prior call(s)
    in current call.

  Prior to this change, in Windows console UTF-8 sequences split between
  two or more calls to the write callback would cause invalid "replacement
  characters" U+FFFD to be printed instead of the actual Unicode
  character. This is because in Windows only UTF-16 encoded characters are
  printed to the console, therefore we convert the UTF-8 contents to
  UTF-16, which cannot be done with partial UTF-8 sequences.

  Reported-by: Maksim Arhipov

  Fixes https://github.com/curl/curl/issues/9841
  Closes https://github.com/curl/curl/pull/10890

Daniel Stenberg (1 Aug 2023)

- sectransp: prevent CFRelease() of NULL

  When SecCertificateCopyCommonName() returns NULL, the common_name
  pointer remains set to NULL which apparently when calling CFRelease() on
  (sometimes?) crashes.

  Reported-by: Guillaume Algis
  Fixes #9194
  Closes #11554

Jay Satiro (1 Aug 2023)

- vtls: clarify "ALPN: offers" message

  Before:
  * ALPN: offers h2,http/1.1

  After:
  * ALPN: curl offers h2,http/1.1

  Bug: https://curl.se/mail/lib-2023-07/0041.html
  Reported-by: Richard W.M. Jones
  Closes #11544

Daniel Stenberg (1 Aug 2023)

- urlapi: make sure zoneid is also duplicated in curl_url_dup

  Add several curl_url_dup() tests to the general lib1560 test.

  Reported-by: Rutger Broekhoff
  Bug: https://curl.se/mail/lib-2023-07/0047.html
  Closes #11549

Sergey (1 Aug 2023)

- urlapi: fix heap buffer overflow

  `u->path = Curl_memdup(path, pathlen + 1);` accesses bytes after the null-ter
  minator.

  ```
  ==2676==ERROR: AddressSanitizer: heap-buffer-overflow on address 0x04d48c75 a
  t pc 0x0112708a bp 0x006fb7e0 sp 0x006fb3c4
  READ of size 78 at 0x04d48c75 thread T0
      #0 0x1127089 in __asan_wrap_memcpy D:\a\_work\1\s\src\vctools\asan\llvm\c
  ompiler-rt\lib\sanitizer_common\sanitizer_common_interceptors.inc:840
      #1 0x1891a0e in Curl_memdup C:\actions-runner\_work\client\client\third_p
  arty\curl\lib\strdup.c:97
      #2 0x18db4b0 in parseurl C:\actions-runner\_work\client\client\third_part
  y\curl\lib\urlapi.c:1297
      #3 0x18db819 in parseurl_and_replace C:\actions-runner\_work\client\clien
  t\third_party\curl\lib\urlapi.c:1342
      #4 0x18d6e39 in curl_url_set C:\actions-runner\_work\client\client\third_
  party\curl\lib\urlapi.c:1790
      #5 0x1877d3e in parseurlandfillconn C:\actions-runner\_work\client\client
  \third_party\curl\lib\url.c:1768
      #6 0x1871acf in create_conn C:\actions-runner\_work\client\client\third_p
  arty\curl\lib\url.c:3403
      #7 0x186d8dc in Curl_connect C:\actions-runner\_work\client\client\third_
  party\curl\lib\url.c:3888
      #8 0x1856b78 in multi_runsingle C:\actions-runner\_work\client\client\thi
  rd_party\curl\lib\multi.c:1982
      #9 0x18531e3 in curl_multi_perform C:\actions-runner\_work\client\client\
  third_party\curl\lib\multi.c:2756
  ```

  Closes #11560

Daniel Stenberg (31 Jul 2023)

- curl: make %output{} in -w specify a file to write to

  It can be used multiple times. Use %output{>>name} to append.

  Add docs. Test 990 and 991 verify.

  Idea: #11400
  Suggested-by: ed0d2b2ce19451f2
  Closes #11416

- RELEASE-NOTES: synced

- tool: add "variable" support

  Add support for command line variables. Set variables with --variable
  name=content or --variable name@file (where "file" can be stdin if set
  to a single dash (-)).

  Variable content is expanded in option parameters using "{{name}}"
  (without the quotes) if the option name is prefixed with
  "--expand-". This gets the contents of the variable "name" inserted, or
  a blank if the name does not exist as a variable. Insert "{{" verbatim
  in the string by prefixing it with a backslash, like "\\{{".

  Import an environment variable with --variable %name. It makes curl exit
  with an error if the environment variable is not set. It can also rather
  get a default value if the variable does not exist, using =content or
  @file like shown above.

  Example: get the USER environment variable into the URL:

   --variable %USER
   --expand-url = "https://example.com/api/{{USER}}/method"

  When expanding variables, curl supports a set of functions that can make
  the variable contents more convenient to use. It can trim leading and
  trailing white space with "trim", output the contents as a JSON quoted
  string with "json", URL encode it with "url" and base 64 encode it with
  "b64". To apply functions to a variable expansion, add them colon
  separated to the right side of the variable. They are then performed in
  a left to right order.

  Example: get the contents of a file called $HOME/.secret into a variable
  called "fix". Make sure that the content is trimmed and percent-encoded
  sent as POST data:

    --variable %HOME=/home/default
    --expand-variable fix@{{HOME}}/.secret
    --expand-data "{{fix:trim:url}}"
    https://example.com/

  Documented. Many new test cases.

  Co-brainstormed-by: Emanuele Torre
  Assisted-by: Jat Satiro
  Closes #11346

- KNOWN_BUGS: cygwin: make install installs curl-config.1 twice

  Closes #8839

- KNOWN_BUGS: build for iOS simulator on macOS 13.2 with Xcode 14

  Closes #11215

- KNOWN_BUGS: cmake outputs: no version information available

  Closes #11158

- KNOWN_BUGS: APOP authentication fails on POP3

  Closes #10073

- KNOWN_BUGS: hyper is slow

  Closes #11203

Patrick Monnerat (31 Jul 2023)

- configure, cmake, lib: more form api deprecation

  Introduce a --enable-form-api configure option to control its inclusion
  in builds. The condition name defined for it is CURL_DISABLE_FORM_API.

  Form api code is dependent of MIME: configure and CMake handle this
  dependency automatically: CMake by making it a dependent option
  explicitly, configure by inheriting the MIME value by default and
  rejecting explicit incompatible values.

  "form-api" is now a new hidden test feature.

  Update libcurl modules to respect this option and adjust tests
  accordingly.

  Closes #9621

Daniel Stenberg (31 Jul 2023)

- mailmap: add Derzsi Dániel

Derzsi Dániel (31 Jul 2023)

- wolfssl: support loading system CA certificates

  Closes #11452

Viktor Szakats (30 Jul 2023)

- nss: delete more NSS references

  Fix the distcheck CI failure and delete more NSS references.

  Follow-up to 7c8bae0d9c9b2dfeeb008b9a316117d7b9675175

  Reviewed-by: Marcel Raad
  Reviewed-by: Daniel Stenberg
  Closes #11548

Daniel Stenberg (29 Jul 2023)

- nss: remove support for this TLS library

  Closes #11459

Ryan Schmidt (29 Jul 2023)

- macOS: fix target detection more

  Now SCDynamicStoreCopyProxies is called (and the required frameworks are
  linked in) on all versions of macOS and only on macOS. Fixes crash due
  to undefined symbol when built with the macOS 10.11 SDK or earlier.

  CURL_OSX_CALL_COPYPROXIES is renamed to CURL_MACOS_CALL_COPYPROXIES and
  is now only defined when SCDynamicStoreCopyProxies will actually be
  called. Previously, it was defined when ENABLE_IPV6 was not defined but
  SCDynamicStoreCopyProxies is not called in that case.

  TARGET_OS_OSX is only defined in the macOS 10.12 SDK and later and only
  when dynamic targets are enabled. TARGET_OS_MAC is always defined but
  means any Mac OS or derivative including macOS, iOS, tvOS, and watchOS.
  TARGET_OS_IPHONE means any Darwin OS other than macOS.

  Follow-up to c73b2f82

  Fixes #11502
  Closes #11516

Daniel Stenberg (29 Jul 2023)

- tool_operate: allow SSL_CERT_FILE and SSL_CERT_DIR

  ... used at once.

  Reported-by: Gabriel Corona
  Fixes #11325
  Closes #11531

Thomas M. DuBuisson (29 Jul 2023)

- CI: remove Lift's configuration

  The Lift tool is being retired. Their site reads:

  "Sonatype Lift will be retiring on Sep 12, 2023, with its analysis
  stopping on Aug 12, 2023."

  Closes #11541

Nathan Moinvaziri (29 Jul 2023)

- Revert "schannel: reverse the order of certinfo insertions"

  This reverts commit 8986df802db9b5338d9d50a54232ebae4dbcf6dd.

  Windows does not guarantee a particular certificate ordering, even
  though TLS may have its own ordering/relationship guarantees. Recent
  versions of Windows 11 reversed the ordering of ceritifcates returned by
  CertEnumCertificatesInStore, therefore this commit no longer works as
  initially intended. libcurl makes no guarantees about certificate
  ordering if the operating system can't.

  Ref: https://github.com/curl/curl/issues/9706

  Closes https://github.com/curl/curl/pull/11536

wangzhikun (29 Jul 2023)

- winbuild: improve check for static zlib

  - Check for zlib static library name zlibstatic.lib.

  zlib's static library has a different name depending on how it was
  built. zlibstatic.lib is output by cmake. zlibstat.lib is output by
  their pre-generated Visual Studio project files (in the contrib
  directory) and defines ZLIB_WINAPI (ie it's meant to use stdcall
  instead of cdecl if you end up exporting the zlib functions).

  Prior to this change the makefile only checked for the latter.

  Closes https://github.com/curl/curl/pull/11521

Daniel Stenberg (29 Jul 2023)

- configure: use the pkg-config --libs-only-l flag for libssh2

  ... instead of --libs, as that one also returns -L flags.

  Reported-by: Wilhelm von Thiele
  Fixes #11538
  Closes #11539

Viktor Szakats (29 Jul 2023)

- cmake: support building static and shared libcurl in one go

  This patch adds the ability to build a static and shared libcurl library
  in a single build session. It also adds an option to select which one to
  use when building the curl executable.

  New build options:
  - `BUILD_STATIC_LIBS`. Default: `OFF`.
    Enabled automatically if `BUILD_SHARED_LIBS` is `OFF`.
  - `BUILD_STATIC_CURL`. Default: `OFF`.
    Requires `BUILD_STATIC_LIBS` enabled.
    Enabled automatically if building static libcurl only.
  - `STATIC_LIB_SUFFIX`. Default: empty.
  - `IMPORT_LIB_SUFFIX`. Default: `_imp` if implib filename would collide
    with static lib name (typically with MSVC) in Windows builds.
    Otherwise empty.

  Also:

  - Stop setting the `CURL_STATICLIB` macro via `curl_config.h`, and pass
    it directly to the compiler. This also allows to delete a condition
    from `tests/server/CMakeLists.txt`.

  - Complete a TODO by following the logic used in autotools (also for
    `LIBCURL_NO_SHARED`), and set `-DCURL_STATICLIB` in `Cflags:` of
    `libcurl.pc` for _static-only_ curl builds.

  - Convert an existing CI test to build both shared and static libcurl.

  Closes #11505

Stefan Eissing (28 Jul 2023)

- CI/awslc: add cache for build awslc library

  Closes #11535

- GHA/linux.yml: add caching

  Closes #11532

Daniel Stenberg (27 Jul 2023)

- RELEASE-NOTES: synced

  Bump working version to 8.3.0

- url: remove infof() output for "still name resolving"

  The message does not help and might get spewed a lot during times.

  Reported-by: yushicheng7788 on github
  Fixes #11394
  Closes #11529

- KNOWN_BUGS: cygwin: "WARNING: UNPROTECTED PRIVATE KEY FILE!"

  Closes #11244

Stefan Eissing (27 Jul 2023)

- CI: quiche updates

  - remove quiche from standard `linux` workflow
  - add mod_h2 caching to quiche workflow
  - rename quiche to quiche-linux
  - move version definitions into env section

  Closes #11528

- http2: disable asssertion blocking OSSFuzz testing

  - not clear how this triggers and it blocks OSSFuzz testing other
    things. Since we handle the case with an error return, disabling the
    assertion for now seems the best way forward.

  Fixes #11500
  Closes #11519

- http2: fix in h2 proxy tunnel: progress in ingress on sending

  - depending on what is tunneled, the proxy may never get invoked for
    receiving data explicitly. Not progressing ingress may lead to stalls
    due to missed WINDOW_UPDATEs.

  CI:
  - add a chache for building mod_h2

  Closes #11527

- CI ngtcp2+quictls: use nghttpx cache as in quiche build

Jay Satiro (27 Jul 2023)

- bearssl: don't load CA certs when peer verification is disabled

  We already do this for other SSL backends.

  Bug: https://github.com/curl/curl/pull/11457#issuecomment-1644587473
  Reported-by: kyled-dell@users.noreply.github.com

  Closes https://github.com/curl/curl/pull/11497

Daniel Stenberg (26 Jul 2023)

- easy: remove #ifdefs to make code easier on the eye

  Closes #11525

Stefan Eissing (26 Jul 2023)

- GHA: adding quiche workflow

  - adding separate quiche workflow to also build nghttpx server for testing

  Closes #11517

Version 8.2.1 (26 Jul 2023)

Daniel Stenberg (26 Jul 2023)

- RELEASE-NOTES: synced

  curl 8.2.1 release

- THANKS: add contributors from 8.2.1

- docs: provide more see also for cipher options

  More cross references. Hide nroff errors.

  Closes #11513

- docs: mark two TLS options for TLS, not SSL

  Closes #11514

Brad Harder (25 Jul 2023)

- curl_multi_wait.3: fix arg quoting to doc macro .BR

  Closes #11511

Daniel Stenberg (24 Jul 2023)

- RELEASE-NOTES: synced

Viktor Szakats (24 Jul 2023)

- cmake: update ngtcp2 detection

  Replace `OpenSSL` with `quictls` to follow the same change
  in the v0.17.0 ngtcp2 release.

  Follow-up to e0093b4b732f6495b0fb1cd6747cbfedcdcf63ed

  Closes #11508

Stefan Eissing (24 Jul 2023)

- http: VLH, very large header test and fixes

  - adding tests using very large passwords in auth
  - fixes general http sending to treat h3 like h2, and
    not like http1.1
  - eliminate H2_HEADER max definitions and use the commmon
    DYN_HTTP_REQUEST everywhere, different limits do not help
  - fix http2 handling of requests denied by nghttp2 on send
    to immediately report the refused stream

  Closes #11509

Andrei Rybak (23 Jul 2023)

- CONTRIBUTE: drop mention of copyright year ranges

  Year ranges in copyrights were dropped in commits [1] and [2].
  Verification of year ranges in copyrights was dropped from script
  'scripts/copyright.pl' in commit [3].  However, the corresponding
  passages in file 'docs/CONTRIBUTE.md' weren't updated.

  Drop mentions of copyright year ranges from 'docs/CONTRIBUTE.md'.

  [1] 2bc1d775f (copyright: update all copyright lines and remove year
      ranges, 2023-01-02)
  [2] c46761bd8 (tests/http: remove year ranges from copyrights,
      2023-03-14)
  [3] 0e293bacb (copyright.pl: cease doing year verifications, 2023-01-28)

  Closes #11504

- CONTRIBUTE: fix syntax in commit message description

  File 'docs/CONTRIBUTE.md' includes a description of how one should write
  commit messages in the curl project.  Different possible parts of the
  message are enclosed in square brackets.  One exception is the section
  describing how the curl project doesn't use "Signed-off-by" commit
  trailers [1], which is enclosed in an opening curly brace paired with a
  closing square bracket.

  Fix the enclosing square brackets in description of "Signed-off-by"
  trailers in commit messages in file 'docs/CONTRIBUTE.md'.

  [1] See description of option '--signoff' in Git documentation:
      https://git-scm.com/docs/git-commit

  Closes #11504

Daniel Stenberg (23 Jul 2023)

- src/mkhelp: strip off escape sequences

  At some point the nroff command stopped stripping off escape sequences,
  so then this script needs to do the job instead.

  Reported-by: VictorVG on github
  Fixes #11501
  Closes #11503

- KNOWN_BUGS: building for old macOS fails with gcc

  Closes #11441

Jacob Hoffman-Andrews (22 Jul 2023)

- rustls: update rustls-ffi 0.10.0

  This brings in version 0.21.0 of the upstream rustls implementation,
  which notable includes support for IP address certificates.

  Closes #10865

Brad Harder (22 Jul 2023)

- websocket: rename arguments/variables to match docs

  Pedantry/semantic-alignment between functions, docs, comments with
  respect to websocket protocol code; No functional change intended.

  * "totalsize", "framesize" becomes "fragsize" (we deal in frame fragments).

  * "sendflags" becomes "flags"

  * use canonical CURL *handle

  Closes #11493

Jan Macku (21 Jul 2023)

- bug_report: use issue forms instead of markdown template

  Issue forms allow you to define web-like input forms using YAML
  syntax. It allows you to guide the reporter to get the required
  information.

  Signed-off-by: Jan Macku <jamacku@redhat.com>
  Closes #11474

Daniel Stenberg (21 Jul 2023)

- TODO: Obey Retry-After in redirects

  (remove "Set custom client ip when using haproxy protocol" which was
  shipped in 8.2.0)

  Mentioned-by: Yair Lenga
  Closes #11447

- RELEASE-NOTES: synced

Oliver Roberts (21 Jul 2023)

- amissl: fix AmiSSL v5 detection

  Due to changes in the AmiSSL SDK, the detection needed adjusting.

  Closes #11477

Alois Klink (21 Jul 2023)

- unittest/makefile: remove unneeded unit1621_LDADD

  The `unit1621_LDADD` variable has the exact same value as the `LDADD`
  flag in `Makefile.am`, except without `@LDFLAGS@ @LIBCURL_LIBS@`.

  This was originally added by [98e6629][], but I can't see any reason
  why it exists, so we should remove it to clean things up.

  [98e6629]: https://github.com/curl/curl/commit/98e6629154044e4ab1ee7cff8351c7
  ebcb131e88

  Closes #11494

- unittest/makefile: remove unneeded unit1394_LDADD

  These custom `unit1394_LDADD` and similar automake overrides are no
  longer neded. They were originally added by added by [8dac7be][] for
  metalink support, but are no longer after [265b14d][] removed metalink.

  [8dac7be]: https://github.com/curl/curl/commit/8dac7be438512a8725d3c71e9139bd
  fdcac1ed8c
  [265b14d]: https://github.com/curl/curl/commit/265b14d6b37c4298bd5556fabcbc37
  d36f911693

  Closes #11494

- cmake: add `libcurlu`/`libcurltool` for unit tests

  Add a `libcurlu`/`libcurltool` static library that is compiled only for
  unit tests. We use `EXCLUDE_FROM_ALL` to make sure that they're not
  built by default, they're only built if unit tests are built.

  These libraries allow us to compile every unit test with CMake.

  Closes #11446

Daniel Stenberg (21 Jul 2023)

- test979: test -u with redirect to (the same) absolute host

  Verifies #11492

- transfer: do not clear the credentials on redirect to absolute URL

  Makes test 979 work. Regression shipped in 8.2.0 from commit
  dd4d1a26959f63a2c

  Fixes #11486
  Reported-by: Cloudogu Siebels
  Closes #11492

Jon Rumsey (20 Jul 2023)

- os400: correct EXPECTED_STRING_LASTZEROTERMINATED

  Correct EXPECTED_STRING_LASTZEROTERMINATED to account for
  CURLOPT_HAPROXY_CLIENT_IP which requires EBCDIC to ASCII conversion when
  passed into curl_easy_setopt().

  Closes #11476

Oliver Roberts (20 Jul 2023)

- amissl: add missing signal.h include

  In some environments, signal.h is already included, but not in others
  which cause compilation to fail, so explictly include it.

  Closes #11478

- amigaos: fix sys/mbuf.h m_len macro clash

  The updated Curl_http_req_make and Curl_http_req_make2 functions spawned
  a parameter called m_len. The AmigaOS networking headers, derived from
  NetBSD, contain "#define m_len m_hdr.mh_len" which clashes with
  this. Since we do not actually use mbuf, force the include file to be
  ignored, removing the clash.

  Closes #11479

Daniel Stenberg (20 Jul 2023)

- socks: print ipv6 address within brackets

  Fixes #11483
  Closes #11484

Christian Schmitz (20 Jul 2023)

- libcurl-errors.3: add CURLUE_OK

  Closes #11488

Oliver Roberts (20 Jul 2023)

- cfilters: rename close/connect functions to avoid clashes

  Rename `close` and `connect` in `struct Curl_cftype` for
  consistency and to avoid clashes with macros of the same name
  (the standard AmigaOS networking connect() function is implemented
  via a macro).

  Closes #11491

Stefan Eissing (20 Jul 2023)

- http2: fix regression on upload EOF handling

  - a regression introduced by c9ec85121110d7cbbbed2990024222c8f5b8afe5
    where optimization of small POST bodies leads to a new code path
    for such uploads that did not trigger the "done sending" event
  - add triggering this event for early "upload_done" situations

  Fixes #11485
  Closes #11487
  Reported-by: Aleksander Mazur

Daniel Stenberg (19 Jul 2023)

- configure: check for nghttp2_session_get_stream_local_window_size

  The http2 code uses it now. Introduced in nghttp2 1.15.0 (Sep 2016)

  Fixes #11470
  Reported-by: Paul Howarth
  Closes #11473

Stefan Eissing (19 Jul 2023)

- quiche: fix segfault and other things

  - refs #11449 where a segfault is reported when IP Eyeballing did
    not immediately connect but made several attempts
  - The transfer initiating the eyeballing was initialized  too early,
    leadding to references to the filter instance that was then
    replaced in the subsequent eyeball attempts. That led to a use
    after free in the buffer handling for the transfer
  - transfers are initiated now more lazy (like in the ngtcp2 filter),
    when the stream is actually opened
  - suppress reporting on quiche event errors for "other" transfers
    than the current one to not fail a transfer due to faults in
    another one.
  - revert recent return value handling for quiche_h3_recv_body()
    to not indicate an error but an EAGAIN situation. We wish quiche
    would document what functions return.

  Fixes #11449
  Closes #11469
  Reported-by: ウさん

Daniel Stenberg (19 Jul 2023)

- hostip: return IPv6 first for localhost resolves

  Fixes #11465
  Reported-by: Chilledheart on github
  Closes #11466

Harry Sintonen (19 Jul 2023)

- tool: fix tool_seek_cb build when SIZEOF_CURL_OFF_T > SIZEOF_OFF_T

  - a variable was renamed, and some use of it wasn't. this fixes the
    build.

  Closes #11468

Stefan Eissing (19 Jul 2023)

- quiche: fix lookup of transfer at multi

  - refs #11449 where weirdness in quiche multi connection tranfers was
    observed
  - fixes lookup of transfer for a quiche event to take the connection
    into account
  - formerly, a transfer with the same stream_id, but on another connection
    could be found

  Closes #11462

Daniel Stenberg (19 Jul 2023)

- RELEASE-NOTES: synced

  bump to 8.2.1

John Haugabook (19 Jul 2023)

- ciphers.d: put URL in first column

  This makes the URL turn into a link properly when "webified".

  Fixes https://github.com/curl/curl-www/issues/270
  Closes #11464

Version 8.2.0 (19 Jul 2023)

Daniel Stenberg (19 Jul 2023)

- RELEASE-NOTES: synced

  8.2.0 release

- THANKS-filter: strip out "GitHub"

- THANKS: add contributors from 8.2.0

- RELEASE-PROCEDURE.md: adjust the release dates

Stefan Eissing (17 Jul 2023)

- quiche: fix defects found in latest coverity report

  Closes #11455

Daniel Stenberg (17 Jul 2023)

- quiche: avoid NULL deref in debug logging

  Coverity reported "Dereference after null check"

  If stream is NULL and the function exits, the logging must not deref it.

  Closes #11454

Stefan Eissing (17 Jul 2023)

- http2: treat initial SETTINGS as a WINDOW_UPDATE

  - refs #11426 where spurious stalls on large POST requests
    are reported
  - the issue seems to involve the following
    * first stream on connection adds up to 64KB of POST
      data, which is the max default HTTP/2 stream window size
      transfer is set to HOLD
    * initial SETTINGS from server arrive, enlarging the stream
      window. But no WINDOW_UPDATE is received.
    * curl stalls
  - the fix un-HOLDs a stream on receiving SETTINGS, not
    relying on a WINDOW_UPDATE from lazy servers

  Closes #11450

Daniel Stenberg (17 Jul 2023)

- ngtcp2: assigning timeout, but value is overwritten before used

  Reported by Coverity

  Closes #11453

- krb5: add typecast to please Coverity

Derzsi Dániel (16 Jul 2023)

- wolfssl: support setting CA certificates as blob

  Closes #11445

- wolfssl: detect when TLS 1.2 support is not built into wolfssl

  Closes #11444

Graham Campbell (15 Jul 2023)

- CI: bump nghttp2 from 1.55.0 to 1.55.1

  Closes #11442

Daniel Stenberg (15 Jul 2023)

- curl: return error when asked to use an unsupported HTTP version

  When one of the following options are used but the libcurl in use does
  not support it:

  --http2
  --http2-prior-knowledge
  --proxy-http2

  Closes #11440

Chris Paulson-Ellis (14 Jul 2023)

- cf-socket: don't bypass fclosesocket callback if cancelled before connect

  After upgrading to 8.1.2 from 7.84.0, I found that sockets were being
  closed without calling the fclosesocket callback if a request was
  cancelled after the associated socket was created, but before the socket
  was connected. This lead to an imbalance of fopensocket & fclosesocket
  callbacks, causing problems with a custom event loop integration using
  the multi-API.

  This was caused by cf_socket_close() calling sclose() directly instead
  of calling socket_close() if the socket was not active. For regular TCP
  client connections, the socket is activated by cf_socket_active(), which
  is only called when the socket completes the connect.

  As far as I can tell, this issue has existed since 7.88.0. That is,
  since the code in question was introduced by:
      commit 71b7e0161032927cdfb4e75ea40f65b8898b3956
      Author: Stefan Eissing <stefan@eissing.org>
      Date:   Fri Dec 30 09:14:55 2022 +0100

          lib: connect/h2/h3 refactor

  Closes #11439

Daniel Stenberg (13 Jul 2023)

- tool_parsecfg: accept line lengths up to 10M

  Bumped from 100K set in 47dd957daff9

  Reported-by: Antoine du Hamel
  Fixes #11431
  Closes #11435

Stefan Eissing (13 Jul 2023)

- CI: brew fix for openssl in default path

  If brew install/update links openssl into /usr/local, it will be found
  before anything we add with `-isystem path` to CPP/LDLFAGS.  Get rid of
  that by unlinking the keg.

  Fixes #11413
  Closes #11436

Daniel Stenberg (13 Jul 2023)

- RELEASE-NOTES: synced

Ondřej Koláček (13 Jul 2023)

- sectransp: fix EOF handling

  Regression since the large refactor from 2022

  Closes #11427

Daniel Stenberg (13 Jul 2023)

- checksrc: quote the file name to work with "funny" letters

  Closes #11437

Karthikdasari0423 (13 Jul 2023)

- HTTP3.md: ngtcp2 updated to v0.17.0 and nghttp3 to v0.13.0

  Follow-up to e0093b4b732f6

  Closes #11433

Daniel Stenberg (13 Jul 2023)

- CURLOPT_MIMEPOST.3: clarify what setting to NULL means

  Follow-up to e08382a208d4e480

  Closes #11430

Tatsuhiro Tsujikawa (12 Jul 2023)

- ngtcp2: build with 0.17.0 and nghttp3 0.13.0

  - ngtcp2_crypto_openssl was renamed to ngtcp2_crypto_quictls.

  Closes #11428

- CI: Bump ngtcp2, nghttp3, and nghttp2

  Closes #11428

James Fuller (11 Jul 2023)

- example/maxconnects: set maxconnect example

  Closes #11343

Pontakorn Prasertsuk (11 Jul 2023)

- http2: send HEADER & DATA together if possible

  Closes #11420

Daniel Stenberg (11 Jul 2023)

- CI: use wolfSSL 5.6.3 in builds

  No using master anymore

  Closes #11424

SaltyMilk (11 Jul 2023)

- fopen: optimize

  Closes #11419

Daniel Stenberg (11 Jul 2023)

- cmake: make use of snprintf

  Follow-up to 935b1bd4544a23a91d68

  Closes #11423

Stefan Eissing (11 Jul 2023)

- macOS: fix taget detection

  - TARGET_OS_OSX is not always defined on macOS
  - this leads to missing symbol Curl_macos_init()
  - TargetConditionals.h seems to define these only when
    dynamic targets are enabled (somewhere?)
  - this PR fixes that on my macOS 13.4.1
  - I have no clue why CI builds worked without it

  Follow-up to c7308592fb8ba213fc2c1
  Closes #11417

Stan Hu (9 Jul 2023)

- hostip.c: Move macOS-specific calls into global init call

  https://github.com/curl/curl/pull/7121 introduced a macOS system call
  to `SCDynamicStoreCopyProxies`, which is invoked every time an IP
  address needs to be resolved.

  However, this system call is not thread-safe, and macOS will kill the
  process if the system call is run first in a fork. To make it possible
  for the parent process to call this once and prevent the crash, only
  invoke this system call in the global initialization routine.

  In addition, this change is beneficial because it:

  1. Avoids extra macOS system calls for every IP lookup.
  2. Consolidates macOS-specific initialization in a separate file.

  Fixes #11252
  Closes #11254

Daniel Stenberg (9 Jul 2023)

- docs: use a space after RFC when spelling out RFC numbers

  Closes #11382

Margu (9 Jul 2023)

- imap-append.c: update to make it more likely to work

  Fixes #10300
  Closes #11397

Emanuele Torre (9 Jul 2023)

- tool_writeout_json: fix encoding of control characters

  Control characters without a special escape sequence e.g. %00 or %06
  were being encoded as "u0006" instead of "\u0006".

  Ref: https://github.com/curl/trurl/pull/214#discussion_r1257487858
  Closes #11414

Stefan Eissing (9 Jul 2023)

- http3/ngtcp2: upload EAGAIN handling

  - refs #11389 where IDLE timeouts on upload are reported
  - reword ngtcp2 expiry handling to apply to both send+recv
    calls into the filter
  - EAGAIN uploads similar to the recent changes in HTTP/2, e.g.
    report success only when send data was ACKed.
  - HOLD sending of EAGAINed uploads to avoid cpu busy loops
  - rename internal function for consistency with HTTP/2
    implementation

  Fixes #11389
  Closes #11390

Brian Nixon (9 Jul 2023)

- tool_easysrc.h: correct `easysrc_perform` for `CURL_DISABLE_LIBCURL_OPTION`

  Closes #11398

Daniel Stenberg (9 Jul 2023)

- RELEASE-NOTES: synced

- transfer: clear credentials when redirecting to absolute URL

  Make sure the user and password for the second request is taken from the
  redirected-to URL.

  Add test case 899 to verify.

  Reported-by: James Lucas
  Fixes #11410
  Closes #11412

Stefan Eissing (8 Jul 2023)

- hyper: fix EOF handling on input

  We ran out of disc space due to an infinite loop with debug logging

  Fixes #11377
  Closes #11385
  Reported-by: Dan Fandrich

- http2: raise header limitations above and beyond

  - not quite to infinity
  - rewrote the implementation of our internal HTTP/1.x request
    parsing to work with very large lines using dynbufs.
  - new default limit is `DYN_HTTP_REQUEST`, aka 1MB, which
    is also the limit of curl's general HTTP request processing.

  Fixes #11405
  Closes #11407

Juan Cruz Viotti (8 Jul 2023)

- curl_easy_nextheader.3: add missing open parenthesis examples

  Closes #11409
  Signed-off-by: Juan Cruz Viotti <jv@jviotti.com>

Dan Fandrich (7 Jul 2023)

- CI: enable verbose test output on pytest

  This shows individual pass/fail status on tests and makes this output
  consistent with other jobs' pytest invocations.

Stefan Eissing (28 Jun 2023)

- http2: fix crash in handling stream weights

  - Delay the priority handling until the stream has been opened.

  - Add test2404 to reproduce and verify.

  Weights may change "on the run", which is why there are checks in
  general egress handling. These must not trigger when the stream has not
  been opened yet.

  Reported-by: jbgoog@users.noreply.github.com

  Fixes https://github.com/curl/curl/issues/11379
  Closes https://github.com/curl/curl/pull/11384

- tests/http: Add mod_h2 directive `H2ProxyRequests`

  master of mod_h2 now requires H2ProxyRequests directives for forward
  proxying with HTTP/2 to work.

  Ref: https://github.com/icing/mod_h2/commit/3897a7086

  Closes https://github.com/curl/curl/pull/11392

Dan Fandrich (28 Jun 2023)

- CI: make Appveyor job names unique

  Two otherwise identical mingw-w64 jobs now have their differing compiler
  versions mentioned in their names.

Sheshadri.V (25 Jun 2023)

- curl.h: include <sys/select.h> for vxworks

  Closes #11356

Dan Fandrich (24 Jun 2023)

- CI: enable parallel make in more builds

  Most CI services provide at least two cores, so enable parallel make
  jobs to take advantage of that for builds. Some dependencies aren't safe
  to build in parallel so leave those as-is.  Also, rename a few
  workflows to eliminate duplicate names and provide a better idea what
  they're about.

- CI: don't install impacket if tests are not run

  It just wastes time and bandwidth and isn't even used.

divinity76 (24 Jun 2023)

- configure: the --without forms of the options are also gone

  --without-darwin-ssl and --without-metalink

  Closes #11378

Daniel Stenberg (23 Jun 2023)

- configure: add check for ldap_init_fd

  ... as otherwise the configure script will say it is OpenLDAP in the
  summary, but not set the USE_OPENLDAP define, therefor not using the
  intended OpenLDAP code paths.

  Regression since 4d7385446 (7.85.0)
  Fixes #11372
  Closes #11374
  Reported-by: vlkl-sap on github

Michał Petryka (23 Jun 2023)

- cmake: stop CMake from quietly ignoring missing Brotli

  The CMake project was set to `QUIET` for Brotli instead of
  `REQUIRED`. This makes builds unexpectedly ignore missing Brotli even
  when `CURL_BROTLI` is enabled.

  Closes #11376

Emanuele Torre (22 Jun 2023)

- docs: add more .IP after .RE to fix indentation of generate paragraphs

  follow-up from 099f41e097c030077b8ec078f2c2d4038d31353b

  I just thought of checking all the other files with .RE, and I found 6
  other files that were missing .IP at the end.

  Closes #11375

Stefan Eissing (22 Jun 2023)

- http2: h2 and h2-PROXY connection alive check fixes

  - fix HTTP/2 check to not declare a connection dead when
    the read attempt results in EAGAIN
  - add H2-PROXY alive check as for HTTP/2 that was missing
    and is needed
  - add attach/detach around Curl_conn_is_alive() and remove
    these in filter methods
  - add checks for number of connections used in some test_10
    proxy tunneling tests

  Closes #11368

- http2: error stream resets with code CURLE_HTTP2_STREAM

  - refs #11357, where it was reported that HTTP/1.1 downgrades
    no longer works
  - fixed with suggested change
  - added test_05_03 and a new handler in the curltest module
    to reproduce that downgrades work

  Fixes #11357
  Closes #11362
  Reported-by: Jay Satiro

Daniel Stenberg (22 Jun 2023)

- connect-timeout.d: mention that the DNS lookup is included

  Closes #11370

Emanuele Torre (22 Jun 2023)

- quote.d: fix indentation of generated paragraphs

  quote.d was missing a .IP at the end which caused the paragraphs
  generated for See-also, Multi, and Example to not be indented correctly.

  I also remove a redundant "This option can be used multiple times.", and
  replaced .IP "item" with .TP .B "item" to make more clear which lines
  are part of the list of commands and which aren't.

  Closes #11371

Paul Wise (22 Jun 2023)

- checksrc: modernise perl file open

  Use regular variables and separate file open modes from filenames.

  Suggested by perlcritic

  Copied from https://github.com/curl/trurl/commit/f2784a9240f47ee28a845

  Closes #11358

Dan Fandrich (21 Jun 2023)

- runtests: work around a perl without SIGUSR1

  At least msys2 perl v5.32.1 doesn't seem to define this signal. Since
  this signal is only used for debugging, just ignore if setting it fails.

  Reported-by: Marcel Raad
  Fixes #11350
  Closes #11366

- runtests: include missing valgrind package

  use valgrind was missing which caused torture tests with valgrind
  enabled to fail.

  Reported-by: Daniel Stenberg
  Fixes #11364
  Closes #11365

- runtests: use more consistent failure lines

  After a test failure log a consistent log message to make it easier to
  parse the log file.  Also, log a consistent message with "ignored" for
  failures that cause the test to be not considered at all. These should
  perhaps be counted in the skipped category, but this commit does not
  change that behaviour.

- runtests: consistently write the test check summary block

  The memory check character was erroneously omitted if the memory
  checking file was not available for some reason, making the block of
  characters an inconsistent length.

- test2600: fix the description

  It looks like it was cut-and-pasted.

  Closes #11354

Daniel Stenberg (21 Jun 2023)

- TODO: "Support HTTP/2 for HTTP(S) proxies" *done*

humbleacolyte (21 Jun 2023)

- cf-socket: move ctx declaration under HAVE_GETPEERNAME

  Closes #11352

Daniel Stenberg (20 Jun 2023)

- RELEASE-NOTES: synced

- example/connect-to: show CURLOPT_CONNECT_TO

  Closes #11340

Stefan Eissing (20 Jun 2023)

- hyper: unslow

  - refs #11203 where hyper was reported as being slow
  - fixes hyper_executor_poll to loop until it is out of
    tasks as advised by @seanmonstar in https://github.com/hyperium/hyper/issue
  s/3237
  - added a fix in hyper io handling for detecting EAGAIN
  - added some debug logs to see IO results
  - pytest http/1.1 test cases pass
  - pytest h2 test cases fail on connection reuse. HTTP/2
    connection reuse does not seem to work. Hyper submits
    a request on a reused connection, curl's IO works and
    thereafter hyper declares `Hyper: [1] operation was canceled: connection cl
  osed`
    on stderr without any error being logged before.

  Fixes #11203
  Reported-by: Gisle Vanem
  Advised-by: Sean McArthur
  Closes #11344

- HTTP/2: upload handling fixes

  - fixes #11242 where 100% CPU on uploads was reported
  - fixes possible stalls on last part of a request body when
    that information could not be fully send on the connection
    due to an EAGAIN
  - applies the same EGAIN handling to HTTP/2 proxying

  Reported-by: Sergey Alirzaev
  Fixed #11242
  Closes #11342

Daniel Stenberg (20 Jun 2023)

- example/opensslthreadlock: remove

  This shows how to setup OpenSSL mutex callbacks, but this is not
  necessary since OpenSSL 1.1.0 - meaning that no currently supported
  OpenSSL version requires this anymore

  Closes #11341

Dan Fandrich (19 Jun 2023)

- libtest: display the times after a test timeout error

  This is to help with test failure debugging.

  Ref: #11328
  Closes #11329

- test2600: bump a test timeout

  Case 1 failed at least once on GHA by going 30 msec too long.

  Ref: #11328

- runtests: better detect and handle pipe errors in the controller

  Errors reading and writing to the pipes are now better detected and
  propagated up to the main test loop so it can be cleanly shut down. Such
  errors are usually due to a runner dying so it doesn't make much sense
  to try to continue the test run.

- runtests: cleanly abort the runner if the controller dies

  If the controller dies unexpectedly, have the runner stop its servers
  and exit cleanly. Otherwise, the orphaned servers will stay running in
  the background.

- runtests: improve error logging

  Give more information about test harness error conditions to help figure
  out what might be wrong. Print some internal test state when SIGUSR1 is
  sent to runtests.pl.

  Ref: #11328

- runtests: better handle ^C during slow tests

  Since the SIGINT handler now just sets a flag that must be checked in the
  main controller loop, make sure that runs periodically.  Rather than
  blocking on a response from a test runner near the end of the test run,
  add a short timeout to allow it.

- runtests: rename server command file

  The name ftpserver.cmd was historical and has been used for more than
  ftp for many years now. Rename it to plain server.cmd to reduce
  confusion.

- tests: improve reliability of TFTP tests

  Stop checking the timeout used by the client under test (for most
  tests). The timeout will change if the TFTP test server is slow (such as
  happens on an overprovisioned CI server) because the client will retry
  and reduce its timeout, and the actual value is not important for most
  tests.

  test285 is changed a different way, by increasing the connect timeout.
  This improves test coverage by allowing the changed timeout value to be
  checked, but improves reliability with a carefully-chosen timeout that
  not only allows twice the time to respond as before, but also allows
  several retries before the client will change its timeout value.

  Ref: #11328

Daniel Stenberg (19 Jun 2023)

- cf-socket: skip getpeername()/getsockname for TFTP

  Since the socket is not connected then the call fails. When the call
  fails, failf() is called to write an error message that is then
  surviving and is returned when the *real* error occurs later. The
  earlier, incorrect, error therefore hides the actual error message.

  This could be seen in stderr for test 1007

  Test 1007 has now been extended to verify the stderr message.

  Closes #11332

- example/crawler: make it use a few more options

  For show, but reasonable

- libcurl-ws.3: mention raw mode

  Closes #11339

- example/default-scheme: set the default scheme for schemeless URLs

  Closes #11338

- example/hsts-preload: show one way to HSTS preload

  Closes #11337

- examples/http-options: show how to send "OPTIONS *"

  With CURLOPT_REQUEST_TARGET.

  Also add use of CURLOPT_QUICK_EXIT to show.

  Closes #11333

- examples: make use of CURLOPT_(REDIR_|)PROTOCOLS_STR

  To show how to use them

  Closes #11334

- examples/smtp-mime: use CURLOPT_MAIL_RCPT_ALLOWFAILS

  For show

  Closes #11335

- http: rectify the outgoing Cookie: header field size check

  Previously it would count the size of the entire outgoing request and
  not just the size of only the Cookie: header field - which was the
  intention.

  This could make the check be off by several hundred bytes in some cases.

  Closes #11331

Jay Satiro (17 Jun 2023)

- lib: fix some format specifiers

  - Use CURL_FORMAT_CURL_OFF_T where %zd was erroneously used for some
    curl_off_t variables.

  - Use %zu where %zd was erroneously used for some size_t variables.

  Prior to this change some of the Windows CI tests were failing because
  in Windows 32-bit targets have a 32-bit size_t and a 64-bit curl_off_t.
  When %zd was used for some curl_off_t variables then only the lower
  32-bits was read and the upper 32-bits would be read for part or all of
  the next specifier.

  Fixes https://github.com/curl/curl/issues/11327
  Closes https://github.com/curl/curl/pull/11321

Marcel Raad (16 Jun 2023)

- test427: add `cookies` feature and keyword

  This test doesn't work with `--disable-cookies`.

  Closes https://github.com/curl/curl/pull/11320

Chris Talbot (15 Jun 2023)

- imap: Provide method to disable SASL if it is advertised

  - Implement AUTH=+LOGIN for CURLOPT_LOGIN_OPTIONS to prefer plaintext
    LOGIN over SASL auth.

  Prior to this change there was no method to be able to fall back to
  LOGIN if an IMAP server advertises SASL capabilities. However, this may
  be desirable for e.g. a misconfigured server.

  Per: https://www.ietf.org/rfc/rfc5092.html#section-3.2

  ";AUTH=<enc-auth-type>" looks to be the correct way to specify what
  authenication method to use, regardless of SASL or not.

  Closes https://github.com/curl/curl/pull/10041

Daniel Stenberg (15 Jun 2023)

- RELEASE-NOTES: synced

- examples/multi-debugcallback.c: avoid the bool typedef

  Apparently this cannot be done in c23

  Reported-by: Cristian Rodríguez
  Fixes #11299
  Closes #11319

- docs/libcurl/libcurl.3: cleanups and improvements

  Closes #11317

- libcurl-ws.3: fix typo

- curl_ws_*.3: enhance

  - all: SEE ALSO the libcurl-ws man page
  - send: add example and return value information
  - meta: mention that the returned data is read-only

  Closes #11318

- docs/libcurl/libcurl-ws.3: see also CURLOPT_WS_OPTIONS

- docs/libcurl/libcurl-ws.3: minor polish

- libcurl-ws.3. WebSocket API overview

  Closes #11314

- libcurl-url.3: also mention CURLUPART_ZONEID

  ... and sort the two part-using lists alphabetically

Marcel Raad (14 Jun 2023)

- fopen: fix conversion warning on 32-bit Android

  When building for 32-bit ARM or x86 Android, `st_mode` is defined as
  `unsigned int` instead of `mode_t`, resulting in a
  -Wimplicit-int-conversion clang warning because `mode_t` is
  `unsigned short`. Add a cast to silence the warning.

  Ref: https://android.googlesource.com/platform/bionic/+/refs/tags/ndk-r25c/li
  bc/include/sys/stat.h#86
  Closes https://github.com/curl/curl/pull/11313

- http2: fix variable type

  `max_recv_speed` is `curl_off_t`, so using `size_t` might result in
  -Wconversion GCC warnings for 32-bit `size_t`. Visible in the NetBSD
  ARM autobuilds.

  Closes https://github.com/curl/curl/pull/11312

Daniel Stenberg (13 Jun 2023)

- vtls: fix potentially uninitialized local variable warnings

  Follow-up from a4a5e438ae533c

  Closes #11310

- timeval: use CLOCK_MONOTONIC_RAW if available

  Reported-by: Harry Sintonen
  Ref: #11288
  Closes #11291

Stefan Eissing (12 Jun 2023)

- tool: add curl command line option `--trace-ids`

  - added and documented --trace-ids to prepend (after the timestamp)
    the transfer and connection identifiers to each verbose log line
  - format is [n-m] with `n` being the transfer id and `m` being the
    connection id. In case there is not valid connection id, print 'x'.
  - Log calls with a handle that has no transfer id yet, are written
    without any ids.

  Closes #11185

- lib: add CURLINFO_CONN_ID and CURLINFO_XFER_ID

  - add an `id` long to Curl_easy, -1 on init
  - once added to a multi (or its own multi), it gets
    a non-negative number assigned by the connection cache
  - `id` is unique among all transfers using the same
    cache until reaching LONG_MAX where it will wrap
    around. So, not unique eternally.
  - CURLINFO_CONN_ID returns the connection id attached to
    data or, if none present, data->state.lastconnect_id
  - variables and type declared in tool for write out

  Closes #11185

Daniel Stenberg (12 Jun 2023)

- CURLOPT_INFILESIZE.3: mention -1 triggers chunked

  Ref: #11300
  Closes #11304

Philip Heiduck (12 Jun 2023)

- CI: openssl-3.0.9+quic

  Closes #11296

Karthikdasari0423 (12 Jun 2023)

- HTTP3.md: update openssl version

  Closes #11297

Daniel Stenberg (12 Jun 2023)

- vtls: avoid memory leak if sha256 call fails

  ... in the pinned public key handling function.

  Reported-by: lizhuang0630 on github
  Fixes #11306
  Closes #11307

- examples/ipv6: disable on win32

  I can't make if_nametoindex() work there

  Follow-up to c23dc42f3997acf23

  Closes #11305

- tool_operate: allow cookie lines up to 8200 bytes

  Since this option might set multiple cookies in the same line, it does
  not make total sense to cap this at 4096 bytes, which is the limit for a
  single cookie name or value.

  Closes #11303

- test427: verify sending more cookies than fit in a 8190 bytes line

  curl will then only populate the header with cookies that fit, dropping
  ones that otherwise would have been sent

  Ref: https://curl.se/mail/lib-2023-06/0020.html

  Closes #11303

- testutil: allow multiple %-operators on the same line

  Closes #11303

Oleg Jukovec (12 Jun 2023)

- docs: update CURLOPT_UPLOAD.3

  The behavior of CURLOPT_UPLOAD differs from what is described in the
  documentation. The option automatically adds the 'Transfer-Encoding:
  chunked' header if the upload size is unknown.

  Closes #11300

Daniel Stenberg (12 Jun 2023)

- RELEASE-NOTES: synced

- CURLOPT_AWS_SIGV4.3: remove unused variable from example

  Closes #11302

- examples/https.c: use CURLOPT_CA_CACHE_TIMEOUT

  for demonstration purposes

  Closes #11290

- example/ipv6: feature CURLOPT_ADDRESS_SCOPE in use

  Closes #11282

Karthikdasari0423 (10 Jun 2023)

- docs: Update HTTP3.md for newer ngtcp2 and nghttp3

  Follow-up to fb9b9b58

  Ref: #11184
  Closes #11295

Dan Fandrich (10 Jun 2023)

- docs: update the supported ngtcp2 and nghttp3 versions

  Follow-up to cae9d10b

  Ref: #11184
  Closes #11294

- tests: fix error messages & handling around sockets

  The wrong error code was checked on Windows on UNIX socket failures,
  which could have caused all UNIX sockets to be reported as having
  errored and the tests therefore skipped. Also, a useless error message
  was displayed on socket errors in many test servers on Windows because
  strerror() doesn't work on WinSock error codes; perror() is overridden
  there to work on all errors and is used instead.

  Ref #11258
  Closes #11265

Daniel Stenberg (9 Jun 2023)

- CURLOPT_SSH_PRIVATE_KEYFILE.3: expand on the file search

  Reported-by: atjg on github
  Ref: #11287
  Closes #11289

Stefan Eissing (9 Jun 2023)

- ngtcp2: use ever increasing timestamp in io

  - ngtcp2 v0.16.0 asserts that timestamps passed to its function
    will only ever increase.
  - Use a context shared between ingress/egress operations that
    uses a shared timestamp, regularly updated during calls.

  Closes #11288

Daniel Stenberg (9 Jun 2023)

- GHA: use nghttp2 1.54.0 for the ngtcp2 jobs

Philip Heiduck (9 Jun 2023)

- GHA: ngtcp2: use 0.16.0 and nghttp3 0.12.0

Daniel Stenberg (9 Jun 2023)

- ngtcp2: build with 0.16.0 and nghttp3 0.12.0

  - moved to qlog_write
  - crypto => encryption
  - CRYPTO => ENCRYPTION
  - removed "_is_"
  - ngtcp2_conn_shutdown_stream_read and
    ngtcp2_conn_shutdown_stream_write got flag arguments
  - the nghttp3_callbacks struct got a recv_settings callback

  Closes #11184

- example/http2-download: set CURLOPT_BUFFERSIZE

  Primarily because no other example sets it, and remove the disabling of
  the certificate check because we should not recommend that.

  Closes #11284

- example/crawler: also set CURLOPT_AUTOREFERER

  Could make sense, and it was not used in any example before.

  Closes #11283

Wyatt OʼDay (9 Jun 2023)

- tls13-ciphers.d: include Schannel

  Closes #11271

Daniel Stenberg (9 Jun 2023)

- curl_pushheader_byname/bynum.3: document in their own man pages

  These two functions were added in 7.44.0 when CURLMOPT_PUSHFUNCTION was
  introduced but always lived a life in the shadows, embedded in the
  CURLMOPT_PUSHFUNCTION man page. Until now.

  It makes better sense and gives more visibility to document them in
  their own stand-alone man pages.

  Closes #11286

- curl_mprintf.3: minor fix of the example

- curl_url_set: enforce the max string length check for all parts

  Update the docs and test 1559 accordingly

  Closes #11273

- examples/ftpuploadresume.c: add use of CURLOPT_ACCEPTTIMEOUT_MS

  For show

  Closes #11277

- examples/unixsocket.c: example using CURLOPT_UNIX_SOCKET_PATH

  and alternatively CURLOPT_ABSTRACT_UNIX_SOCKET

  Closes #11276

Anssi Kolehmainen (8 Jun 2023)

- docs: fix missing parameter names in examples

  Closes #11278

Daniel Stenberg (8 Jun 2023)

- urlapi: have *set(PATH) prepend a slash if one is missing

  Previously the code would just do that for the path when extracting the
  full URL, which made a subsequent curl_url_get() of the path to
  (unexpectedly) still return it without the leading path.

  Amend lib1560 to verify this. Clarify the curl_url_set() docs about it.

  Bug: https://curl.se/mail/lib-2023-06/0015.html
  Closes #11272
  Reported-by: Pedro Henrique

Dan Fandrich (7 Jun 2023)

- runtests; give each server a unique log lock file

  Logs are written by several servers and all of them must be finished
  writing before the test results can be determined. This means each
  server must have its own lock file rather than sharing a single one,
  which is how it was done up to now. Previously, the first server to
  complete a test would clear the lock before the other server was done,
  which caused flaky tests.

  Lock files are now all found in their own directory, so counting locks
  equals counting the files in that directory.  The result is that the
  proxy logs are now reliably written which actually changes the expected
  output for two tests.

  Fixes #11231
  Closes #11259

- runtests: make test file directories in log/N

  Test files in subdirectories were not created after parallel test log
  directories were moved down a level due to a now-bad comparison.

  Follow-up to 92d7dd39

  Ref #11264
  Closes #11267

Daniel Stenberg (7 Jun 2023)

- ws: make the curl_ws_meta() return pointer a const

  The returned info is read-only for the user.

  Closes #11261

- RELEASE-NOTES: synced

- runtests: move parallel log dirs from logN to log/N

  Having several hundreds of them in there gets annoying.

  Closes #11264

Dan Fandrich (7 Jun 2023)

- test447: move the test file into %LOGDIR

Viktor Szakats (7 Jun 2023)

- cmake: add support for "unity" builds

  Aka "jumbo" or "amalgamation" builds. It means to compile all sources
  per target as a single C source. This is experimental.

  You can enable it by passing `-DCMAKE_UNITY_BUILD=ON` to cmake.
  It requires CMake 3.16 or newer.

  It makes builds (much) faster, allows for better optimizations and tends
  to promote less ambiguous code.

  Also add a new AppVeyor CI job and convert an existing one to use
  "unity" mode (one MSVC, one MinGW), and enable it for one macOS CI job.

  Fix related issues:
  - add missing include guard to `easy_lock.h`.
  - rename static variables and functions (and a macro) with names reused
    across sources, or shadowed by local variables.
  - add an `#undef` after use.
  - add a missing `#undef` before use.
  - move internal definitions from `ftp.h` to `ftp.c`.
  - `curl_memory.h` fixes to make it work when included repeatedly.
  - stop building/linking curlx bits twice for a static-mode curl tool.
    These caused doubly defined symbols in unity builds.
  - silence missing extern declarations compiler warning for ` _CRT_glob`.
  - fix extern declarations for `tool_freq` and `tool_isVistaOrGreater`.
  - fix colliding static symbols in debug mode: `debugtime()` and
    `statename`.
  - rename `ssl_backend_data` structure to unique names for each
    TLS-backend, along with the `ssl_connect_data` struct member
    referencing them. This required adding casts for each access.
  - add workaround for missing `[P]UNICODE_STRING` types in certain Windows
    builds when compiling `lib/ldap.c`. To support "unity" builds, we had
    to enable `SCHANNEL_USE_BLACKLISTS` for Schannel (a Windows
    `schannel.h` option) _globally_. This caused an indirect inclusion of
    Windows `schannel.h` from `ldap.c` via `winldap.h` to have it enabled
    as well. This requires `[P]UNICODE_STRING` types, which is apperantly
    not defined automatically (as seen with both MSVS and mingw-w64).
    This patch includes `<subauth.h>` to fix it.
    Ref: https://github.com/curl/curl/runs/13987772013
    Ref: https://dev.azure.com/daniel0244/curl/_build/results?buildId=15827&vie
  w=logs&jobId=2c9f582d-e278-56b6-4354-f38a4d851906&j=2c9f582d-e278-56b6-4354-f
  38a4d851906&t=90509b00-34fa-5a81-35d7-5ed9569d331c
  - tweak unity builds to compile `lib/memdebug.c` separately in memory
    trace builds to avoid PP confusion.
  - force-disable unity for test programs.
  - do not compile and link libcurl sources to libtests _twice_ when libcurl
    is built in static mode.

  KNOWN ISSUES:
  - running tests with unity builds may fail in cases.
  - some build configurations/env may not compile in unity mode. E.g.:
    https://ci.appveyor.com/project/curlorg/curl/builds/47230972/job/51wfesgnfu
  auwl8q#L250

  Ref: https://github.com/libssh2/libssh2/issues/1034
  Ref: https://cmake.org/cmake/help/latest/prop_tgt/UNITY_BUILD.html
  Ref: https://en.wikipedia.org/wiki/Unity_build

  Closes #11095

Daniel Stenberg (7 Jun 2023)

- examples/websocket.c: websocket example using CONNECT_ONLY

  Closes #11262

- websocket-cb: example doing WebSocket download using callback

  Very basic

  Closes #11260

- test/.gitignore: ignore log*

Dan Fandrich (5 Jun 2023)

- runtests: document the -j parallel testing option

  Reported-by: Daniel Stenberg
  Ref: #10818
  Closes #11255

- runtests: create multiple test runners when requested

  Parallel testing is enabled by using a nonzero value for the -j option
  to runtests.pl. Performant values seem to be about 7*num CPU cores, or
  1.3*num CPU cores if Valgrind is in use.

  Flaky tests due to improper log locking (bug #11231) are exacerbated
  while parallel testing, so it is not enabled by default yet.

  Fixes #10818
  Closes #11246

- runtests: handle repeating tests in multiprocess mode

  Such as what happens with the --repeat option.  Some functions are
  changed to pass the runner ID instead of relying on the non-unique test
  number.

  Ref: #10818

- runtests: buffer logmsg while running singletest()

  This allows all messages relating to a single test case to be displayed
  together at the end of the test.

  Ref: #10818

- runtests: call initserverconfig() in the runner

  This must be done so variables pick up the runner's unique $LOGDIR.

  Ref: #10818

- runtests: use a per-runner random seed

  Each runner needs a unique random seed to reduce the chance of port
  number collisions. The new scheme uses a consistent per-runner source of
  randomness which results in deterministic behaviour, as it did before.

  Ref: #10818

- runtests: complete main test loop refactor for multiple runners

  The main test loop is now able to handle multiple runners, or no
  additional runner processes at all. At most one process is still
  created, however.

  Ref: #10818

- runtests: prepare main test loop for multiple runners

  Some variables are expanded to arrays and hashes so that multiple
  runners can be used for running tests.

  Ref: #10818

Stefan Eissing (5 Jun 2023)

- bufq: make write/pass methods more robust

  - related to #11242 where curl enters busy loop when
    sending http2 data to the server

  Closes #11247

Boris Verkhovskiy (5 Jun 2023)

- tool_getparam: fix comment

  Closes #11253

Raito Bezarius (5 Jun 2023)

- haproxy: add --haproxy-clientip flag to spoof client IPs

  CURLOPT_HAPROXY_CLIENT_IP in the library

  Closes #10779

Daniel Stenberg (5 Jun 2023)

- curl: add --ca-native and --proxy-ca-native

  These are two boolean options to ask curl to use the native OS's CA
  store when verifying TLS servers. For peers and for proxies
  respectively.

  They currently only have an effect for curl on Windows when built to use
  OpenSSL for TLS.

  Closes #11049

Viktor Szakats (5 Jun 2023)

- build: drop unused/redundant `HAVE_WINLDAP_H`

  Sources did not use it. Autotools used it when checking for the
  `winldap` library, which is redundant.

  With CMake, detection was broken:
  ```
  Run Build Command(s):/usr/local/Cellar/cmake/3.26.3/bin/cmake -E env VERBOSE=
  1 /usr/bin/make -f Makefile cmTC_2d8fe/fast && /Library/Developer/CommandLine
  Tools/usr/bin/make  -f CMakeFiles/cmTC_2d8fe.dir/build.make CMakeFiles/cmTC_2
  d8fe.dir/build
  Building C object CMakeFiles/cmTC_2d8fe.dir/HAVE_WINLDAP_H.c.obj
  /usr/local/opt/llvm/bin/clang --target=x86_64-w64-mingw32 --sysroot=/usr/loca
  l/opt/mingw-w64/toolchain-x86_64 -D_WINSOCKAPI_="" -I/my/quictls/x64-ucrt/usr
  /include -I/my/zlib/x64-ucrt/usr/include -I/my/brotli/x64-ucrt/usr/include -W
  no-unused-command-line-argument   -D_UCRT -DCURL_HIDDEN_SYMBOLS -DHAVE_SSL_SE
  T0_WBIO -DHAS_ALPN -DNGHTTP2_STATICLIB -DNGHTTP3_STATICLIB -DNGTCP2_STATICLIB
   -DUSE_MANUAL=1  -fuse-ld=lld -Wl,-s -static-libgcc  -lucrt  -Wextra -Wall -p
  edantic -Wbad-function-cast -Wconversion -Winline -Wmissing-declarations -Wmi
  ssing-prototypes -Wnested-externs -Wno-long-long -Wno-multichar -Wpointer-ari
  th -Wshadow -Wsign-compare -Wundef -Wunused -Wwrite-strings -Wcast-align -Wde
  claration-after-statement -Wempty-body -Wendif-labels -Wfloat-equal -Wignored
  -qualifiers -Wno-format-nonliteral -Wno-sign-conversion -Wno-system-headers -
  Wstrict-prototypes -Wtype-limits -Wvla -Wshift-sign-overflow -Wshorten-64-to-
  32 -Wdouble-promotion -Wenum-conversion -Wunused-const-variable -Wcomma -Wmis
  sing-variable-declarations -Wassign-enum -Wextra-semi-stmt  -MD -MT CMakeFile
  s/cmTC_2d8fe.dir/HAVE_WINLDAP_H.c.obj -MF CMakeFiles/cmTC_2d8fe.dir/HAVE_WINL
  DAP_H.c.obj.d -o CMakeFiles/cmTC_2d8fe.dir/HAVE_WINLDAP_H.c.obj -c /my/curl/b
  ld-cmake-llvm-x64-shared/CMakeFiles/CMakeScratch/TryCompile-3JP6dR/HAVE_WINLD
  AP_H.c
  In file included from /my/curl/bld-cmake-llvm-x64-shared/CMakeFiles/CMakeScra
  tch/TryCompile-3JP6dR/HAVE_WINLDAP_H.c:2:
  In file included from /usr/local/opt/mingw-w64/toolchain-x86_64/x86_64-w64-mi
  ngw32/include/winldap.h:17:
  In file included from /usr/local/opt/mingw-w64/toolchain-x86_64/x86_64-w64-mi
  ngw32/include/schnlsp.h:9:
  In file included from /usr/local/opt/mingw-w64/toolchain-x86_64/x86_64-w64-mi
  ngw32/include/schannel.h:10:
  /usr/local/opt/mingw-w64/toolchain-x86_64/x86_64-w64-mingw32/include/wincrypt
  .h:5041:254: error: unknown type name 'PSYSTEMTIME'
    WINIMPM PCCERT_CONTEXT WINAPI CertCreateSelfSignCertificate (HCRYPTPROV_OR_
  NCRYPT_KEY_HANDLE hCryptProvOrNCryptKey, PCERT_NAME_BLOB pSubjectIssuerBlob, 
  DWORD dwFlags, PCRYPT_KEY_PROV_INFO pKeyProvInfo, PCRYPT_ALGORITHM_IDENTIFIER
   pSignatureAlgorithm, PSYSTEMTIME pStartTime, PSYSTEMTIME pEndTime, PCERT_EXT
  ENSIONS pExtensions);
                                                                               
                                                                               
                                                                               
                        ^
  /usr/local/opt/mingw-w64/toolchain-x86_64/x86_64-w64-mingw32/include/wincrypt
  .h:5041:278: error: unknown type name 'PSYSTEMTIME'
    WINIMPM PCCERT_CONTEXT WINAPI CertCreateSelfSignCertificate (HCRYPTPROV_OR_
  NCRYPT_KEY_HANDLE hCryptProvOrNCryptKey, PCERT_NAME_BLOB pSubjectIssuerBlob, 
  DWORD dwFlags, PCRYPT_KEY_PROV_INFO pKeyProvInfo, PCRYPT_ALGORITHM_IDENTIFIER
   pSignatureAlgorithm, PSYSTEMTIME pStartTime, PSYSTEMTIME pEndTime, PCERT_EXT
  ENSIONS pExtensions);
                                                                               
                                                                               
                                                                               
                                                ^
  2 errors generated.
  make[1]: *** [CMakeFiles/cmTC_2d8fe.dir/HAVE_WINLDAP_H.c.obj] Error 1
  make: *** [cmTC_2d8fe/fast] Error 2
  exitCode: 2
  ```

  Cherry-picked from #11095 88e4a21ff70ccef391cf99c8165281ff81374503
  Reviewed-by: Daniel Stenberg
  Closes #11245

Daniel Stenberg (5 Jun 2023)

- urlapi: scheme starts with alpha

  Add multiple tests to lib1560 to verify

  Fixes #11249
  Reported-by: ad0p on github
  Closes #11250

- RELEASE-NOTES: synced

- CURLOPT_MAIL_RCPT_ALLOWFAILS: replace CURLOPT_MAIL_RCPT_ALLLOWFAILS

  Deprecate the name using three Ls and prefer the name with two.

  Replaces #10047
  Closes #11218

- tests/servers: generate temp names in /tmp for unix domain sockets

  ... instead of putting them in the regular pid directories because
  systems generally have strict length requirements for the path name to
  be shorter than 107 bytes and we easily hit that boundary otherwise.

  The new concept generates two random names: one for the socks daemon and
  one for http.

  Reported-by: Andy Fiddaman
  Fixes #11152
  Closes #11166

Stefan Eissing (2 Jun 2023)

- http2: better support for --limit-rate

  - leave transfer loop when --limit-rate is in effect and has
    been received
  - adjust stream window size to --limit-rate plus some slack
    to make the server observe the pacing we want
  - add test case to confirm behaviour

  Closes #11115

- curl_log: evaluate log statement only when transfer is verbose

  Closes #11238

Daniel Stenberg (2 Jun 2023)

- libssh2: provide error message when setting host key type fails

  Ref: https://curl.se/mail/archive-2023-06/0001.html

  Closes #11240

Igor Todorovski (2 Jun 2023)

- system.h: remove __IBMC__/__IBMCPP__ guards and apply to all z/OS compiles

  Closes #11241

Daniel Stenberg (2 Jun 2023)

- docs/SECURITY-PROCESS.md: link to example of previous critical flaw

Mark Seuffert (2 Jun 2023)

- README.md: updated link to opencollective

  Closes #11232

Daniel Stenberg (1 Jun 2023)

- libssh2: use custom memory functions

  Because of how libssh2_userauth_keyboard_interactive_ex() works: the
  libcurl callback allocates memory that is later free()d by libssh2, we
  must set the custom memory functions.

  Reverts 8b5f100db388ee60118c08aa28

  Ref: https://github.com/libssh2/libssh2/issues/1078
  Closes #11235

- test447: test PUTting a file that grows

  ... and have curl trim the end when it reaches the expected total amount
  of bytes instead of over-sending.

  Reported-by: JustAnotherArchivist on github
  Closes #11223

- curl: count uploaded data to stop at the originally given size

  Closes #11223
  Fixes #11222
  Reported-by: JustAnotherArchivist on github

- tool: remove exclamation marks from error/warning messages

- tool: use errorf() for error output

  Convert a number of fprintf() calls.

- tool: remove newlines from all helpf/notef/warnf/errorf calls

  Make voutf() always add one.

  Closes #11226

- tests/servers.pm: pick unused port number with a server socket

  This change replaces the previous method of picking a port number at
  random to try to start servers on, then retrying up to ten times with
  new random numbers each time, with a function that creates a server
  socket on port zero, thereby getting a suitable random port set by the
  kernel. That server socket is then closed and that port number is used
  to setup the actual test server on.

  There is a risk that *another* server can be started on the machine in
  the time gap, but the server verification feature will detect that.

  Closes #11220

- RELEASE-NOTES: synced

  bump to 8.2.0

Alejandro R. Sedeño (31 May 2023)

- configure: fix run-compiler for old /bin/sh

  If you try to assign and export on the same line on some older /bin/sh
  implementations, it complains:

  ```
  $ export "NAME=value"
  NAME=value: is not an identifier
  ```

  This commit rewrites run-compiler's assignments and exports to work with
  old /bin/sh, splitting assignment and export into two separate
  statements, and only quote the value. So now we have:

  ```
  NAME="value"
  export NAME
  ```

  While we're here, make the same change to the two supporting
  assign+export lines preceeding the script to be consistent with how
  exports work throughout the rest of configure.ac.

  Closes #11228

Philip Heiduck (31 May 2023)

- circleci: install impacket & wolfssl 5.6.0

  Closes #11221

Daniel Stenberg (31 May 2023)

- tool_urlglob: use curl_off_t instead of longs

  To handle more globs better (especially on Windows)

  Closes #11224

Dan Fandrich (30 May 2023)

- scripts: Fix GHA matrix job detection in cijobs.pl

  The parsing is pretty brittle and it broke detecting some jobs at some
  point. Also, detect if Windows is used in GHA.

- runtests: abort test run after failure without -a

  This was broken in a recent refactor and test runs would not stop.

  Follow-up to d4a1b5b6

  Reported-by: Daniel Stenberg
  Fixes #11225
  Closes #11227

Version 8.1.2 (30 May 2023)

Daniel Stenberg (30 May 2023)

- RELEASE-NOTES: synced

  8.1.2 release

- THANKS: contributors from 8.1.2

- lib1560: verify more scheme guessing

  - on 2nd level domains
  - on names without dots

  As mentioned in #11161, "imap.com" will be guessed IMAP

  Closes #11219

- page-header: minor wording polish in the URL segment

  Closes #11217

- page-header: mention curl version and how to figure out current release

  Closes #11216

- RELEASE-NOTES: synced

- configure: without pkg-config and no custom path, use -lnghttp2

  Reported-by: correctmost on github
  Fixes #11186
  Closes #11210

Stefan Eissing (28 May 2023)

- curl: cache the --trace-time value for a second

  - caches HH:MM:SS computed and reuses it for logging during
    the same second.
  - common function for plain log line start formatting

  Closes #11211

Kev Jackson (28 May 2023)

- libcurl.m4: remove trailing 'dnl' that causes this to break autoconf

  Closes #11212

Stefan Eissing (26 May 2023)

- http3: send EOF indicator early as possible

  - ngtcp2 and quiche implementations relied on the DONE_SEND event
    to forward the EOF for uploads to the libraries. This often
    result in a last 0 length EOF data. Tracking the amount of
    data left to upload allows EOF indication earlier.
  - refs #11205 where CloudFlare DoH servers did not like to
    receive the initial upload DATA without EOF and returned
    a 400 Bad Request

  Reported-by: Sergey Fionov
  Fixes #11205
  Closes #11207

Daniel Stenberg (26 May 2023)

- scripts/contri*sh: no longer grep -v ' '

  Originally these scripts filtered out names that have no space so that
  they better avoid nick names not intended for credits. Such names are
  not too commonly used, plus we now give credit even to those.

  Additionally: non-latin names, like Asian, don't have spaces at all so
  they were also filtered out and had to be manually added which made it
  an error-prone operation where Asian names eventually easily fell off by
  mistake.

  Closes #11206

- cf-socket: restore Curl_sock_assign_addr()

  Regression since it was not private. Also used by msh3.c

  Follow-up to 8e85764b7bd7f05f5
  Reported-by: Gisle Vanem
  Fixes #11202
  Closes #11204

- RELEASE-NOTES: synced

  Taken down to 8.1.2 now for pending patch release

- libssh: when keyboard-interactive auth fails, try password

  The state machine had a mistake in that it would not carry on to that
  next step.

  This also adds a verbose output what methods that are available from the
  server and renames the macros that change to the next auth methods to
  try.

  Reported-by: 左潇峰
  Fixes #11196
  Closes #11197

Emanuele Torre (25 May 2023)

- configure: fix build with arbitrary CC and LD_LIBRARY_PATH

  Since ./configure and processes that inherit its environment variables
  are the only callers of the run-compiler script, we can just save the
  current value of the LD_LIBRARY_PATH and CC variables to another pair of
  environment variables, and make run-compiler a static script that
  simply restores CC and LD_LIBRARY_PATH to the saved value, and before
  running the compiler.

  This avoids having to inject the values of the variables in the script,
  possibly causing problems if they contains spaces, quotes, and other
  special characters.

  Also add exports in the script just in case LD_LIBRARY_PATH and CC are
  not already in the environment.

  follow-up from 471dab2

  Closes #11182

Daniel Stenberg (25 May 2023)

- urlapi: remove superfluous host name check

  ... as it is checked later more proper.

  Closes #11195

Stefan Eissing (25 May 2023)

- http2: fix EOF handling on uploads with auth negotiation

  - doing a POST with `--digest` does an override on the initial request
    with `Content-Length: 0`, but the http2 filter was unaware of that
    and expected the originally request body. It did therefore not
    send a final DATA frame with EOF flag to the server.
  - The fix overrides any initial notion of post size when the `done_send`
    event is triggered by the transfer loop, leading to the EOF that
    is necessary.
  - refs #11194. The fault did not happen in testing, as Apache httpd
    never tries to read the request body of the initial request,
    sends the 401 reply and closes the stream. The server used in the
    reported issue however tried to read the EOF and timed out on the
    request.

  Reported-by: Aleksander Mazur
  Fixes #11194
  Cloes #11200

Daniel Stenberg (23 May 2023)

- RELEASE-NOTES: synced

  bump to 8.2.0

- lib: remove unused functions, make single-use static

  Closes #11174

- scripts/singleuse.pl: add more API calls

Christian Hesse (23 May 2023)

- configure: quote the assignments for run-compiler

  Building for multilib failed, as the compiler command contains an
  extra argument. That needs quoting.

  Regression from b78ca50cb3dda361f9c1

  Fixes #11179
  Closes #11180

Daniel Stenberg (23 May 2023)

- misc: fix spelling mistakes

  Reported-by: musvaage on github
  Fixes #11171
  Closes #11172

Version 8.1.1 (23 May 2023)

Daniel Stenberg (23 May 2023)

- RELEASE-NOTES: synced

  curl 8.1.1

- THANKS: contributors from the 8.1.1 release

Dan Fandrich (22 May 2023)

- docs: fix fuzzing documentation link

  Follow-up to 4c712a1b

- CI: add an Alpine build with MUSL

  MUSL is another libc implementation which has its own unique issues
  worth testing.

  Ref: #11140
  Closes #11178

- runtests: add a missing \n at the end of a log message

correctmost on github (22 May 2023)

- SECURITY-PROCESS.md: link security advisory doc and fix typo

  Closes #11177

Daniel Stenberg (22 May 2023)

- TODO: build curl with Windows Unicode support

  Closes #7229

- KNOWN_BUGS: hyper memory-leaks

  Closes #10803

Stefan Eissing (22 May 2023)

- http/2: unstick uploads

  - refs #11157 and #11175 where uploads get stuck or lead to RST streams
  - fixes our h2 send behaviour to continue sending in the nghttp2 session
    as long as it wants to. This will empty our send buffer as long as
    the remote stream/connection window allows.
  - in case the window is exhausted, the data remaining in the send buffer
    will wait for a WINDOW_UPDATE from the server. Which is a socket event
    that engages our transfer loop again
  - the problem in the issue was that we did not exhaust the window, but
    left data in the sendbuffer and no further socket events did happen.
    The server was just waiting for us to send more.
  - relatedly, there was an issue fixed that closing a stream with KEEP_HOLD
    set kept the transfer from shutting down - as it should have - leading
    to a timeout.

  Closes #11176

Daniel Stenberg (21 May 2023)

- workflows/macos: add a job using gcc + debug + secure transport

Jay Satiro (21 May 2023)

- lib: fix conversion warnings with gcc on macOS

Daniel Stenberg (21 May 2023)

- sectransp.c: make the code c89 compatible

  Follow-up to dd2bb485521c2ec713001b3a

  Reported-by: FeignClaims on github
  Fixes #11155
  Closes #11159

Emanuele Torre (21 May 2023)

- Revert "urlapi: respect CURLU_ALLOW_SPACE and CURLU_NO_AUTHORITY for redirect
  s"

  This reverts commit df6c2f7b544f1f35f2a3e0be11f345affeb6fe9c.
  (It only keep the test case that checks redirection to an absolute URL
  without hostname and CURLU_NO_AUTHORITY).

  I originally wanted to make CURLU_ALLOW_SPACE accept spaces in the
  hostname only because I thought
  curl_url_set(CURLUPART_URL, CURLU_ALLOW_SPACE) was already accepting
  them, and they were only not being accepted in the hostname when
  curl_url_set(CURLUPART_URL) was used for a redirection.

  That is not actually the case, urlapi never accepted hostnames with
  spaces, and a hostname with a space in it never makes sense.
  I probably misread the output of my original test when I they were
  normally accepted when using CURLU_ALLOW_SPACE, and not redirecting.

  Some other URL parsers seems to allow space in the host part of the URL,
  e.g. both python3's urllib.parse module, and Chromium's javascript URL
  object allow spaces (chromium percent escapes the spaces with %20),
  (they also both ignore TABs, and other whitespace characters), but those
  URLs with spaces in the hostname are useless, neither python3's requests
  module nor Chromium's window.location can actually use them.

  There is no reason to add support for URLs with spaces in the host,
  since it was not a inconsistency bug; let's revert that patch before it
  makes it into release. Sorry about that.

  I also reverted the extra check for CURLU_NO_AUTHORITY since that does
  not seem to be necessary, CURLU_NO_AUTHORITY already worked for
  redirects.

  Closes #11169

Dan Fandrich (20 May 2023)

- runtests: use the correct fd after select

  The code was using the wrong fd when determining which runner was ready
  with a response.

  Ref: #10818
  Closes #11160

- test425: fix the log directory for the upload

  This must be %LOGDIR to let it work with parallel tests.

  Ref: #10969

- runtests: handle interrupted reads from IPC pipes

  These can be interrupted by signals, especially SIGINT to shut down, and
  must be restarted so the IPC call arrives correctly. If the read just
  returns an error instead, the IPC calling state will go out of sync and
  a proper shutdown won't happen.

  Ref: #10818

Stefan Eissing (20 May 2023)

- http2: upload improvements

  Make send buffer smaller to have progress and "upload done" reporting
  closer to reality. Fix handling of send "drain" condition to no longer
  trigger once the transfer loop reports it is done sending. Also do not
  trigger the send "drain" on RST streams.

  Background:
  - a upload stall was reported in #11157 that timed out
  - test_07_33a reproduces a problem with such a stall if the
    server 404s the request and RSTs the stream.
  - test_07_33b verifies a successful PUT, using the parameters
    from #11157 and checks success

  Ref: #11157
  Closes #11165

- http2: increase stream window size to 10 MB

  Reported-by: pandada8 on github

  Fixes #11162
  Closes #11167

Daniel Stenberg (20 May 2023)

- lib: rename struct 'http_req' to 'httpreq'

  Because FreeBSD 14 kidnapped the name.
  Ref: https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=271526

  Fixes #11163
  Closes #11164

Viktor Szakats (20 May 2023)

- cmake: avoid `list(PREPEND)` for compatibility

  `list(PREPEND)` requires CMake v3.15, our minimum is v3.7.

  Ref: https://cmake.org/cmake/help/latest/command/list.html#prepend

  Regression from 1e3319a167d2f32d295603167486e9e88af9bb4e

  Reported-by: Keitagit-kun on Github
  Fixes #11141
  Closes #11144

Daniel Stenberg (19 May 2023)

- RELEASE-NOTES: synced

Stefan Eissing (19 May 2023)

- ngtcp2: proper handling of uint64_t when adjusting send buffer

  Fixes #11149
  Closes #11153

- ngtcp2: fix compiler warning about possible null-deref

  - compiler analyzer did not include the call context for this
    static function where the condition had already been checked.
  - eleminating the problem by making stream a call parameter

  Fixes #11147
  Closes #11151

Emanuele Torre (19 May 2023)

- docs: document that curl_url_cleanup(NULL) is a safe no-op

  This has always been the case, but it was not documented.

  The paragraph was copied verbatim from curl_easy_cleanup.3

  Closes #11150

Antoine Pitrou (19 May 2023)

- select: avoid returning an error on EINTR from select() or poll()

  This was already done for the poll() and select() calls
  made directly from Curl_poll(), but was missed in
  Curl_wait_ms(), which is called when there are no fds
  to wait on.

  Fixes #11135
  Closes #11143

Daniel Stenberg (19 May 2023)

- vquic.c: make recvfrom_packets static, avoid compiler warning

  warning: no previous prototype for 'recvfrom_packets'

  Reported-by: Keitagit-kun on github
  Fixes #11146
  Closes #11148

- urlapi: allow numerical parts in the host name

  It can only be an IPv4 address if all parts are all digits and no more than
  four parts, otherwise it is a host name. Even slightly wrong IPv4 will now be
  passed through as a host name.

  Regression from 17a15d88467 shipped in 8.1.0

  Extended test 1560 accordingly.

  Reported-by: Pavel Kalyugin
  Fixes #11129
  Closes #11131

Emilio Cobos Álvarez (19 May 2023)

- http2: double http request parser max line length

  This works around #11138, by doubling the limit, and should be a
  relatively safe fix.

  Ideally the buffer would grow as needed and there would be no need for a
  limit? But that might be follow-up material.

  Fixes #11138
  Closes #11139

Emanuele Torre (18 May 2023)

- configure: fix --help alignment

  AC_ARG_ENABLE seems to only trim off whitespace from the start and end
  of its help-string argument, while prepending two spaces of indentation
  to all lines.

  This means that the two spaces of indentation between the --enable-rtsp
  and the --disable-rtsp line were not removed causing ./configure --help
  to print:

    Optional Features:
      [...]
      --enable-rtsp           Enable RTSP support
        --disable-rtsp          Disable RTSP support

  I removed the indentation to fix the issue, now it prints:

    Optional Features:
      [...]
      --enable-rtsp           Enable RTSP support
      --disable-rtsp          Disable RTSP support

  The --enable-hsts and --disable-hsts lines had the same problems, and
  have been fixed too.

  Closes #11142

Deal(一线灵) (18 May 2023)

- cmake: repair cross compiling

  It cannot *run* code for testing purposes when cross-compiling.

  Closes #11130

Daniel Stenberg (18 May 2023)

- configure: generate a script to run the compiler

  in the CURL_RUN_IFELSE macro, with LD_LIBRARY_PATH set to the value of
  the configure invoke, and not the value that might be used later,
  intended for the execution of the output the compiler ouputs.

  For example when the compiler uses the same library (like libz) that
  configure checks for.

  Reported-by: Jonas Bülow
  Fixes #11114
  Closes #11120

Stefan Eissing (18 May 2023)

- cf-socket: completely remove the disabled USE_RECV_BEFORE_SEND_WORKAROUND

  Closes #11118

Emanuele Torre (18 May 2023)

- urlapi: respect CURLU_ALLOW_SPACE and CURLU_NO_AUTHORITY for redirects

  curl_url_set(uh, CURLUPART_URL, redirurl, flags)  was not respecing
  CURLU_ALLOW_SPACE and CURLU_NO_AUTHORITY in the host part of redirurl
  when redirecting to an absolute URL.

  Closes #11136

Colin Cross (18 May 2023)

- hostip: move easy_lock.h include above curl_memory.h

  Similar to #9561, move easy_lock.h above curl_memory.h to fix building
  against musl libc.

  Closes #11140

Hind Montassif (18 May 2023)

- curl_easy_getinfo: clarify on return data types

  Closes #11126

Emanuele Torre (18 May 2023)

- checksrc: disallow spaces before labels

  Out of 415 labels throughout the code base, 86 of those labels were
  not at the start of the line. Which means labels always at the start of
  the line is the favoured style overall with 329 instances.

  Out of the 86 labels not at the start of the line:
  * 75 were indented with the same indentation level of the following line
  * 8 were indented with exactly one space
  * 2 were indented with one fewer indentation level then the following
    line
  * 1 was indented with the indentation level of the following line minus
    three space (probably unintentional)

  Co-Authored-By: Viktor Szakats

  Closes #11134

Daniel Stenberg (18 May 2023)

- cookie: update the comment on cookie length and size limits

  To refer to the proper cookie RFC and the upcoming RFC refresh.

  Closes #11127

- url: provide better error message when URLs fail to parse

  By providing the URL API error message into the error message.

  Ref: #11129
  Closes #11137

- RELEASE-NOTES: synced

  bumped to 8.1.1

Jon Rumsey (18 May 2023)

- os400: update chkstrings.c

  Compensate changes for recent changes to urldata.h to reclassify
  STRING_AWS_SIGV4.

  Fixes #11132
  Closes #11133

Version 8.1.0 (17 May 2023)

Daniel Stenberg (17 May 2023)

- RELEASE-NOTES: synced

- THANKS: contributors from the 8.1.0 release

- hostip: include easy_lock.h before using GLOBAL_INIT_IS_THREADSAFE

  Since that header file is the only place that define can be defined.

  Reported-by: Marc Deslauriers

  Follow-up to 13718030ad4b3209

  Closes #11121

Thomas Taylor (16 May 2023)

- aws-sigv4.d: fix region identifier in example

  Closes #11117

Philip Heiduck (15 May 2023)

- mlc_config.json: remove this linkcheck CI job config file

  Closes #11113

Daniel Silverstone (15 May 2023)

- ssh: Add support for libssh2 read timeout

  Hook the new (1.11.0 or newer) libssh2 support for setting a read timeout
  into the SERVER_RESPONSE_TIMEOUT option.  With this done, clients can use
  the standard curl response timeout setting to also control the time that
  libssh2 will wait for packets from a slow server.  This is necessary to
  enable use of very slow SFTP servers.

  Signed-off-by: Daniel Silverstone <daniel.silverstone@codethink.co.uk>

  Closes #10965

Osama Albahrani (14 May 2023)

- GIT-INFO: add --with-openssl

  Closes #11110

Daniel Stenberg (13 May 2023)

- RELEASE-NOTES: synced

Marcel Raad (13 May 2023)

- md(4|5): don't use deprecated iOS functions

  They are marked as deprecated in iOS 13.0, which might result in
  warnings-as-errors.

  Also, use `*_MIN_REQUIRED` instead of `*_MIN_ALLOWED`, which seems to
  be what's currently used.

  Bug: https://github.com/curl/curl/issues/11098
  Closes https://github.com/curl/curl/pull/11102

- md4: only build when used

  Its only usage in curl_ntlm_core.c is guarded by `USE_CURL_NTLM_CORE`,
  so let's use this here too.

  Ref: https://github.com/curl/curl/issues/11098
  Closes https://github.com/curl/curl/pull/11102

Vítor Galvão (12 May 2023)

- write-out.d: Use response_code in example

  Closes #11107

Shohei Maeda (12 May 2023)

- url: fix null dispname for --connect-to option

  Closes #11106

Daniel Stenberg (12 May 2023)

- test2306: verify getting a second response with folded headers

  Reproduces the isue #11101 and verifies the fix.

  Verifies a17b2a503f

- headers: clear (possibly) lingering pointer in init

  The "prevhead" pointer is used for the headers storage but was not
  cleared correctly in init, which made it possible to act up when a
  handle is reused.

  Reported-by: Steve Herrell
  Fixes #11101
  Closes #11103

- RELEASE-NOTES: synced

- ngtcp2: use 0.15.0

  - nghttp3 0.11.0
  - nghttp2 1.53.0

  Adapt to new API calls

  Closes #11031

Jay Satiro (10 May 2023)

- openssl: fix indent

Daniel Stenberg (10 May 2023)

- CURLOPT_DNS_CACHE_TIMEOUT.3: fix spelling

  Follow-up to 9ed7d56e044f5aa1b29

  Closes #11096

- hostip: use time_t for storing oldest DNS entry

  Theoretically, the oldest time could overflow an int. In practice that
  won't happen, but let's do this to please analyzers.

  Follow-up to 9ed7d56e044f5aa1b2928ccde6245d0

  Pointed out by Coverity.
  Closes #11094

- http: free the url before storing a new copy

  To avoid a memory-leak.

  Reported-by: Hiroki Kurosawa

  Closes #11093

- compressed.d: clarify the words on "not notifying headers"

  Reported-by: Dylan Anthony
  Fixes #11091
  Closes #11092

- libssh2: free fingerprint better

  Reported-by: Wei Chong Tan
  Closes #11088

- CURLOPT_IPRESOLVE.3: clarify that this for host names, not IP addresses

  Reported-by: Harry Sintonen
  Closes #11087

- hostip: enforce a maximum DNS cache size independent of timeout value

  To reduce the damage an application can cause if using -1 or other
  ridiculous timeout values and letting the cache live long times.

  The maximum number of entries in the DNS cache is now totally
  arbitrarily and hard-coded set to 29999.

  Closes #11084

- hostip: store dns timeout as 'int'

  ... because it set and held as an 'int' elsewhere and can never be
  larger.

- RELEASE-NOTES: synced

- tool_operate: refuse (--data or --form) and --continue-at combo

  libcurl assumes that a --continue-at resumption is done to continue an
  upload using the read callback and neither --data nor --form use
  that and thus won't do what the user wants. Whatever the user wants
  with this strange combination.

  Add test 426 to verify.

  Reported-by: Smackd0wn on github
  Fixes #11081
  Closes #11083

- transfer: refuse POSTFIELDS + RESUME_FROM combo

  The code assumes that such a resume is wanting to continue an upload
  using the read callback, and since POSTFIELDS is done without callback
  libcurl will just misbehave.

  This combo will make the transfer fail with CURLE_BAD_FUNCTION_ARGUMENT
  with an explanation in the error message.

  Reported-by: Smackd0wn on github
  Fixes #11081
  Closes #11083

- ipv4.d/ipv6.d: they are "mutex", not "boolean"

  ... which for example means they do not have --no-* versions.

  Reported-by: Harry Sintonen
  Fixes #11085
  Closes #11086

- docs/SECURITY-ADVISORY.md: how to write a curl security advisory

  Closes #11080

nobedee on github (5 May 2023)

- MANUAL.md: add dict example for looking up a single definition

  Closes #11077

Dan Fandrich (5 May 2023)

- runtests: fix -c option when run with valgrind

  The curl binary argument wasn't being quoted properly. This seems to
  have broken at some point after quoting was added in commit 606b29fe.

  Reported-by: Daniel Stenberg
  Ref: #11073
  Fixes #11074
  Closes #11076

- runtests: support creating more than one runner process

  The controller currently only creates and uses one, but more are now
  possible.

  Ref: #10818

- runtests: spawn a new process for the test runner

  When the -j option is given, a new process is spawned in which the test
  programs are run and from which test servers are started. Only one
  process can be started at once, but this is sufficient to test that the
  infrastructure can isolate those functions in a new task. There should
  be no visible difference between the two modes at the moment.

  Ref: #10818
  Closes #11064

- runtests: turn singletest() into a state machine

  This allows it to run in a non-blocking manner.

  Ref: #10818

- runtests: change runner interface to be asynchronous

  Program arguments are marshalled and then written to the end of a pipe
  which is later read from and the arguments unmarshalled before the
  desired function is called normally.  The function return values are
  then marshalled and written into another pipe when is later read from
  and unmarshalled before being returned to the caller.

  The implementation is currently blocking but can be made non-blocking
  without any changes to the API.  This allows calling multiple runners
  without blocking in the future.

  Ref: #10818

- runtests: call citest_finishtest in singletest

  This is where citest_starttest is called.

  Ref: #10818

- runtests: add a runner initialization function

  This sets up the runner environment to start running tests.

  Ref: #10818

- runtests: remove directory from server filename variables

  There will soon be multiple log directories so the paths will no longer
  be static in runtests.pl. Also, get rid of $SERVER2IN which was not
  used.

  Ref: #10818

- runtests: reduce package exports after refactoring

  Some recent refactoring made these export no longer necessary. Also,
  stop displaying the Unix socket paths at startup since there will soon
  be many of them and they're not that interesting.

  Ref: #10818

- runtests: use a function to obtain $LOGDIR for a test

  This will no longer be static soon.

  Ref: #10818

Jay Satiro (5 May 2023)

- tool_cb_hdr: Fix 'Location:' formatting for early VTE terminals

  - Disable hyperlink formatting for the 'Location:' header value in VTE
    0.48.1 and earlier, since it is buggy in some of those versions.

  Prior to this change those terminals may show the location header value
  as gibberish or show it twice.

  Ref: https://gist.github.com/egmontkob/eb114294efbcd5adb1944c9f3cb5feda#backw
  ard-compatibility

  Fixes https://github.com/curl/curl/issues/10428
  Closes https://github.com/curl/curl/pull/11071

François Michel (3 May 2023)

- quiche: disable pacing while pacing is not actually performed

  Closes #11068

Daniel Stenberg (2 May 2023)

- easy_cleanup: require a "good" handle to act

  By insisting that the passed in handle is "good" (the magic number is
  intact), this can limit the potential damage if a bad pointer is passed
  in. Like when this function is called twice on the same handle pointer.

  Ref: #10964
  Closes #11061

Andreas Falkenhahn (1 May 2023)

- amiga: Fix CA certificate paths for AmiSSL and MorphOS

  AmiSSL stores certificates in `AmiSSL:Certs` and MorphOS stores them in
  `MOSSYS:Data/SSL/curl-ca-bundle.crt`.

  Closes https://github.com/curl/curl/pull/11059

Daniel Stenberg (30 Apr 2023)

- http2: (void)-mark when we explicitly ignore the return code

  When h2_progress_egress() is called. Pointed out by Coverity.

  Closes #11057

- checksrc: find bad indentation in conditions without open brace

  If the previous line starts with if/while/for AND ends with a closed
  parenthesis and there's an equal number of open and closed parentheses
  on that line, verify that this line is indented $indent more steps, if
  not a cpp line.

  Also adjust the fall-out from this fix.

  Closes #11054

Diogo Teles Sant'Anna (28 Apr 2023)

- CI: Set minimal permissions on workflow ngtcp2-quictls.yml

  Signed-off-by: Diogo Teles Sant'Anna <diogoteles@google.com>

  Closes #11055

Dan Fandrich (28 Apr 2023)

- CI: use another glob syntax for matching files on Appveyor

  The previous globbing syntax was not matching files recursively in
  directories, so try appending a /* to more closely match the examples at
  https://www.appveyor.com/docs/how-to/filtering-commits/

Daniel Stenberg (28 Apr 2023)

- multi: add multi-ignore logic to multi_socket_action

  The multi-ignore logic that was previously applied to
  curl_multi_perform() (#10750) is here applied to the loop within
  curl_multi_socket_action() to make it use the same optimization: most
  handles have the same signal-ignore option state so this drastically
  reduces the number of ignore/unignore calls per libcurl function invoke.

  Follow-up to bc90308328afb8

  Closes #11045

Stefan Eissing (28 Apr 2023)

- http2: do flow window accounting for cancelled streams

  - nghttp2 does not free connection level window flow for
    aborted streams
  - when closing transfers, make sure that any buffered
    response data is "given back" to the flow control window
  - add tests test_02_22 and test_02_23 to reproduce

  Closes #11052

- pingpong: fix compiler warning "assigning an enum to unsigned char"

  Closes #11050

Daniel Stenberg (28 Apr 2023)

- configure: fix detection of apxs (for httpd)

  The condition check was turned the wrong way around!

  Closes #11051

Viktor Szakats (28 Apr 2023)

- ci: `-Wno-vla` no longer necessary

  We handle this issue in the source now.

  Follow-up to b725fe1944b45406676ea3aff333ae3085a848d9

  Reviewed-by: Marcel Raad
  Reviewed-by: Daniel Stenberg
  Closes #11048

Marcel Raad (28 Apr 2023)

- tests/http: make curl_setup.h the first include

  This is required for the macros there to take effect for system
  libraries. Specifically, including the system libraries first led to
  warnings about `_FILE_OFFSET_BITS` being redefined in curl_config.h on
  the Solaris autobuilds for ws-data.c and ws-pingpong.c.
  Also make the curl includes come first for the other source files here
  for consistency.

  Closes https://github.com/curl/curl/pull/11046

Emanuele Torre (27 Apr 2023)

- checksrc: check for spaces before the colon of switch labels

  Closes #11047

Daniel Stenberg (27 Apr 2023)

- RELEASE-NOTES: synced

- libssh: tell it to use SFTP non-blocking

  Reported-by: Andreas Huebner
  Fixes #11020
  Closes #11039

Stefan Eissing (27 Apr 2023)

- http2: enlarge the connection window

  - fixes stalled connections

  - Make the connection window large enough, so that there is
    some room left should 99/100 streams be PAUSED by the application

  Reported-by: Paweł Wegner
  Fixes #10988
  Closes #11043

Daniel Stenberg (27 Apr 2023)

- checksrc: fix SPACEBEFOREPAREN for conditions starting with "*"

  The open paren check wants to warn for spaces before open parenthesis
  for if/while/for but also for any function call. In order to avoid
  catching function pointer declarations, the logic allows a space if the
  first character after the open parenthesis is an asterisk.

  I also spotted what we did not include "switch" in the check but we should.

  This check is a little lame, but we reduce this problem by not allowing
  that space for if/while/for/switch.

  Reported-by: Emanuele Torre
  Closes #11044

- docs: minor polish

  - "an HTTP*" (not "a")
  - remove a few contractions
  - remove a spurious "a"
  - reduce use of "I" in texts

  Closes #11040

- ws: fix CONT opcode check

  Detected by Coverity. Follow-up to 930c00c259

  Closes #11037

Dan Fandrich (27 Apr 2023)

- CI: switch the awslc builds to build out-of-tree

  This is a common configuration that should be tested to avoid
  regressions. The awsls cmake build was already out-of-tree so the
  automake build now joins it.

  Ref: #11006

- tests/http: fix out-of-tree builds

  Add both lib/ directories (src & build) to the search path so
  curl_setup.h and its dependencies can be found.

  Followup-to acd82c8b

  Ref: #11006
  Closes #11036

Daniel Stenberg (27 Apr 2023)

- urlapi: make internal function start with Curl_

  Curl_url_set_authority() it is.

  Follow-up to acd82c8bfd

  Closes #11035

YX Hao (26 Apr 2023)

- cf-socket: turn off IPV6_V6ONLY on Windows if it is supported

  IPV6_V6ONLY refs:
  https://en.wikipedia.org/wiki/IPv6#IPv4-mapped_IPv6_addresses
  https://github.com/golang/go/blob/master/src/net/ipsock_posix.go
  https://en.wikipedia.org/wiki/Unix-like
  https://learn.microsoft.com/en-us/windows/win32/winsock/ipproto-ipv6-socket-o
  ptions

  default value refs:
  https://datatracker.ietf.org/doc/html/rfc3493#section-5.3
  https://www.kernel.org/doc/html/latest/networking/ip-sysctl.html#proc-sys-net
  -ipv6-variables

  Closes #10975

Daniel Stenberg (26 Apr 2023)

- urldata: shrink *select_bits int => unsigned char

  - dselect_bits
  - cselect_bits

  ... are using less than 8 bits. Changed types and moved them towards
  the end of the structs to fit better.

  Closes #11025

Stefan Eissing (26 Apr 2023)

- tests/http: more tests with specific clients

  - Makefile support for building test specific clients in tests/http/clients
  - auto-make of clients when invoking pytest
  - added test_09_02 for server PUSH_PROMISEs using clients/h2-serverpush
  - added test_02_21 for lib based downloads and pausing/unpausing transfers

  curl url parser:
  - added internal method `curl_url_set_authority()` for setting the
    authority part of a url (used for PUSH_PROMISE)

  http2:
  - made logging of PUSH_PROMISE handling nicer

  Placing python test requirements in requirements.txt files
  - separate files to base test suite and http tests since use
    and module lists differ
  - using the files in the gh workflows

  websocket test cases, fixes for we and bufq
  - bufq: account for spare chunks in space calculation
  - bufq: reset chunks that are skipped empty
  - ws: correctly encode frames with 126 bytes payload
  - ws: update frame meta information on first call of collect
    callback that fills user buffer
  - test client ws-data: some test/reporting improvements

  Closes #11006

Jay Satiro (26 Apr 2023)

- libssh2: fix crash in keyboard callback

  - Always set the libssh2 'abstract' user-pointer to the libcurl easy
    handle associated with the ssh session, so it is always passed to the
    ssh keyboard callback.

  Prior to this change and since 8b5f100 (precedes curl 8.0.0), if libcurl
  was built without CURL_DEBUG then it could crash during the ssh auth
  phase due to a null dereference in the ssh keyboard callback.

  Reported-by: Andreas Falkenhahn

  Fixes https://github.com/curl/curl/pull/11024
  Closes https://github.com/curl/curl/pull/11026

Daniel Stenberg (26 Apr 2023)

- docs: clarify that more backends have HTTPS proxy support

  Closes #11033

- KNOWN_BUGS: remove two not-bugs

  - 11.7 signal-based resolver timeouts

  Not considered a bug anymore but just implementation details. People
  should avoid using timeouts with the synchronous name resolver.

  - 11.16 libcurl uses renames instead of locking for atomic operations

  Not a bug, just a description of how it works

  Closes #11032

Harry Sintonen (26 Apr 2023)

- hostip: add locks around use of global buffer for alarm()

  When building with the sync name resolver and timeout ability we now
  require thread-safety to be present to enable it.

  Closes #11030

Daniel Stenberg (26 Apr 2023)

- curl_path: bring back support for SFTP path ending in /~

  libcurl used to do a directory listing for this case (even though the
  documentation says a URL needs to end in a slash for this), but
  4e2b52b5f7a3 modified the behavior.

  This change brings back a directory listing for SFTP paths that are
  specified exactly as /~ in the URL.

  Reported-by: Pavel Mayorov
  Fixes #11001
  Closes #11023

Emanuele Torre (26 Apr 2023)

- docs/libcurl/curl_*escape.3: rename "url" argument to "input"/"string"

  Also reword the DESCRIPTION section to mention "input"/"string" argument
  in bold.

  Closes #11027

- docs/libcurl: minor cleanups

  I was reading curl_unescape(3) and I noticed that there was an extra
  space after the open parenthesis in the SYNOPSIS; I removed the extra
  space.

  I also ran a few  grep -r  commands to find and remove extra spaces
  after '(' in other files, and to find and replace uses of `T*' instead
  of `T *'. Some of the instances of `T*` where unnecessary casts that I
  removed.

  I also fixed a comment that was misaligned in CURLMOPT_SOCKETFUNCTION.3.

  And I fixed some formatting inconsistencies: in curl_unescape(3), all
  function parameter were mentioned with bold text except length, that was
  mentioned as 'length'; and, in curl_easy_unescape(3), all parameters
  were mentioned in bold text except url that was italicised. Now they are
  all mentioned in bold.
  Documentation is not very consistent in how function parameter are
  formatted: many pages italicise them, and others display them in bold
  text; but I think it makes sense to at least be consistent with
  formatting within the same page.

  Closes #11027

Daniel Stenberg (26 Apr 2023)

- man pages: simplify the .TH sections

  - remove the version numbers
  - simplify the texts

  The date and version number will be put there for releases when maketgz
  runs the updatemanpages.pl script.

  Closes #11029

- hostcheck: fix host name wildcard checking

  The leftmost "label" of the host name can now only match against single
  '*'. Like the browsers have worked for a long time.

  - extended unit test 1397 for this
  - move some SOURCE variables from unit/Makefile.am to unit/Makefile.inc

  Reported-by: Hiroki Kurosawa
  Closes #11018

Dan Fandrich (25 Apr 2023)

- smbserver: remove temporary files before exit

  Each execution of test 1451 would leave a file in /tmp before. Since
  Windows can't delete a file while it's open, all the temporary file
  names are stored and deleted on exit.

  Closes #10990

Stefan Eissing (25 Apr 2023)

- Websocket en-/decoding

  - state is fully kept at connection, since curl_ws_send() and
    curl_ws_rec() have lifetime beyond usual transfers
  - no more limit on frame sizes

  Reported-by: simplerobot on github
  Fixes #10962
  Closes #10999

Patrick Monnerat (25 Apr 2023)

- urldata: copy CURLOPT_AWS_SIGV4 value on handle duplication

  Prior to this change STRING_AWS_SIGV4 (CURLOPT_AWS_SIGV4) was wrongly
  marked as binary data that could not be duplicated.

  Without this fix, this option's value is not copied upon calling
  curl_easy_duphandle().

  Closes https://github.com/curl/curl/pull/11021

Stefan Eissing (25 Apr 2023)

- http3: expire unpaused transfers in all HTTP/3 backends

  Closes #11005

- http2: always EXPIRE_RUN_NOW unpaused http/2 transfers

  - just increasing the http/2 flow window does not necessarily
    make a server send new data. It may already have exhausted
    the window before

  Closes #11005

- http2: pass `stream` to http2_handle_stream_close to avoid NULL checks

  Closes #11005

- h2/h3: replace `state.drain` counter with `state.dselect_bits`

  - `drain` was used by http/2 and http/3 implementations to indicate
    that the transfer requires send/recv independant from its socket
    poll state. Intended as a counter, it was used as bool flag only.
  - a similar mechanism exists on `connectdata->cselect_bits` where
    specific protocols can indicate something similar, only for the
    whole connection.
  - `cselect_bits` are cleard in transfer.c on use and, importantly,
    also set when the transfer loop expended its `maxloops` tries.
    `drain` was not cleared by transfer and the http2/3 implementations
    had to take care of that.
  - `dselect_bits` is cleared *and* set by the transfer loop. http2/3
    does no longer clear it, only set when new events happen.

  This change unifies the handling of socket poll overrides, extending
  `cselect_bits` by a easy handle specific value and a common treatment in
  transfers.

  Closes #11005

Daniel Stenberg (25 Apr 2023)

- socketpair: verify with a random value

  ... instead of using the curl time struct, since it would use a few
  uninitialized bytes and the sanitizers would complain. This is a neater
  approach I think.

  Reported-by: Boris Kuschel
  Fixes #10993
  Closes #11015

Stefan Eissing (25 Apr 2023)

- HTTP3: document the ngtcp2/nghttp3 versions to use for building curl

  - refs #11011 to clarify this for people building curl themselves

  Closes #11019

Daniel Stenberg (25 Apr 2023)

- lib: unify the upload/method handling

  By making sure we set state.upload based on the set.method value and not
  independently as set.upload, we reduce confusion and mixup risks, both
  internally and externally.

  Closes #11017

- RELEASE-NOTES: synced

Dan Fandrich (24 Apr 2023)

- CI: don't run CI jobs if only another CI was changed

  A few paths were missed in the last commit, as well as a job added since
  then.

  Followup-to 395b9175

- CI: adjust labeler match patterns

- runtests: support buffering log messages in runner & servers

  Log messages generated with logmsg can now be buffered and returned from
  the runner as a return value.  This will be needed with parallel testing
  to allow all messages for one test to be displayed together instead of
  interspersed with messages of multiple tests. Buffering can be disabled
  by setting a logging callback function with setlogfunc, which is
  currently being done to preserve existing logging behaviour for now.

  Some additional output is generated in verbose and debugprotocol modes,
  which don't always use logmsg. These modes also impact some servers
  which generate extra messages. No attempt is made to buffer everything
  if these modes are enabled.

  Ref: #10818
  Closes #11016

- runtests: more consistently use logmsg in server control code

  Also, display an error when sshversioninfo returns one.

  Ref: #10818

- runtests: create runner functions for clearlocks and stopservers

  runtests.pl now uses runner for all server actions beyond the initial
  variable configuration.

  Ref: #10818

- runtests: tightened servers package exports

  The defaults are intended for runtests.pl, whereas runner.pm needs to
  explicitly specify them.

- runtests: display logs on server failure in singletest()

  This is closer to the place where logs are displayed on test failure.
  Also, only display these logs if -p is given, which is the same flag
  that controls display of test failure logs. Some server log files
  need to be deleted later so that they stay around long enough to be
  displayed on failure.

  Ref: #10818

- runtests: turn a print into a logmsg

  Also enable another couple of useful messages in verbose mode.

  Ref: #10818

Daniel Stenberg (24 Apr 2023)

- http: store the password in the correct variable

  Typo from fc2f1e547a4a, detected by Coverity (because there's dead code
  due to this).

  Closes #11002

Stefan Eissing (24 Apr 2023)

- HTTP3/quiche: terminate h1 response header when no body is sent

  - fixes a failure in test2501 where a response without body was missing
    the final empty line

  Closes #11003

Dan Fandrich (22 Apr 2023)

- runtests: move showdiff into runtests.pl

  It's not used anywhere else.

- devtest: add a new script for testing the test harness

  This is currently useful for starting a test server on its own without
  an associated test, which can be used for interactive curl testing or
  for validating parts of the test harness itself. More commands can be
  added to perform additional functions in the future.

  Ref: #10818
  Closes #11008

- runtests: refactor the main test loop into two

  The test loop now has an initial loop that first runs through all
  possible tests to build a set of those to attempt on this run based on
  features and keywords and only then goes through that new list to run
  them.  This actually makes it three loops through all tests cases, as
  there is an existing loop that gathers possible test numbers from the
  test files on disk.

  This has two minor effects on the output: all the tests that will be
  skipped are displayed at the start (instead of being interspersed with
  other tests) and the -l option no longer shows a count of tests at the
  end or a (misleading) statement that tests have run successfully. The
  skipped tests are also omitted from the test results sent to AppVeyor
  and Azure in CI builds.

  Another effect is a reduction in the amount of work considered part of
  the "Test definition reading and preparation time" reported with -r
  making those figures slightly lower than before.

  Ref: #10818

- runtests: track only the current test timings in runner.pm

  This avoids passing these data through through global variables, which
  soon won't be possible.

  Ref: #10818

- runtests: skip test preprocessing when doing -l

  This speeds up the output tremendously by avoiding unnecessary work.

- runtests: simplify value returned regarding use of valgrind

  As a side effect this will now also show in verbose mode that valgrind
  is being skipped on tests that explicitly disable it, such as 600.

  Ref: #10818

- runtests: fix quoting in Appveyor and Azure test integration

  Test 1442's name was not quoted correctly so wasn't registered in
  Appveyor and it had the wrong name in Azure. The JSON string quotes were
  also invalid, even though both servers happened to accept it regardless.

  Closes #11010

Daniel Stenberg (19 Apr 2023)

- RELEASE-NOTES: synced

Dan Fandrich (18 Apr 2023)

- runtests: spread out the port numbers used by servers

  The server ports are chosen randomly for each server, but the random
  ranges chosen were inconsistently-sized and overlapping. Now, they are
  spread out more so at least the first random port chosen for each server
  is guaranteed to not also be chosen by another server. The starting port
  numbers are also raised to put them in the Ephemeral Port range—not the
  range defined by RFC 6335 but the one used by Linux, which starts lower
  and gives us more room to work with.

  Reported-by: Daniel Stenberg

- runtests: fix problems on <killserver> failure

  The verify time must be set in this case, like all cases. An error
  message needs to be displayed as well.

- runtests: fix perl warning when <tool> is wrong

- runtests: don't try to stop stunnel before trying again

  Calling stopserver() before retrying stunnel due to an error would stop
  the dependent server (such as HTTP) meaning stunnel would have nothing
  to talk to when it came up. Don't try to force a stop when it didn't
  actually start.  Also, don't mark the server as bad for future use when
  it starts up on a retry.

  Reported-by: eaglegai at github
  Tested-by: eaglegai at github
  Fixes #10976

- runtests: don't accidentally randomly choose the same port

  If a server couldn't be started on a port, a new one is randomly chosen
  and the server is tried again. Avoid accidentally using a
  randomly-chosen 0 port offset by adding 1 to the random number.

  Found-by: Daniel Stenberg

- runtests: don't attempt to use a port we know is in use

  This reduces the startup time when there is a known conflict on the
  random port chosen for a server.  This was already done for stunnel, but
  now it's done for all servers.

- http-server: fix server name in a log message

  This changed when the file was renamed in commit cbf57176

- runtests: refactor into more packages

  testutil.pm now contains a few miscellaneous functions that are used in
  several places but have no better place to live.  subvariables moves to
  servers.pm since most variables that it substitutes relate to servers,
  so this is the most appropriate place. Rename a few functions for better
  naming consistency.

  Ref: #10818
  Closes #10995

- runtests: call timestampskippedevents() in singletest

  ..rather than by the runner

- runtests: assume a newer Valgrind by default

  The tests for an older Valgrind version should probably just be deleted,
  given that they're testing for an 18-year-old version.

- runtests: refactor test runner code into runner.pm

  This is code that is directly responsible for running a single test.
  This will eventually run in a separate process as part of the parallel
  testing project.

  Ref: #10818

- runtests: skip unneeded work if test won't be running

  This speeds up tests by avoiding unnecessary processing.

  Ref: #10818

- runtests: factor out singletest_postcheck

  This will eventually need to be part of the test runner.

  Ref: #10818

- test303: kill server after test

  Otherwise, an HTTP test closely following this one with a tight time
  constraint (e.g. 672) could fail because the test server stays sitting
  with the wait command for a while.

Patrick Monnerat (18 Apr 2023)

- OS400: provide ILE/RPG usage examples

  Closes https://github.com/curl/curl/pull/10994

- OS400: improve vararg emulation

  - Use V7R4 RPG procedure overloading to improve vararg emulation.

  From OS400 V7R4 and above, ILE/RPG implements a limited procedure
  overloading feature that can be used to improve curl's typed
  implementation of varargs procedures. This commit applies it to
  curl_easy_setopt(), curl_multi_setopt(), curl_share_setopt() and
  curl_easy_getinfo().

  Closes https://github.com/curl/curl/pull/10994

- OS400: fix and complete ILE/RPG binding

  - Fix wrong definitions of CURL_ZERO_TERNINATED, curl_mime_data() and
    curl_mime_data_ccsid().

  - Add recent definitions, in particular blob, header API and WebSockets
    API.

  - Support for CURLVERSION_ELEVENTH.

  - New functions for EBCDIC support.

  Reflect these changes in README.OS400.

  Closes https://github.com/curl/curl/pull/10994

- OS400: implement EBCDIC support for recent features

  - Support CURLVERSION_ELEVENTH.

  - New function curl_url_strerror_ccsid().

  - curl_easy_setopt_ccsid() supports blobs and 3 recent string options.

  - New function curl_easy_header_ccsid().

  - New generic latin1<-->ccsid conversion functions curl_from_ccsid() and
    curl_to_ccsid() for user convenience.

  - README.OS400 updated accordingly.

  - Removed a leftover QsoSSL support identifier.

  Closes https://github.com/curl/curl/pull/10994

- OS400: rework build scripts

  - Rename shell function "system" to "CLcommand" to avoid confusion with
    built-in command.

  - Reformat scripts. Fix some indentations. Avoid lines > 80 characters
    where possible.

  - Support ASCII runtime development files in a user-defined directory
    path.

  - FIX SONAME detection.

  - Drop form API test program compilation (does not exist anymore).

  Closes https://github.com/curl/curl/pull/10994

Sevan Janiyan (18 Apr 2023)

- tests/sshserver.pl: Define AddressFamily earlier

  As the comment states "Address family must be specified before ListenAddress"
  , otherwise the tests fail to run
  `"failed starting SSH server" 52 times (582, 583, 600, 601, 602, 603, 604, 60
  5, 606 and 43 more)`

  Closes #10983

Stefan Eissing (18 Apr 2023)

- quiche: Enable IDLE egress handling

  Follow-up to 544abeea which added the handling but wrongly left it
  commented out.

  Closes https://github.com/curl/curl/pull/11000

Daniel Stenberg (18 Apr 2023)

- docs/examples/protofeats.c: Outputs all protocols and features

  Showing off one way to get to char pointer arrays of info returned by
  curl_version_info()

  Closes #10991

- tests/keywords.pl: remove

  This script does not work since the introduction of the test
  preprocessing. If we need this functionality, it probably needs to be
  moved into the runtests tool or similar.

  Reported-by: Dan Fandrich
  Fixes #10895
  Closes #10987

Stefan Eissing (17 Apr 2023)

- http2: support HTTP/2 to forward proxies, non-tunneling

  - with `--proxy-http2` allow h2 ALPN negotiation to
    forward proxies
  - applies to http: requests against a https: proxy only,
    as https: requests will auto-tunnel
  - adding a HTTP/1 request parser in http1.c
  - removed h2h3.c
  - using new request parser in nghttp2 and all h3 backends
  - adding test 2603 for request parser
  - adding h2 proxy test cases to test_10_*

  scorecard.py: request scoring accidentally always run curl
  with '-v'. Removed that, expect double numbers.

  labeller: added http1.* and h2-proxy sources to detection

  Closes #10967

Daniel Stenberg (17 Apr 2023)

- curl_easy_unescape.3: rename the argument

  and highlight it appropriately in the text.

  Closes #10979

Viktor Szakats (17 Apr 2023)

- autotools: sync up clang picky warnings with cmake

  Bringing missing options over from CMake.

  Move around existing `-Wno-pointer-bool-conversion` option to come
  _after_ `-Wconversion`.

  Reviewed-by: Marcel Raad
  Closes #10974

Daniel Stenberg (17 Apr 2023)

- tests/libtest/lib1900.c: remove

  This file was left behind when the rest of the test was previously removed.

  Follow-up to e50a877df74f

- src/tool_operhlp.c: fix value stored to 'uerr' is never read

  Ref: https://github.com/curl/curl/pull/10974#issuecomment-1510461343
  Reported-by: Viktor Szakats
  Closes #10982

Viktor Szakats (16 Apr 2023)

- cmake: speed up and extend picky clang/gcc options

  Extend existing picky compiler options with ones missing compared to
  autotools builds. Also sync options between clang and gcc.

  Redesign the way we enable these options to avoid the slow option
  detection almost completely.

  This reduces the number of detections from 35 to zero for clang and
  3 for gcc, even after adding a bunch of new options.

  clang 3.0 (2011-11-29) and gcc 2.95 (1999-07-31) now required.

  Also show enabled picky options.

  Ref: https://github.com/libssh2/libssh2/pull/952

  Reviewed-by: Daniel Stenberg
  Closes #10973

Andreas Falkenhahn (16 Apr 2023)

- nbtlm: use semicolons instead of commas for (void) args

  Closes #10978

Daniel Stenberg (15 Apr 2023)

- multi: free up more data earleier in DONE

  Before checking for more users of the connection and possibly bailing
  out.

  Fixes #10971
  Reported-by: Paweł Wegner
  Closes #10972

- RELEASE-NOTES: synced

- curl: do NOT append file name to path for upload when there's a query

  Added test 425 to verify.

  Reported-by: Dirk Rosenkranz
  Bug: https://curl.se/mail/archive-2023-04/0008.html
  Closes #10969

- libcurl-thread.3: improved name resolver wording

  And make better .SH sections

  Closes #10966

Colman Mbuya (14 Apr 2023)

- CURLOPT_PROXY_SSL_VERIFYPEER.3: fix minor grammar mistake

  Closes #10968

Daniel Stenberg (14 Apr 2023)

- curl: add --proxy-http2

  For trying HTTP/2 with an HTTPS proxy.

  Closes #10926

- KNOWN_BUGS: remove fixed or outdated issues, move non-bugs

  - remove h3 issues believed to be fixed

  - make the flaky CI issue be generic and not Windows specific

  - "TLS session cache does not work with TFO" now documented

    This is now a documented restriction and not a bug. TFO in general is
    rarely used and has other problems, making it a low-priotity thing to
    work on.

  - remove "Renegotiate from server may cause hang for OpenSSL backend"

    This is an OpenSSL issue, not a curl one. Even if it taints curl.

  - rm "make distclean loops forever"

  - rm "configure finding libs in wrong directory"

    Added a section to docs/INSTALL.md about it.

  - "A shared connection cache is not thread-safe"

    Moved over to TODO and expanded for other sharing improvements we
    could do

  - rm "CURLOPT_OPENSOCKETPAIRFUNCTION is missing"

  - rm "Blocking socket operations in non-blocking API"

    Already listed as a TODO

  - rm "curl compiled on OSX 10.13 failed to run on OSX 10.10"

    Water under the bridge. No one cares about this anymore.

  - rm "build on Linux links libcurl to libdl"

    Verified to not be true (anymore).

  - rm "libpsl is not supported"

    The cmake build supports it since cafb356e19cda22

  Closes #10963

- url: fix PVS nits

  - expression 'hostptr' is always true
  - a part of conditional expression is always true: proxypasswd
  - expression 'proxyuser' is always true
  - avoid multiple Curl_now() calls in allocate_conn

  Ref: #10929
  Closes #10959

- bufq: simplify since expression is always true

  The check for 'len' is already done so it will remain true until
  updated. Pointed out by PVS.

  Ref: #10929
  Closes #10958

- hash: fix assigning same value

  Pointed out by PVS

  Ref: #10929
  Closes #10956

- cookie: address PVS nits

  - avoid assigning the same value again
  - remove superfluous check of co->domain
  - reduce variable scope for namep/valuep

  Ref: #10929
  Closes #10954

Stefan Eissing (14 Apr 2023)

- cf-socket: Disable socket receive buffer by default

  - Disable socket receive buffer unless USE_RECV_BEFORE_SEND_WORKAROUND
    is in place.

  While we would like to use the receive buffer, we have stalls in
  parallel transfers where not all buffered data is consumed and no socket
  events happen.

  Note USE_RECV_BEFORE_SEND_WORKAROUND is a Windows sockets workaround
  that has been disabled by default since b4b6e4f1, due to other bugs.

  Closes https://github.com/curl/curl/pull/10961

- cf-h2-proxy: fix processing ingress to stop too early

  - progress ingress stopped too early, causing data
    from the underlying filters to not be processed and
    report that no tunnel data was available
  - this lead to "hangers" where no socket activity was
    seen but data rested in buffers

  Closes #10952

- http3: check stream_ctx more thoroughly in all backends

  - callbacks and filter methods might be invoked at unexpected
    times, e.g. when the transfer's stream_ctx has not been initialized
    yet or, more likely, has already been taken down.
  - check for existance of stream_ctx in such places and return
    an error or silently succeed the call.

  Closes #10951

Daniel Stenberg (13 Apr 2023)

- ftp: fix 'portsock' variable was assigned the same value

  Pointed out by PVS

  Ref: #10929
  Closes #10955

- ftp: remove dead code

  This condition can never be true here since it is handled already 28
  lines above.

  Pointed out by PVS.

  Ref: #10929
  Closes #10957

- cf-h1-proxy: skip an extra NULL assign

  and use Curl_safefree() once to save another NULL assign. Found by PVS.

  Ref. #10929
  Closes #10953

Philip Heiduck (13 Apr 2023)

- GHA: suppress git clone output

  Follow-up: https://github.com/curl/curl/commit/8203aa6ed405ec832d2c62f18dfda2
  93f89a23f9

  Closes #10949

Stefan Eissing (13 Apr 2023)

- cf-socket: remove dead code discovered by PVS

  Closes #10960

Daniel Stenberg (13 Apr 2023)

- http: skip a double NULL assign

  and also use a local variable to shorten the long names and increase
  readability in the function. Pointed out by PVS.

  Ref: #10929
  Closes #10950

- mime: skip NULL assigns after Curl_safefree()

  Pointed out by PVS.

  Ref: #10929
  Closes #10947

- rtsp: skip NULL assigns after Curl_safefree()

  ... since this is a macro that assigns NULL itself. Pointed out by PVS.

  Ref: #10929
  Closes #10946

- smb: remove double assign

  The same value is assigned the same value already a few lines above.
  Pointed out by PVS.

  Ref: #10929
  Closes #10945

- transfer: skip extra assign

  The 'result' variable already contains CURLE_OK at this point, no use in
  setting it again. Pointed out by PVS.

  Ref: #10929
  Closes #10944

- urlapi: skip a pointless assign

  It stores a null byte after already having confirmed there is a null
  byte there. Detected by PVS.

  Ref: #10929
  Closes #10943

Philip Heiduck (13 Apr 2023)

- GHA: suppress git clone output

  Closes #10939

Stefan Eissing (13 Apr 2023)

- tests: make test_12_01 a bit more forgiving on connection counts

- cf-socket: add socket recv buffering for most tcp cases

  - use bufq as recv buffer, also for Windows pre-receive handling
  - catch small reads followed by larger ones in a single socket
    call. A common pattern on TLS connections.

  Closes #10787

Daniel Stenberg (13 Apr 2023)

- urlapi: cleanups

  - move host checks together
  - simplify the scheme parser loop and the end of host name parser
  - avoid itermediate buffer storing in multiple places
  - reduce scope for several variables
  - skip the Curl_dyn_tail() call for speed
  - detect IPv6 earlier and skip extra checks for such hosts
  - normalize directly in dynbuf instead of itermediate buffer
  - split out the IPv6 parser into its own funciton
  - call the IPv6 parser directly for ipv6 addresses
  - remove (unused) special treatment of % in host names
  - junkscan() once in the beginning instead of scattered
  - make junkscan return error code
  - remove unused query management from dedotdotify()
  - make Curl_parse_login_details use memchr
  - more use of memchr() instead of strchr() and less strlen() calls
  - make junkscan check and return the URL length

  An optimized build runs one of my benchmark URL parsing programs ~41%
  faster using this branch. (compared against the shipped 7.88.1 library
  in Debian)

  Closes #10935

Josh McCullough (13 Apr 2023)

- http2: fix typo in infof() call

  Closes #10940

Daniel Stenberg (12 Apr 2023)

- noproxy: pointer to local array 'hostip' is stored outside scope

  Ref: #10929
  Closes #10933

Stefan Eissing (12 Apr 2023)

- connect: fix https connection setup to treat ssl_mode correctly

  - for HTTPS protocol, a disabled ssl should never be acceptables.

  Closes #10934

Douglas R. Reno (12 Apr 2023)

- CMakeLists.txt: fix typo for Haiku detection

  Closes #10937

Dan Fandrich (11 Apr 2023)

- pathhelp: use the cached $use_cygpath when available

- runtests: eliminate unneeded variable

- runtests: make the # of server start attempts a constant

- runtests: on startup failure call displaylogs only in serverfortest

  This reduces the number of calls spread throughout the code.

  Ref: #10818
  Closes #10919

- runtests: return an error code with startservers()

  The code indicates the kind of failure encountered in starting a server,
  which can be used by the caller to tailor the user experience.

  Ref: #10818

- runtests: abort early if runpingpongserver is given a bad server type

- runtests: don't use the SMB server verification time as reference

  %FTPTIME2 and %FTPTIME3 should be set by the FTP server only, for
  consistency.

- tests: factor out the test server management code

  This now lives in servers.pm with some configuration variables moved to
  globalconfig.pm

  Ref: #10818

- runtests: remove an inappropriate use of runclientoutput

  This function is intended for running client code, not servers.

- runtests: only add $LIBDIR to the path for checktestcmd

  Since checkcmd is for finding servers, there will never be anything in
  this directory of interest to them.

  Ref: #10818

- tests: log sshserver.pl messages to a file

  The logmsg messages were thrown away before, so they are now available
  for debugging.

- runtests: also show DISABLED tests with -l

  Other reasons for skipping tests are ignored for -l, so being explicitly
  disabled should be too.

- runtests: move the UNIX sockets into $PIDDIR

  These were missed when the other server files were moved there.

  Follow-up to 70d2fca2

  Ref: #10818

- tests: tighten up perl exports

  This reduces namespace pollution a little.

  Ref: #10818

- tests: turn perl modules into full packages

  This helps enforce more modularization and encapsulation. Enable and fix
  warnings on a few packages.  Also, rename ftp.pm to processhelp.pm since
  there's really nothing ftp-specific in it.

  Ref: #10818

Daniel Stenberg (11 Apr 2023)

- multi: remove a few superfluous assigns

  PVS found these "The 'rc' variable was assigned the same value." cases.

  Ref: #10929
  Closes #10932

- schannel: add clarifying comment

  Explaining how the PVS warning in #10929 is wrong: Dereferencing of the
  null pointer 'backend->cred' might take place.

  Closes #10931

- cookie: clarify that init with data set to NULL reads no file

  ... and make Curl_cookie_add() require 'data' being set proper with an
  assert.

  The function has not worked with a NULL data for quite some time so this
  just corrects the code and comment.

  This is a different take than the proposed fixed in #10927

  Reported-by: Kvarec Lezki
  Ref: #10929
  Closes #10930

Kvarec Lezki (11 Apr 2023)

- vtls: remove int typecast for sizeof()

  V220 Suspicious sequence of types castings: memsize -> 32-bit integer ->
  memsize. The value being cast: 'sizeof
  (buf->data)'. curl\lib\vtls\vtls.c 2025

  https://pvs-studio.com/en/docs/warnings/v220/

  Closes #10928

Stefan Eissing (11 Apr 2023)

- http2: fix copynpaste error reported by coverity

  - move all code handling HTTP/2 frames for a particular
    stream into a separate function to keep from confusing
    the call `data` with the stream `data`.

  Closes #10924

Dan Fandrich (11 Apr 2023)

- tests: log a too-long Unix socket path in sws and socksd

  Ref: #10919

Daniel Stenberg (11 Apr 2023)

- gen.pl: error on duplicated See-Also fields

  Updated http2.d accordingly.

  Closes #10925

- http2: avoid possible null pointer dereference

  Reported-by: Dan Fandrich
  Fixes #10920
  Closes #10923

- lib1560: verify that more bad host names are rejected

  when setting the hostname component of a URL

  Closes #10922

- curl_url_set.3: mention that users can set content rather freely

  ... which then might render bad URLs if you extract a URL later.

  Closes #10921

Dan Fandrich (10 Apr 2023)

- CI: retry failed downloads of aws-lc

  Don't fail the build in case of a temporary server problem.

- test1169: fix so it works properly everywhere

  - Use an absolute path for the -L option since the module isn't in the
    perl path
  - Create the needed test file in a <file> section; <precheck> isn't
    intended for this
  - Fix the test number in the file name, which was wrong

  Follow-up to f754990a

  Ref: #10818
  Fixes #10889
  Closes #10917

- tests: stop using strndup(), which isn't portable

  It's not available on Solaris 10, for example. Since this is just test
  code that doesn't need to use an optimized system version, replace it
  with the implementation copied from tool_cb_hdr.c.

- runtests: fix an incorrect comment about the ld_preload feature

  Follow-up to 1f631864

  Ref: #10818

Daniel Stenberg (9 Apr 2023)

- urlapi: prevent setting invalid schemes with *url_set()

  A typical mistake would be to try to set "https://" - including the
  separator - this is now rejected as that would then lead to
  url_get(... URL...) would get an invalid URL extracted.

  Extended test 1560 to verify.

  Closes #10911

Biswapriyo Nath (9 Apr 2023)

- http2: remove unused Curl_http2_strerror function declaration

  Curl_http2_strerror was renamed to http2_strerror in
  05b100aee247bb9bec8e9a1b0 and then http2_strerror was removed in
  5808a0d0f5ea0399d4a2a2

  This also fixes the following compiler error

  lib/http2.h:41:33: error: unknown type name 'uint32_t'
  lib/http2.h:1:1: note: 'uint32_t' is defined in header '<stdint.h>'

  Closes #10912

Daniel Stenberg (8 Apr 2023)

- RELEASE-NOTES: synced

SuperIlu on github (8 Apr 2023)

- config-dos.h: fix SIZEOF_CURL_OFF_T for MS-DOS/DJGPP

  Fixes #10905
  Closes #10910

Daniel Stenberg (8 Apr 2023)

- lib: remove CURLX_NO_MEMORY_CALLBACKS

  The only user of this define was 'chkdecimalpoint' - a special purpose
  test tool that was built but not used anymore (since 17c18fbc3 - Apr
  2020).

  Closes #10908

- CURLPROXY_HTTPS2: for HTTPS proxy that may speak HTTP/2

  Setting this proxy type allows curl to negotiate and use HTTP/2 with
  HTTPS proxies.

  Closes #10900

Ali Khodkar (8 Apr 2023)

- write-out.d: add missing periods

  Closes #10897

Daniel Stenberg (7 Apr 2023)

- http2: remove check for !data after it was already dereferenced

  Pointed out by Coverity

  Closes #10906
